/*===========================================================================*/
/*   (Ast/shrinkify.scm)                                                     */
/*   Bigloo (2.6a)                                                           */
/*   Inria -- Sophia Antipolis (c)       Thu Jul 10 14:28:09 CEST 2003       */
/*===========================================================================*/
/* COMPILATION: (/users/serrano/prgm/project/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc-2.96 -lib-dir /users/serrano/prgm/project/bigloo/lib/2.6a -unsafev -no-hello -O2 -rm -unsafe -s -indent Ast/shrinkify.scm)*/
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>


/* Object type definitions */
typedef struct BgL_typez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   obj_t BgL_siza7eza7;
   obj_t BgL_classz00;
   obj_t BgL_coercezd2tozd2;
   obj_t BgL_parentsz00;
   bool_t BgL_initzf3zf3;
   bool_t BgL_magiczf3zf3;
   obj_t BgL_z42z42;
   obj_t BgL_aliasz00;
   obj_t BgL_pointedzd2tozd2byz00;
   obj_t BgL_tvectorz00;
   obj_t BgL_locationz00;
   obj_t BgL_importzd2locationzd2;
} *BgL_typez00_bglt;

typedef struct BgL_valuez00_bgl {
   header_t header;
   obj_t widening;
} *BgL_valuez00_bglt;

typedef struct BgL_variablez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_valuez00_bgl * BgL_valuez00;
   obj_t BgL_accessz00;
   obj_t BgL_fastzd2alphazd2;
   obj_t BgL_removablez00;
   long BgL_occurrencez00;
} *BgL_variablez00_bglt;

typedef struct BgL_globalz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_valuez00_bgl * BgL_valuez00;
   obj_t BgL_accessz00;
   obj_t BgL_fastzd2alphazd2;
   obj_t BgL_removablez00;
   long BgL_occurrencez00;
   obj_t BgL_modulez00;
   obj_t BgL_importz00;
   bool_t BgL_evaluablezf3zf3;
   bool_t BgL_libraryzf3zf3;
   bool_t BgL_userzf3zf3;
   obj_t BgL_pragmaz00;
   obj_t BgL_srcz00;
   obj_t BgL_jvmzd2typezd2namez00;
} *BgL_globalz00_bglt;

typedef struct BgL_localz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_namez00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_valuez00_bgl * BgL_valuez00;
   obj_t BgL_accessz00;
   obj_t BgL_fastzd2alphazd2;
   obj_t BgL_removablez00;
   long BgL_occurrencez00;
   bool_t BgL_userzf3zf3;
   long BgL_keyz00;
} *BgL_localz00_bglt;

typedef struct BgL_funz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_arityz00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_predicatezd2ofzd2;
   obj_t BgL_stackzd2allocatorzd2;
   bool_t BgL_topzf3zf3;
   obj_t BgL_thezd2closurezd2;
} *BgL_funz00_bglt;

typedef struct BgL_sfunz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_arityz00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_predicatezd2ofzd2;
   obj_t BgL_stackzd2allocatorzd2;
   bool_t BgL_topzf3zf3;
   obj_t BgL_thezd2closurezd2;
   obj_t BgL_propertyz00;
   obj_t BgL_argsz00;
   obj_t BgL_bodyz00;
   obj_t BgL_classz00;
   obj_t BgL_dssslzd2keywordszd2;
   obj_t BgL_locz00;
} *BgL_sfunz00_bglt;

typedef struct BgL_cfunz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_arityz00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_predicatezd2ofzd2;
   obj_t BgL_stackzd2allocatorzd2;
   bool_t BgL_topzf3zf3;
   obj_t BgL_thezd2closurezd2;
   obj_t BgL_argszd2typezd2;
   bool_t BgL_macrozf3zf3;
   bool_t BgL_infixzf3zf3;
   obj_t BgL_methodz00;
} *BgL_cfunz00_bglt;

typedef struct BgL_svarz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
} *BgL_svarz00_bglt;

typedef struct BgL_scnstz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_nodez00;
   obj_t BgL_classz00;
   obj_t BgL_locz00;
} *BgL_scnstz00_bglt;

typedef struct BgL_cvarz00_bgl {
   header_t header;
   obj_t widening;
   bool_t BgL_macrozf3zf3;
} *BgL_cvarz00_bglt;

typedef struct BgL_sexitz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_handlerz00;
   bool_t BgL_detachedzf3zf3;
} *BgL_sexitz00_bglt;

typedef struct BgL_nodez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
} *BgL_nodez00_bglt;

typedef struct BgL_nodezf2effectzf2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
} *BgL_nodezf2effectzf2_bglt;

typedef struct BgL_atomz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_valuez00;
} *BgL_atomz00_bglt;

typedef struct BgL_varz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_variablez00_bgl * BgL_variablez00;
} *BgL_varz00_bglt;

typedef struct BgL_closurez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_variablez00_bgl * BgL_variablez00;
} *BgL_closurez00_bglt;

typedef struct BgL_kwotez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_valuez00;
} *BgL_kwotez00_bglt;

typedef struct BgL_sequencez00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_nodesz00;
} *BgL_sequencez00_bglt;

typedef struct BgL_appz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_varz00_bgl * BgL_funz00;
   obj_t BgL_argsz00;
} *BgL_appz00_bglt;

typedef struct BgL_appzd2lyzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_funz00;
   struct BgL_nodez00_bgl * BgL_argz00;
} *BgL_appzd2lyzd2_bglt;

typedef struct BgL_funcallz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_funz00;
   obj_t BgL_argsz00;
   obj_t BgL_strengthz00;
} *BgL_funcallz00_bglt;

typedef struct BgL_externz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
} *BgL_externz00_bglt;

typedef struct BgL_pragmaz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_formatz00;
} *BgL_pragmaz00_bglt;

typedef struct BgL_getfieldz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_fnamez00;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
} *BgL_getfieldz00_bglt;

typedef struct BgL_setfieldz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_fnamez00;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
} *BgL_setfieldz00_bglt;

typedef struct BgL_newz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
} *BgL_newz00_bglt;

typedef struct BgL_vallocz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_czd2heapzd2formatz00;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
} *BgL_vallocz00_bglt;

typedef struct BgL_vrefz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_czd2formatzd2;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
   struct BgL_typez00_bgl * BgL_vtypez00;
} *BgL_vrefz00_bglt;

typedef struct BgL_vsetz12z12_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_czd2formatzd2;
   struct BgL_typez00_bgl * BgL_ftypez00;
   struct BgL_typez00_bgl * BgL_otypez00;
   struct BgL_typez00_bgl * BgL_vtypez00;
} *BgL_vsetz12z12_bglt;

typedef struct BgL_vlengthz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   obj_t BgL_czd2formatzd2;
   struct BgL_typez00_bgl * BgL_vtypez00;
} *BgL_vlengthz00_bglt;

typedef struct BgL_isaz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_exprza2za2;
   struct BgL_typez00_bgl * BgL_classz00;
} *BgL_isaz00_bglt;

typedef struct BgL_castz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_argz00;
} *BgL_castz00_bglt;

typedef struct BgL_setqz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_varz00_bgl * BgL_varz00;
   struct BgL_nodez00_bgl * BgL_valuez00;
} *BgL_setqz00_bglt;

typedef struct BgL_conditionalz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_nodez00_bgl * BgL_testz00;
   struct BgL_nodez00_bgl * BgL_truez00;
   struct BgL_nodez00_bgl * BgL_falsez00;
} *BgL_conditionalz00_bglt;

typedef struct BgL_failz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_procz00;
   struct BgL_nodez00_bgl * BgL_msgz00;
   struct BgL_nodez00_bgl * BgL_objz00;
} *BgL_failz00_bglt;

typedef struct BgL_selectz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_nodez00_bgl * BgL_testz00;
   obj_t BgL_clausesz00;
   struct BgL_typez00_bgl * BgL_itemzd2typezd2;
} *BgL_selectz00_bglt;

typedef struct BgL_letzd2funzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_localsz00;
   struct BgL_nodez00_bgl * BgL_bodyz00;
} *BgL_letzd2funzd2_bglt;

typedef struct BgL_letzd2varzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   obj_t BgL_bindingsz00;
   struct BgL_nodez00_bgl * BgL_bodyz00;
   bool_t BgL_removablezf3zf3;
} *BgL_letzd2varzd2_bglt;

typedef struct BgL_setzd2exzd2itz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_varz00_bgl * BgL_varz00;
   struct BgL_nodez00_bgl * BgL_bodyz00;
} *BgL_setzd2exzd2itz00_bglt;

typedef struct BgL_jumpzd2exzd2itz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_nodez00_bgl * BgL_exitz00;
   struct BgL_nodez00_bgl * BgL_valuez00;
} *BgL_jumpzd2exzd2itz00_bglt;

typedef struct BgL_makezd2boxzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_nodez00_bgl * BgL_valuez00;
} *BgL_makezd2boxzd2_bglt;

typedef struct BgL_boxzd2refzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   obj_t BgL_sidezd2effectzf3z21;
   obj_t BgL_keyz00;
   struct BgL_varz00_bgl * BgL_varz00;
} *BgL_boxzd2refzd2_bglt;

typedef struct BgL_boxzd2setz12zc0_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_typez00_bgl * BgL_typez00;
   struct BgL_varz00_bgl * BgL_varz00;
   struct BgL_nodez00_bgl * BgL_valuez00;
} *BgL_boxzd2setz12zc0_bglt;


static obj_t BGl_methodzd2initzd2zzast_shrinkifyz00();
BGL_IMPORT obj_t open_input_string(obj_t);
static obj_t BGl_shrinkzd2nodez12zd2select2715z12zzast_shrinkifyz00(obj_t, obj_t);
static obj_t BGl_shrinkzd2nodez12zd2letzd2fun2723zc0zzast_shrinkifyz00(obj_t, obj_t);
BGL_IMPORT long BGl_classzd2numzd2zz__objectz00(obj_t);
extern obj_t BGl_letzd2funzd2zzast_nodez00;
static obj_t BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(BgL_nodez00_bglt);
static obj_t BGl_shrinkzd2variablez12zc0zzast_shrinkifyz00(BgL_variablez00_bglt);
BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t);
static obj_t BGl_shrinkzd2nodez12zd2default2688z12zzast_shrinkifyz00(BgL_nodez00_bglt);
BGL_IMPORT obj_t BGl_addzd2genericz12zc0zz__objectz00(obj_t, obj_t);
static obj_t BGl_shrinkzd2nodez12zd2letzd2var2725zc0zzast_shrinkifyz00(obj_t, obj_t);
extern obj_t BGl_letzd2varzd2zzast_nodez00;
static obj_t BGl_shrinkzd2nodez12zd2sequence2697z12zzast_shrinkifyz00(obj_t, obj_t);
extern obj_t BGl_kwotez00zzast_nodez00;
static obj_t BGl_shrinkzd2nodez12zd2var2693z12zzast_shrinkifyz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_za2classesza2z00zz__objectz00;
static obj_t BGl_shrinkzd2nodez12zd2setq2709z12zzast_shrinkifyz00(obj_t, obj_t);
extern obj_t BGl_castz00zzast_nodez00;
extern obj_t BGl_boxzd2refzd2zzast_nodez00;
extern obj_t BGl_varz00zzast_nodez00;
static obj_t BGl_cnstzd2initzd2zzast_shrinkifyz00();
extern obj_t BGl_atomz00zzast_nodez00;
extern obj_t BGl_failz00zzast_nodez00;
extern obj_t BGl_funcallz00zzast_nodez00;
static obj_t BGl_importedzd2moduleszd2initz00zzast_shrinkifyz00();
BGL_EXPORTED_DECL obj_t BGl_shrinkifyz12z12zzast_shrinkifyz00(obj_t);
extern obj_t BGl_makezd2boxzd2zzast_nodez00;
static obj_t BGl_shrinkzd2nodez12zd2atom2691z12zzast_shrinkifyz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_addzd2methodz12zc0zz__objectz00(obj_t, obj_t, obj_t);
static obj_t BGl__shrinkzd2nodez12zd2default2688z12zzast_shrinkifyz00(obj_t, obj_t);
extern obj_t BGl_selectz00zzast_nodez00;
static obj_t BGl_shrinkzd2nodez12zd2extern2705z12zzast_shrinkifyz00(obj_t, obj_t);
static obj_t BGl_toplevelzd2initzd2zzast_shrinkifyz00();
extern obj_t BGl_appzd2lyzd2zzast_nodez00;
static obj_t BGl_shrinkzd2nodez12zd2appzd2ly2701zc0zzast_shrinkifyz00(obj_t, obj_t);
extern obj_t BGl_boxzd2setz12zc0zzast_nodez00;
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zzast_shrinkifyz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzast_envz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
static obj_t BGl_shrinkzd2nodez12zd2boxzd2ref2719zc0zzast_shrinkifyz00(obj_t, obj_t);
static obj_t BGl_shrinkzd2variablez12zd2default2684z12zzast_shrinkifyz00(BgL_variablez00_bglt);
static obj_t BGl_shrinkzd2nodez12zd2makezd2box2717zc0zzast_shrinkifyz00(obj_t, obj_t);
static obj_t BGl__shrinkzd2nodez123706zc0zzast_shrinkifyz00(obj_t, obj_t);
static obj_t BGl_shrinkzd2nodez12zd2jumpzd2exzd2it2729z12zzast_shrinkifyz00(obj_t, obj_t);
extern obj_t BGl_setzd2exzd2itz00zzast_nodez00;
static obj_t BGl_shrinkzd2nodez12zd2fail2713z12zzast_shrinkifyz00(obj_t, obj_t);
static obj_t BGl__shrinkifyz12z12zzast_shrinkifyz00(obj_t, obj_t);
static obj_t BGl_shrinkzd2nodez12zd2app2699z12zzast_shrinkifyz00(obj_t, obj_t);
extern obj_t BGl_forzd2eachzd2globalz12z12zzast_envz00(obj_t);
extern obj_t BGl_jumpzd2exzd2itz00zzast_nodez00;
static obj_t BGl__shrinkzd2variablez12zd2default2684z12zzast_shrinkifyz00(obj_t, obj_t);
extern obj_t BGl_externz00zzast_nodez00;
extern obj_t BGl_conditionalz00zzast_nodez00;
extern obj_t BGl_sequencez00zzast_nodez00;
extern obj_t BGl_appz00zzast_nodez00;
static obj_t BGl_shrinkzd2nodez12zd2conditional2711z12zzast_shrinkifyz00(obj_t, obj_t);
static bool_t BGl_shrinkzd2nodeza2z12z62zzast_shrinkifyz00(obj_t);
static obj_t BGl_shrinkzd2nodez12zd2kwote2695z12zzast_shrinkifyz00(obj_t, obj_t);
static obj_t BGl_requirezd2initializa7ationz75zzast_shrinkifyz00 = BUNSPEC;
static obj_t BGl_shrinkzd2nodez12zd2funcall2703z12zzast_shrinkifyz00(obj_t, obj_t);
static obj_t BGl_shrinkzd2nodez12zd2boxzd2setz122721zd2zzast_shrinkifyz00(obj_t, obj_t);
static obj_t BGl__shrinkzd2variablez123704zc0zzast_shrinkifyz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_classzd2superzd2zz__objectz00(obj_t);
static obj_t BGl_shrinkzd2nodez12zd2cast2707z12zzast_shrinkifyz00(obj_t, obj_t);
static obj_t BGl_libraryzd2moduleszd2initz00zzast_shrinkifyz00();
static obj_t BGl_shrinkzd2nodez12zd2setzd2exzd2it2727z12zzast_shrinkifyz00(obj_t, obj_t);
extern obj_t BGl_setqz00zzast_nodez00;
static obj_t __cnst[ 1 ] ;


DEFINE_STATIC_GENERIC( BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, BgL_bgl__shrinkza7d2nodeza7123706za7c0za7za7ast_shrinkifyza7004300z00, BGl__shrinkzd2nodez123706zc0zzast_shrinkifyz00, 0L, 1 );
DEFINE_STATIC_PROCEDURE( BGl_proc4253z00zzast_shrinkifyz00, BgL_bgl_shrinkza7d2nodeza712za7d2atom2691za712za7za7ast_shrinkifyza7004301za7, BGl_shrinkzd2nodez12zd2atom2691z12zzast_shrinkifyz00, 0L, 1 );
DEFINE_STATIC_PROCEDURE( BGl_proc4254z00zzast_shrinkifyz00, BgL_bgl_shrinkza7d2nodeza712za7d2var2693za712za7za7ast_shrinkifyza7004302za7, BGl_shrinkzd2nodez12zd2var2693z12zzast_shrinkifyz00, 0L, 1 );
DEFINE_STATIC_PROCEDURE( BGl_proc4255z00zzast_shrinkifyz00, BgL_bgl_shrinkza7d2nodeza712za7d2kwote2695za712za7za7ast_shrinkifyza7004303za7, BGl_shrinkzd2nodez12zd2kwote2695z12zzast_shrinkifyz00, 0L, 1 );
DEFINE_STATIC_PROCEDURE( BGl_proc4256z00zzast_shrinkifyz00, BgL_bgl_shrinkza7d2nodeza712za7d2sequence2697za712za7za7ast_shrinkifyza7004304za7, BGl_shrinkzd2nodez12zd2sequence2697z12zzast_shrinkifyz00, 0L, 1 );
DEFINE_STATIC_PROCEDURE( BGl_proc4257z00zzast_shrinkifyz00, BgL_bgl_shrinkza7d2nodeza712za7d2app2699za712za7za7ast_shrinkifyza7004305za7, BGl_shrinkzd2nodez12zd2app2699z12zzast_shrinkifyz00, 0L, 1 );
DEFINE_STATIC_PROCEDURE( BGl_proc4258z00zzast_shrinkifyz00, BgL_bgl_shrinkza7d2nodeza712za7d2appza7d2ly2701za7c0za7za7ast_shrinkifyza7004306z00, BGl_shrinkzd2nodez12zd2appzd2ly2701zc0zzast_shrinkifyz00, 0L, 1 );
DEFINE_STATIC_PROCEDURE( BGl_proc4260z00zzast_shrinkifyz00, BgL_bgl_shrinkza7d2nodeza712za7d2extern2705za712za7za7ast_shrinkifyza7004307za7, BGl_shrinkzd2nodez12zd2extern2705z12zzast_shrinkifyz00, 0L, 1 );
DEFINE_STATIC_PROCEDURE( BGl_proc4259z00zzast_shrinkifyz00, BgL_bgl_shrinkza7d2nodeza712za7d2funcall2703za712za7za7ast_shrinkifyza7004308za7, BGl_shrinkzd2nodez12zd2funcall2703z12zzast_shrinkifyz00, 0L, 1 );
DEFINE_STATIC_PROCEDURE( BGl_proc4261z00zzast_shrinkifyz00, BgL_bgl_shrinkza7d2nodeza712za7d2cast2707za712za7za7ast_shrinkifyza7004309za7, BGl_shrinkzd2nodez12zd2cast2707z12zzast_shrinkifyz00, 0L, 1 );
DEFINE_STATIC_PROCEDURE( BGl_proc4262z00zzast_shrinkifyz00, BgL_bgl_shrinkza7d2nodeza712za7d2setq2709za712za7za7ast_shrinkifyza7004310za7, BGl_shrinkzd2nodez12zd2setq2709z12zzast_shrinkifyz00, 0L, 1 );
DEFINE_STATIC_PROCEDURE( BGl_proc4263z00zzast_shrinkifyz00, BgL_bgl_shrinkza7d2nodeza712za7d2conditional2711za712za7za7ast_shrinkifyza7004311za7, BGl_shrinkzd2nodez12zd2conditional2711z12zzast_shrinkifyz00, 0L, 1 );
DEFINE_STATIC_PROCEDURE( BGl_proc4264z00zzast_shrinkifyz00, BgL_bgl_shrinkza7d2nodeza712za7d2fail2713za712za7za7ast_shrinkifyza7004312za7, BGl_shrinkzd2nodez12zd2fail2713z12zzast_shrinkifyz00, 0L, 1 );
DEFINE_STATIC_PROCEDURE( BGl_proc4265z00zzast_shrinkifyz00, BgL_bgl_shrinkza7d2nodeza712za7d2select2715za712za7za7ast_shrinkifyza7004313za7, BGl_shrinkzd2nodez12zd2select2715z12zzast_shrinkifyz00, 0L, 1 );
DEFINE_STATIC_PROCEDURE( BGl_proc4266z00zzast_shrinkifyz00, BgL_bgl_shrinkza7d2nodeza712za7d2makeza7d2box2717za7c0za7za7ast_shrinkifyza7004314z00, BGl_shrinkzd2nodez12zd2makezd2box2717zc0zzast_shrinkifyz00, 0L, 1 );
DEFINE_STATIC_PROCEDURE( BGl_proc4267z00zzast_shrinkifyz00, BgL_bgl_shrinkza7d2nodeza712za7d2boxza7d2ref2719za7c0za7za7ast_shrinkifyza7004315z00, BGl_shrinkzd2nodez12zd2boxzd2ref2719zc0zzast_shrinkifyz00, 0L, 1 );
DEFINE_STATIC_PROCEDURE( BGl_proc4268z00zzast_shrinkifyz00, BgL_bgl_shrinkza7d2nodeza712za7d2boxza7d2setza7122721za7d2za7za7ast_shrinkifyza7004316za7, BGl_shrinkzd2nodez12zd2boxzd2setz122721zd2zzast_shrinkifyz00, 0L, 1 );
DEFINE_STATIC_PROCEDURE( BGl_proc4270z00zzast_shrinkifyz00, BgL_bgl_shrinkza7d2nodeza712za7d2letza7d2var2725za7c0za7za7ast_shrinkifyza7004317z00, BGl_shrinkzd2nodez12zd2letzd2var2725zc0zzast_shrinkifyz00, 0L, 1 );
DEFINE_STATIC_PROCEDURE( BGl_proc4269z00zzast_shrinkifyz00, BgL_bgl_shrinkza7d2nodeza712za7d2letza7d2fun2723za7c0za7za7ast_shrinkifyza7004318z00, BGl_shrinkzd2nodez12zd2letzd2fun2723zc0zzast_shrinkifyz00, 0L, 1 );
DEFINE_STATIC_PROCEDURE( BGl_proc4271z00zzast_shrinkifyz00, BgL_bgl_shrinkza7d2nodeza712za7d2setza7d2exza7d2it2727za712za7za7ast_shrinkifyza7004319za7, BGl_shrinkzd2nodez12zd2setzd2exzd2it2727z12zzast_shrinkifyz00, 0L, 1 );
DEFINE_STATIC_PROCEDURE( BGl_proc4272z00zzast_shrinkifyz00, BgL_bgl_shrinkza7d2nodeza712za7d2jumpza7d2exza7d2it2729za712za7za7ast_shrinkifyza7004320za7, BGl_shrinkzd2nodez12zd2jumpzd2exzd2it2729z12zzast_shrinkifyz00, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( BGl_shrinkifyz12zd2envzc0zzast_shrinkifyz00, BgL_bgl__shrinkifyza712za712za7za7ast_shrinkifyza7004321za7, BGl__shrinkifyz12z12zzast_shrinkifyz00, 0L, 1 );
DEFINE_STATIC_PROCEDURE( BGl_shrinkzd2variablez12zd2default2684zd2envzc0zzast_shrinkifyz00, BgL_bgl__shrinkza7d2variableza712za7d2default2684za712za7za7ast_shrinkifyza7004322za7, BGl__shrinkzd2variablez12zd2default2684z12zzast_shrinkifyz00, 0L, 1 );
DEFINE_STATIC_PROCEDURE( BGl_shrinkzd2nodez12zd2default2688zd2envzc0zzast_shrinkifyz00, BgL_bgl__shrinkza7d2nodeza712za7d2default2688za712za7za7ast_shrinkifyza7004323za7, BGl__shrinkzd2nodez12zd2default2688z12zzast_shrinkifyz00, 0L, 1 );
DEFINE_STRING( BGl_string4274z00zzast_shrinkifyz00, BgL_bgl_string4274za700za7za7ast_shrinkifyza7004324z00, "shrink-node!-default2688 ", 25 );
DEFINE_STRING( BGl_string4273z00zzast_shrinkifyz00, BgL_bgl_string4273za700za7za7ast_shrinkifyza7004325z00, "No method for this object", 25 );
DEFINE_STATIC_GENERIC( BGl_shrinkzd2variablez12zd2envz12zzast_shrinkifyz00, BgL_bgl__shrinkza7d2variableza7123704za7c0za7za7ast_shrinkifyza7004326z00, BGl__shrinkzd2variablez123704zc0zzast_shrinkifyz00, 0L, 1 );



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zzast_shrinkifyz00(long BgL_checksumz00_3194, char * BgL_fromz00_3195)
{ AN_OBJECT;
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zzast_shrinkifyz00))
{ 
BGl_requirezd2initializa7ationz75zzast_shrinkifyz00 = 
BBOOL(((bool_t)0)); 
BGl_libraryzd2moduleszd2initz00zzast_shrinkifyz00(); 
BGl_cnstzd2initzd2zzast_shrinkifyz00(); 
BGl_importedzd2moduleszd2initz00zzast_shrinkifyz00(); 
BGl_methodzd2initzd2zzast_shrinkifyz00(); 
return BUNSPEC;}  else 
{ 
return BUNSPEC;} } 
}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zzast_shrinkifyz00()
{ AN_OBJECT;
{ /* ./Ast/shrinkify.scm 15 */
BGl_modulezd2initializa7ationz75zz__objectz00(((long)0), "ast_shrinkify"); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "ast_shrinkify"); 
return BUNSPEC;} 
}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zzast_shrinkifyz00()
{ AN_OBJECT;
{ /* ./Ast/shrinkify.scm 15 */
{ /* ./Ast/shrinkify.scm 15 */
obj_t BgL_cportz00_3187;
BgL_cportz00_3187 = 
open_input_string(BGl_string4274z00zzast_shrinkifyz00); 
{ 
long BgL_iz00_3188;
BgL_iz00_3188 = ((long)0); 
BgL_loopz00_3189:
{ /* ./Ast/shrinkify.scm 15 */
bool_t BgL_test4276z00_3190;
BgL_test4276z00_3190 = 
(BgL_iz00_3188==((long)-1)); 
if(BgL_test4276z00_3190)
{ /* ./Ast/shrinkify.scm 15 */
return BUNSPEC;}  else 
{ /* ./Ast/shrinkify.scm 15 */
{ /* ./Ast/shrinkify.scm 15 */
obj_t BgL_arg4278z00_3191;
{ /* ./Ast/shrinkify.scm 15 */
obj_t BgL_list4281z00_3192;
BgL_list4281z00_3192 = 
MAKE_PAIR(BgL_cportz00_3187, BNIL); 
BgL_arg4278z00_3191 = 
BGl_readz00zz__readerz00(BgL_list4281z00_3192); } 
{ /* ./Ast/shrinkify.scm 15 */
int BgL_auxz00_3210;
BgL_auxz00_3210 = 
(int)(BgL_iz00_3188); 
CNST_TABLE_SET(BgL_auxz00_3210, BgL_arg4278z00_3191); } } 
{ /* ./Ast/shrinkify.scm 15 */
int BgL_auxz00_3193;
{ /* ./Ast/shrinkify.scm 15 */
long BgL_auxz00_3213;
BgL_auxz00_3213 = 
(BgL_iz00_3188-((long)1)); 
BgL_auxz00_3193 = 
(int)(BgL_auxz00_3213); } 
{ 
long BgL_iz00_3216;
BgL_iz00_3216 = 
(long)(BgL_auxz00_3193); 
BgL_iz00_3188 = BgL_iz00_3216; 
goto BgL_loopz00_3189;} } } } } } } 
}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zzast_shrinkifyz00()
{ AN_OBJECT;
{ /* ./Ast/shrinkify.scm 15 */
return BUNSPEC;} 
}



/* shrinkify! */
BGL_EXPORTED_DEF obj_t BGl_shrinkifyz12z12zzast_shrinkifyz00(obj_t BgL_globalsz00_1)
{ AN_OBJECT;
{ /* ./Ast/shrinkify.scm 25 */
BGl_forzd2eachzd2globalz12z12zzast_envz00(BGl_shrinkzd2variablez12zd2envz12zzast_shrinkifyz00); 
{ 
obj_t BgL_l2655z00_908;
BgL_l2655z00_908 = BgL_globalsz00_1; 
BgL_forzd2each2656zd2_909:
{ /* ./Ast/shrinkify.scm 27 */
bool_t BgL_test2732z00_910;
BgL_test2732z00_910 = 
PAIRP(BgL_l2655z00_908); 
if(BgL_test2732z00_910)
{ /* ./Ast/shrinkify.scm 27 */
{ /* ./Ast/shrinkify.scm 28 */
obj_t BgL_globalz00_911;
BgL_globalz00_911 = 
CAR(BgL_l2655z00_908); 
{ /* ./Ast/shrinkify.scm 28 */
BgL_valuez00_bglt BgL_sfunz00_912;
{ /* ./Ast/shrinkify.scm 28 */
BgL_variablez00_bglt BgL_obj1104z00_1521;
BgL_obj1104z00_1521 = 
(BgL_variablez00_bglt)(BgL_globalz00_911); 
BgL_sfunz00_912 = 
(((BgL_variablez00_bglt)CREF(BgL_obj1104z00_1521))->BgL_valuez00); } 
{ 
obj_t BgL_l2657z00_913;
{ /* ./Ast/shrinkify.scm 29 */
obj_t BgL_arg2734z00_915;
{ /* ./Ast/shrinkify.scm 29 */
BgL_sfunz00_bglt BgL_obj1370z00_1522;
BgL_obj1370z00_1522 = 
(BgL_sfunz00_bglt)(BgL_sfunz00_912); 
BgL_arg2734z00_915 = 
(((BgL_sfunz00_bglt)CREF(BgL_obj1370z00_1522))->BgL_argsz00); } 
BgL_l2657z00_913 = BgL_arg2734z00_915; 
BgL_forzd2each2658zd2_914:
{ /* ./Ast/shrinkify.scm 29 */
bool_t BgL_test2737z00_916;
BgL_test2737z00_916 = 
PAIRP(BgL_l2657z00_913); 
if(BgL_test2737z00_916)
{ /* ./Ast/shrinkify.scm 29 */
{ /* ./Ast/shrinkify.scm 29 */
obj_t BgL_arg2739z00_917;
BgL_arg2739z00_917 = 
CAR(BgL_l2657z00_913); 
{ /* ./Ast/shrinkify.scm 29 */
BgL_variablez00_bglt BgL_variablez00_1525;
BgL_variablez00_1525 = 
(BgL_variablez00_bglt)(BgL_arg2739z00_917); 
{ /* ./Ast/shrinkify.scm 29 */
obj_t BgL_method2687z00_1526;
{ /* ./Ast/shrinkify.scm 29 */
BgL_objectz00_bglt BgL_objz00_1527;
BgL_objz00_1527 = 
(BgL_objectz00_bglt)(BgL_variablez00_1525); 
{ /* ./Ast/shrinkify.scm 29 */
long BgL_objzd2classzd2numz00_1528;
BgL_objzd2classzd2numz00_1528 = 
BGL_OBJECT_CLASS_NUM(BgL_objz00_1527); 
{ /* ./Ast/shrinkify.scm 29 */
obj_t BgL_arg1989z00_1529;
{ /* ./Ast/shrinkify.scm 29 */
int BgL_auxz00_3232;
BgL_auxz00_3232 = 
(int)(((long)1)); 
BgL_arg1989z00_1529 = 
PROCEDURE_REF(BGl_shrinkzd2variablez12zd2envz12zzast_shrinkifyz00, BgL_auxz00_3232); } 
{ /* ./Ast/shrinkify.scm 29 */
int BgL_offsetz00_1532;
BgL_offsetz00_1532 = 
(int)(BgL_objzd2classzd2numz00_1528); 
{ /* ./Ast/shrinkify.scm 29 */
long BgL_offsetz00_1533;
{ /* ./Ast/shrinkify.scm 29 */
long BgL_auxz00_3236;
BgL_auxz00_3236 = 
(long)(BgL_offsetz00_1532); 
BgL_offsetz00_1533 = 
(BgL_auxz00_3236-OBJECT_TYPE); } 
{ /* ./Ast/shrinkify.scm 29 */
long BgL_modz00_1534;
{ /* ./Ast/shrinkify.scm 29 */
int BgL_arg2000z00_1535;
BgL_arg2000z00_1535 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 29 */
long BgL_n2z00_1543;
BgL_n2z00_1543 = 
(long)(BgL_arg2000z00_1535); 
BgL_modz00_1534 = 
(BgL_offsetz00_1533/BgL_n2z00_1543); } } 
{ /* ./Ast/shrinkify.scm 29 */
long BgL_restz00_1536;
{ /* ./Ast/shrinkify.scm 29 */
int BgL_arg1996z00_1537;
BgL_arg1996z00_1537 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 29 */
long BgL_n2z00_1546;
BgL_n2z00_1546 = 
(long)(BgL_arg1996z00_1537); 
BgL_restz00_1536 = 
(BgL_offsetz00_1533%BgL_n2z00_1546); } } 
{ /* ./Ast/shrinkify.scm 29 */

{ /* ./Ast/shrinkify.scm 29 */
obj_t BgL_bucketz00_1538;
{ /* ./Ast/shrinkify.scm 29 */
int BgL_kz00_1548;
BgL_kz00_1548 = 
(int)(BgL_modz00_1534); 
BgL_bucketz00_1538 = 
VECTOR_REF(BgL_arg1989z00_1529,BgL_kz00_1548); } 
{ /* ./Ast/shrinkify.scm 29 */
int BgL_kz00_1550;
BgL_kz00_1550 = 
(int)(BgL_restz00_1536); 
BgL_method2687z00_1526 = 
VECTOR_REF(BgL_bucketz00_1538,BgL_kz00_1550); } } } } } } } } } } 
PROCEDURE_ENTRY(BgL_method2687z00_1526)(BgL_method2687z00_1526, 
(obj_t)(BgL_variablez00_1525), BEOA); } } } 
{ /* ./Ast/shrinkify.scm 29 */
obj_t BgL_arg2743z00_918;
BgL_arg2743z00_918 = 
CDR(BgL_l2657z00_913); 
{ 
obj_t BgL_l2657z00_3253;
BgL_l2657z00_3253 = BgL_arg2743z00_918; 
BgL_l2657z00_913 = BgL_l2657z00_3253; 
goto BgL_forzd2each2658zd2_914;} } }  else 
{ /* ./Ast/shrinkify.scm 29 */((bool_t)1); } } } } 
{ /* ./Ast/shrinkify.scm 30 */
obj_t BgL_arg2748z00_919;
{ /* ./Ast/shrinkify.scm 30 */
BgL_sfunz00_bglt BgL_obj1373z00_1553;
{ /* ./Ast/shrinkify.scm 30 */
BgL_valuez00_bglt BgL_auxz00_3254;
{ /* ./Ast/shrinkify.scm 30 */
BgL_variablez00_bglt BgL_obj1104z00_1552;
BgL_obj1104z00_1552 = 
(BgL_variablez00_bglt)(BgL_globalz00_911); 
BgL_auxz00_3254 = 
(((BgL_variablez00_bglt)CREF(BgL_obj1104z00_1552))->BgL_valuez00); } 
BgL_obj1373z00_1553 = 
(BgL_sfunz00_bglt)(BgL_auxz00_3254); } 
BgL_arg2748z00_919 = 
(((BgL_sfunz00_bglt)CREF(BgL_obj1373z00_1553))->BgL_bodyz00); } 
{ /* ./Ast/shrinkify.scm 30 */
obj_t BgL_res3602z00_1580;
{ /* ./Ast/shrinkify.scm 30 */
BgL_nodez00_bglt BgL_nodez00_1554;
BgL_nodez00_1554 = 
(BgL_nodez00_bglt)(BgL_arg2748z00_919); 
{ /* ./Ast/shrinkify.scm 30 */
obj_t BgL_method2689z00_1555;
{ /* ./Ast/shrinkify.scm 30 */
BgL_objectz00_bglt BgL_objz00_1556;
BgL_objz00_1556 = 
(BgL_objectz00_bglt)(BgL_nodez00_1554); 
{ /* ./Ast/shrinkify.scm 30 */
long BgL_objzd2classzd2numz00_1557;
BgL_objzd2classzd2numz00_1557 = 
BGL_OBJECT_CLASS_NUM(BgL_objz00_1556); 
{ /* ./Ast/shrinkify.scm 30 */
obj_t BgL_arg1989z00_1558;
{ /* ./Ast/shrinkify.scm 30 */
int BgL_auxz00_3262;
BgL_auxz00_3262 = 
(int)(((long)1)); 
BgL_arg1989z00_1558 = 
PROCEDURE_REF(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, BgL_auxz00_3262); } 
{ /* ./Ast/shrinkify.scm 30 */
int BgL_offsetz00_1561;
BgL_offsetz00_1561 = 
(int)(BgL_objzd2classzd2numz00_1557); 
{ /* ./Ast/shrinkify.scm 30 */
long BgL_offsetz00_1562;
{ /* ./Ast/shrinkify.scm 30 */
long BgL_auxz00_3266;
BgL_auxz00_3266 = 
(long)(BgL_offsetz00_1561); 
BgL_offsetz00_1562 = 
(BgL_auxz00_3266-OBJECT_TYPE); } 
{ /* ./Ast/shrinkify.scm 30 */
long BgL_modz00_1563;
{ /* ./Ast/shrinkify.scm 30 */
int BgL_arg2000z00_1564;
BgL_arg2000z00_1564 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 30 */
long BgL_n2z00_1572;
BgL_n2z00_1572 = 
(long)(BgL_arg2000z00_1564); 
BgL_modz00_1563 = 
(BgL_offsetz00_1562/BgL_n2z00_1572); } } 
{ /* ./Ast/shrinkify.scm 30 */
long BgL_restz00_1565;
{ /* ./Ast/shrinkify.scm 30 */
int BgL_arg1996z00_1566;
BgL_arg1996z00_1566 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 30 */
long BgL_n2z00_1575;
BgL_n2z00_1575 = 
(long)(BgL_arg1996z00_1566); 
BgL_restz00_1565 = 
(BgL_offsetz00_1562%BgL_n2z00_1575); } } 
{ /* ./Ast/shrinkify.scm 30 */

{ /* ./Ast/shrinkify.scm 30 */
obj_t BgL_bucketz00_1567;
{ /* ./Ast/shrinkify.scm 30 */
int BgL_kz00_1577;
BgL_kz00_1577 = 
(int)(BgL_modz00_1563); 
BgL_bucketz00_1567 = 
VECTOR_REF(BgL_arg1989z00_1558,BgL_kz00_1577); } 
{ /* ./Ast/shrinkify.scm 30 */
int BgL_kz00_1579;
BgL_kz00_1579 = 
(int)(BgL_restz00_1565); 
BgL_method2689z00_1555 = 
VECTOR_REF(BgL_bucketz00_1567,BgL_kz00_1579); } } } } } } } } } } 
{ /* ./Ast/shrinkify.scm 30 */
obj_t BgL_xz00_3158;
BgL_xz00_3158 = 
PROCEDURE_ENTRY(BgL_method2689z00_1555)(BgL_method2689z00_1555, 
(obj_t)(BgL_nodez00_1554), BEOA); 
BgL_res3602z00_1580 = BUNSPEC; } } } BgL_res3602z00_1580; } } } } 
{ /* ./Ast/shrinkify.scm 27 */
obj_t BgL_arg2757z00_921;
BgL_arg2757z00_921 = 
CDR(BgL_l2655z00_908); 
{ 
obj_t BgL_l2655z00_3283;
BgL_l2655z00_3283 = BgL_arg2757z00_921; 
BgL_l2655z00_908 = BgL_l2655z00_3283; 
goto BgL_forzd2each2656zd2_909;} } }  else 
{ /* ./Ast/shrinkify.scm 27 */((bool_t)1); } } } 
return BgL_globalsz00_1;} 
}



/* _shrinkify! */
obj_t BGl__shrinkifyz12z12zzast_shrinkifyz00(obj_t BgL_envz00_3088, obj_t BgL_globalsz00_3089)
{ AN_OBJECT;
{ /* ./Ast/shrinkify.scm 25 */
return 
BGl_shrinkifyz12z12zzast_shrinkifyz00(BgL_globalsz00_3089);} 
}



/* shrink-node*! */
bool_t BGl_shrinkzd2nodeza2z12z62zzast_shrinkifyz00(obj_t BgL_nodeza2za2_26)
{ AN_OBJECT;
{ /* ./Ast/shrinkify.scm 221 */
{ 
obj_t BgL_l2682z00_922;
BgL_l2682z00_922 = BgL_nodeza2za2_26; 
BgL_forzd2each2683zd2_923:
{ /* ./Ast/shrinkify.scm 222 */
bool_t BgL_test2762z00_924;
BgL_test2762z00_924 = 
PAIRP(BgL_l2682z00_922); 
if(BgL_test2762z00_924)
{ /* ./Ast/shrinkify.scm 222 */
{ /* ./Ast/shrinkify.scm 222 */
obj_t BgL_arg2764z00_925;
BgL_arg2764z00_925 = 
CAR(BgL_l2682z00_922); 
{ /* ./Ast/shrinkify.scm 222 */
obj_t BgL_res3605z00_1610;
{ /* ./Ast/shrinkify.scm 222 */
BgL_nodez00_bglt BgL_nodez00_1584;
BgL_nodez00_1584 = 
(BgL_nodez00_bglt)(BgL_arg2764z00_925); 
{ /* ./Ast/shrinkify.scm 222 */
obj_t BgL_method2689z00_1585;
{ /* ./Ast/shrinkify.scm 222 */
BgL_objectz00_bglt BgL_objz00_1586;
BgL_objz00_1586 = 
(BgL_objectz00_bglt)(BgL_nodez00_1584); 
{ /* ./Ast/shrinkify.scm 222 */
long BgL_objzd2classzd2numz00_1587;
BgL_objzd2classzd2numz00_1587 = 
BGL_OBJECT_CLASS_NUM(BgL_objz00_1586); 
{ /* ./Ast/shrinkify.scm 222 */
obj_t BgL_arg1989z00_1588;
{ /* ./Ast/shrinkify.scm 222 */
int BgL_auxz00_3291;
BgL_auxz00_3291 = 
(int)(((long)1)); 
BgL_arg1989z00_1588 = 
PROCEDURE_REF(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, BgL_auxz00_3291); } 
{ /* ./Ast/shrinkify.scm 222 */
int BgL_offsetz00_1591;
BgL_offsetz00_1591 = 
(int)(BgL_objzd2classzd2numz00_1587); 
{ /* ./Ast/shrinkify.scm 222 */
long BgL_offsetz00_1592;
{ /* ./Ast/shrinkify.scm 222 */
long BgL_auxz00_3295;
BgL_auxz00_3295 = 
(long)(BgL_offsetz00_1591); 
BgL_offsetz00_1592 = 
(BgL_auxz00_3295-OBJECT_TYPE); } 
{ /* ./Ast/shrinkify.scm 222 */
long BgL_modz00_1593;
{ /* ./Ast/shrinkify.scm 222 */
int BgL_arg2000z00_1594;
BgL_arg2000z00_1594 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 222 */
long BgL_n2z00_1602;
BgL_n2z00_1602 = 
(long)(BgL_arg2000z00_1594); 
BgL_modz00_1593 = 
(BgL_offsetz00_1592/BgL_n2z00_1602); } } 
{ /* ./Ast/shrinkify.scm 222 */
long BgL_restz00_1595;
{ /* ./Ast/shrinkify.scm 222 */
int BgL_arg1996z00_1596;
BgL_arg1996z00_1596 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 222 */
long BgL_n2z00_1605;
BgL_n2z00_1605 = 
(long)(BgL_arg1996z00_1596); 
BgL_restz00_1595 = 
(BgL_offsetz00_1592%BgL_n2z00_1605); } } 
{ /* ./Ast/shrinkify.scm 222 */

{ /* ./Ast/shrinkify.scm 222 */
obj_t BgL_bucketz00_1597;
{ /* ./Ast/shrinkify.scm 222 */
int BgL_kz00_1607;
BgL_kz00_1607 = 
(int)(BgL_modz00_1593); 
BgL_bucketz00_1597 = 
VECTOR_REF(BgL_arg1989z00_1588,BgL_kz00_1607); } 
{ /* ./Ast/shrinkify.scm 222 */
int BgL_kz00_1609;
BgL_kz00_1609 = 
(int)(BgL_restz00_1595); 
BgL_method2689z00_1585 = 
VECTOR_REF(BgL_bucketz00_1597,BgL_kz00_1609); } } } } } } } } } } 
{ /* ./Ast/shrinkify.scm 222 */
obj_t BgL_xz00_3159;
BgL_xz00_3159 = 
PROCEDURE_ENTRY(BgL_method2689z00_1585)(BgL_method2689z00_1585, 
(obj_t)(BgL_nodez00_1584), BEOA); 
BgL_res3605z00_1610 = BUNSPEC; } } } BgL_res3605z00_1610; } } 
{ /* ./Ast/shrinkify.scm 222 */
obj_t BgL_arg2768z00_926;
BgL_arg2768z00_926 = 
CDR(BgL_l2682z00_922); 
{ 
obj_t BgL_l2682z00_3312;
BgL_l2682z00_3312 = BgL_arg2768z00_926; 
BgL_l2682z00_922 = BgL_l2682z00_3312; 
goto BgL_forzd2each2683zd2_923;} } }  else 
{ /* ./Ast/shrinkify.scm 222 */
return ((bool_t)1);} } } } 
}



/* method-init */
obj_t BGl_methodzd2initzd2zzast_shrinkifyz00()
{ AN_OBJECT;
{ /* ./Ast/shrinkify.scm 15 */
BGl_addzd2genericz12zc0zz__objectz00(BGl_shrinkzd2variablez12zd2envz12zzast_shrinkifyz00, BGl_shrinkzd2variablez12zd2default2684zd2envzc0zzast_shrinkifyz00); 
BGl_addzd2genericz12zc0zz__objectz00(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, BGl_shrinkzd2nodez12zd2default2688zd2envzc0zzast_shrinkifyz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, BGl_atomz00zzast_nodez00, BGl_proc4253z00zzast_shrinkifyz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, BGl_varz00zzast_nodez00, BGl_proc4254z00zzast_shrinkifyz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, BGl_kwotez00zzast_nodez00, BGl_proc4255z00zzast_shrinkifyz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, BGl_sequencez00zzast_nodez00, BGl_proc4256z00zzast_shrinkifyz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, BGl_appz00zzast_nodez00, BGl_proc4257z00zzast_shrinkifyz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, BGl_appzd2lyzd2zzast_nodez00, BGl_proc4258z00zzast_shrinkifyz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, BGl_funcallz00zzast_nodez00, BGl_proc4259z00zzast_shrinkifyz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, BGl_externz00zzast_nodez00, BGl_proc4260z00zzast_shrinkifyz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, BGl_castz00zzast_nodez00, BGl_proc4261z00zzast_shrinkifyz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, BGl_setqz00zzast_nodez00, BGl_proc4262z00zzast_shrinkifyz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, BGl_conditionalz00zzast_nodez00, BGl_proc4263z00zzast_shrinkifyz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, BGl_failz00zzast_nodez00, BGl_proc4264z00zzast_shrinkifyz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, BGl_selectz00zzast_nodez00, BGl_proc4265z00zzast_shrinkifyz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, BGl_makezd2boxzd2zzast_nodez00, BGl_proc4266z00zzast_shrinkifyz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, BGl_boxzd2refzd2zzast_nodez00, BGl_proc4267z00zzast_shrinkifyz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, BGl_boxzd2setz12zc0zzast_nodez00, BGl_proc4268z00zzast_shrinkifyz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, BGl_letzd2funzd2zzast_nodez00, BGl_proc4269z00zzast_shrinkifyz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, BGl_letzd2varzd2zzast_nodez00, BGl_proc4270z00zzast_shrinkifyz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, BGl_setzd2exzd2itz00zzast_nodez00, BGl_proc4271z00zzast_shrinkifyz00); 
return 
BGl_addzd2methodz12zc0zz__objectz00(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, BGl_jumpzd2exzd2itz00zzast_nodez00, BGl_proc4272z00zzast_shrinkifyz00);} 
}



/* shrink-node!-jump-ex-it2729 */
obj_t BGl_shrinkzd2nodez12zd2jumpzd2exzd2it2729z12zzast_shrinkifyz00(obj_t BgL_envz00_3114, obj_t BgL_nodez00_3115)
{ AN_OBJECT;
{ /* ./Ast/shrinkify.scm 213 */
{ 
BgL_jumpzd2exzd2itz00_bglt BgL_nodez00_1499;
BgL_nodez00_1499 = 
(BgL_jumpzd2exzd2itz00_bglt)(BgL_nodez00_3115); 
{ /* ./Ast/shrinkify.scm 214 */
BgL_nodez00_bglt BgL_arg3547z00_1502;
BgL_arg3547z00_1502 = 
(((BgL_jumpzd2exzd2itz00_bglt)CREF(BgL_nodez00_1499))->BgL_exitz00); 
{ /* ./Ast/shrinkify.scm 214 */
obj_t BgL_res3693z00_2978;
{ /* ./Ast/shrinkify.scm 214 */
obj_t BgL_method2689z00_2953;
{ /* ./Ast/shrinkify.scm 214 */
BgL_objectz00_bglt BgL_objz00_2954;
BgL_objz00_2954 = 
(BgL_objectz00_bglt)(BgL_arg3547z00_1502); 
{ /* ./Ast/shrinkify.scm 214 */
long BgL_objzd2classzd2numz00_2955;
BgL_objzd2classzd2numz00_2955 = 
BGL_OBJECT_CLASS_NUM(BgL_objz00_2954); 
{ /* ./Ast/shrinkify.scm 214 */
obj_t BgL_arg1989z00_2956;
{ /* ./Ast/shrinkify.scm 214 */
int BgL_auxz00_3338;
BgL_auxz00_3338 = 
(int)(((long)1)); 
BgL_arg1989z00_2956 = 
PROCEDURE_REF(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, BgL_auxz00_3338); } 
{ /* ./Ast/shrinkify.scm 214 */
int BgL_offsetz00_2959;
BgL_offsetz00_2959 = 
(int)(BgL_objzd2classzd2numz00_2955); 
{ /* ./Ast/shrinkify.scm 214 */
long BgL_offsetz00_2960;
{ /* ./Ast/shrinkify.scm 214 */
long BgL_auxz00_3342;
BgL_auxz00_3342 = 
(long)(BgL_offsetz00_2959); 
BgL_offsetz00_2960 = 
(BgL_auxz00_3342-OBJECT_TYPE); } 
{ /* ./Ast/shrinkify.scm 214 */
long BgL_modz00_2961;
{ /* ./Ast/shrinkify.scm 214 */
int BgL_arg2000z00_2962;
BgL_arg2000z00_2962 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 214 */
long BgL_n2z00_2970;
BgL_n2z00_2970 = 
(long)(BgL_arg2000z00_2962); 
BgL_modz00_2961 = 
(BgL_offsetz00_2960/BgL_n2z00_2970); } } 
{ /* ./Ast/shrinkify.scm 214 */
long BgL_restz00_2963;
{ /* ./Ast/shrinkify.scm 214 */
int BgL_arg1996z00_2964;
BgL_arg1996z00_2964 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 214 */
long BgL_n2z00_2973;
BgL_n2z00_2973 = 
(long)(BgL_arg1996z00_2964); 
BgL_restz00_2963 = 
(BgL_offsetz00_2960%BgL_n2z00_2973); } } 
{ /* ./Ast/shrinkify.scm 214 */

{ /* ./Ast/shrinkify.scm 214 */
obj_t BgL_bucketz00_2965;
{ /* ./Ast/shrinkify.scm 214 */
int BgL_kz00_2975;
BgL_kz00_2975 = 
(int)(BgL_modz00_2961); 
BgL_bucketz00_2965 = 
VECTOR_REF(BgL_arg1989z00_2956,BgL_kz00_2975); } 
{ /* ./Ast/shrinkify.scm 214 */
int BgL_kz00_2977;
BgL_kz00_2977 = 
(int)(BgL_restz00_2963); 
BgL_method2689z00_2953 = 
VECTOR_REF(BgL_bucketz00_2965,BgL_kz00_2977); } } } } } } } } } } 
{ /* ./Ast/shrinkify.scm 214 */
obj_t BgL_xz00_3160;
BgL_xz00_3160 = 
PROCEDURE_ENTRY(BgL_method2689z00_2953)(BgL_method2689z00_2953, 
(obj_t)(BgL_arg3547z00_1502), BEOA); 
BgL_res3693z00_2978 = BUNSPEC; } } BgL_res3693z00_2978; } } 
{ /* ./Ast/shrinkify.scm 215 */
BgL_nodez00_bglt BgL_arg3551z00_1503;
BgL_arg3551z00_1503 = 
(((BgL_jumpzd2exzd2itz00_bglt)CREF(BgL_nodez00_1499))->BgL_valuez00); 
{ /* ./Ast/shrinkify.scm 215 */
obj_t BgL_res3696z00_3006;
{ /* ./Ast/shrinkify.scm 215 */
obj_t BgL_method2689z00_2981;
{ /* ./Ast/shrinkify.scm 215 */
BgL_objectz00_bglt BgL_objz00_2982;
BgL_objz00_2982 = 
(BgL_objectz00_bglt)(BgL_arg3551z00_1503); 
{ /* ./Ast/shrinkify.scm 215 */
long BgL_objzd2classzd2numz00_2983;
BgL_objzd2classzd2numz00_2983 = 
BGL_OBJECT_CLASS_NUM(BgL_objz00_2982); 
{ /* ./Ast/shrinkify.scm 215 */
obj_t BgL_arg1989z00_2984;
{ /* ./Ast/shrinkify.scm 215 */
int BgL_auxz00_3361;
BgL_auxz00_3361 = 
(int)(((long)1)); 
BgL_arg1989z00_2984 = 
PROCEDURE_REF(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, BgL_auxz00_3361); } 
{ /* ./Ast/shrinkify.scm 215 */
int BgL_offsetz00_2987;
BgL_offsetz00_2987 = 
(int)(BgL_objzd2classzd2numz00_2983); 
{ /* ./Ast/shrinkify.scm 215 */
long BgL_offsetz00_2988;
{ /* ./Ast/shrinkify.scm 215 */
long BgL_auxz00_3365;
BgL_auxz00_3365 = 
(long)(BgL_offsetz00_2987); 
BgL_offsetz00_2988 = 
(BgL_auxz00_3365-OBJECT_TYPE); } 
{ /* ./Ast/shrinkify.scm 215 */
long BgL_modz00_2989;
{ /* ./Ast/shrinkify.scm 215 */
int BgL_arg2000z00_2990;
BgL_arg2000z00_2990 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 215 */
long BgL_n2z00_2998;
BgL_n2z00_2998 = 
(long)(BgL_arg2000z00_2990); 
BgL_modz00_2989 = 
(BgL_offsetz00_2988/BgL_n2z00_2998); } } 
{ /* ./Ast/shrinkify.scm 215 */
long BgL_restz00_2991;
{ /* ./Ast/shrinkify.scm 215 */
int BgL_arg1996z00_2992;
BgL_arg1996z00_2992 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 215 */
long BgL_n2z00_3001;
BgL_n2z00_3001 = 
(long)(BgL_arg1996z00_2992); 
BgL_restz00_2991 = 
(BgL_offsetz00_2988%BgL_n2z00_3001); } } 
{ /* ./Ast/shrinkify.scm 215 */

{ /* ./Ast/shrinkify.scm 215 */
obj_t BgL_bucketz00_2993;
{ /* ./Ast/shrinkify.scm 215 */
int BgL_kz00_3003;
BgL_kz00_3003 = 
(int)(BgL_modz00_2989); 
BgL_bucketz00_2993 = 
VECTOR_REF(BgL_arg1989z00_2984,BgL_kz00_3003); } 
{ /* ./Ast/shrinkify.scm 215 */
int BgL_kz00_3005;
BgL_kz00_3005 = 
(int)(BgL_restz00_2991); 
BgL_method2689z00_2981 = 
VECTOR_REF(BgL_bucketz00_2993,BgL_kz00_3005); } } } } } } } } } } 
{ /* ./Ast/shrinkify.scm 215 */
obj_t BgL_xz00_3161;
BgL_xz00_3161 = 
PROCEDURE_ENTRY(BgL_method2689z00_2981)(BgL_method2689z00_2981, 
(obj_t)(BgL_arg3551z00_1503), BEOA); 
BgL_res3696z00_3006 = BUNSPEC; } } BgL_res3696z00_3006; } } 
return BUNSPEC;} } 
}



/* shrink-node!-set-ex-it2727 */
obj_t BGl_shrinkzd2nodez12zd2setzd2exzd2it2727z12zzast_shrinkifyz00(obj_t BgL_envz00_3116, obj_t BgL_nodez00_3117)
{ AN_OBJECT;
{ /* ./Ast/shrinkify.scm 204 */
{ 
BgL_setzd2exzd2itz00_bglt BgL_nodez00_1491;
BgL_nodez00_1491 = 
(BgL_setzd2exzd2itz00_bglt)(BgL_nodez00_3117); 
{ /* ./Ast/shrinkify.scm 206 */
BgL_varz00_bglt BgL_arg3533z00_1495;
BgL_arg3533z00_1495 = 
(((BgL_setzd2exzd2itz00_bglt)CREF(BgL_nodez00_1491))->BgL_varz00); 
{ /* ./Ast/shrinkify.scm 206 */
obj_t BgL_res3687z00_2922;
{ /* ./Ast/shrinkify.scm 206 */
BgL_nodez00_bglt BgL_nodez00_2896;
BgL_nodez00_2896 = 
(BgL_nodez00_bglt)(BgL_arg3533z00_1495); 
{ /* ./Ast/shrinkify.scm 206 */
obj_t BgL_method2689z00_2897;
{ /* ./Ast/shrinkify.scm 206 */
BgL_objectz00_bglt BgL_objz00_2898;
BgL_objz00_2898 = 
(BgL_objectz00_bglt)(BgL_nodez00_2896); 
{ /* ./Ast/shrinkify.scm 206 */
long BgL_objzd2classzd2numz00_2899;
BgL_objzd2classzd2numz00_2899 = 
BGL_OBJECT_CLASS_NUM(BgL_objz00_2898); 
{ /* ./Ast/shrinkify.scm 206 */
obj_t BgL_arg1989z00_2900;
{ /* ./Ast/shrinkify.scm 206 */
int BgL_auxz00_3386;
BgL_auxz00_3386 = 
(int)(((long)1)); 
BgL_arg1989z00_2900 = 
PROCEDURE_REF(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, BgL_auxz00_3386); } 
{ /* ./Ast/shrinkify.scm 206 */
int BgL_offsetz00_2903;
BgL_offsetz00_2903 = 
(int)(BgL_objzd2classzd2numz00_2899); 
{ /* ./Ast/shrinkify.scm 206 */
long BgL_offsetz00_2904;
{ /* ./Ast/shrinkify.scm 206 */
long BgL_auxz00_3390;
BgL_auxz00_3390 = 
(long)(BgL_offsetz00_2903); 
BgL_offsetz00_2904 = 
(BgL_auxz00_3390-OBJECT_TYPE); } 
{ /* ./Ast/shrinkify.scm 206 */
long BgL_modz00_2905;
{ /* ./Ast/shrinkify.scm 206 */
int BgL_arg2000z00_2906;
BgL_arg2000z00_2906 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 206 */
long BgL_n2z00_2914;
BgL_n2z00_2914 = 
(long)(BgL_arg2000z00_2906); 
BgL_modz00_2905 = 
(BgL_offsetz00_2904/BgL_n2z00_2914); } } 
{ /* ./Ast/shrinkify.scm 206 */
long BgL_restz00_2907;
{ /* ./Ast/shrinkify.scm 206 */
int BgL_arg1996z00_2908;
BgL_arg1996z00_2908 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 206 */
long BgL_n2z00_2917;
BgL_n2z00_2917 = 
(long)(BgL_arg1996z00_2908); 
BgL_restz00_2907 = 
(BgL_offsetz00_2904%BgL_n2z00_2917); } } 
{ /* ./Ast/shrinkify.scm 206 */

{ /* ./Ast/shrinkify.scm 206 */
obj_t BgL_bucketz00_2909;
{ /* ./Ast/shrinkify.scm 206 */
int BgL_kz00_2919;
BgL_kz00_2919 = 
(int)(BgL_modz00_2905); 
BgL_bucketz00_2909 = 
VECTOR_REF(BgL_arg1989z00_2900,BgL_kz00_2919); } 
{ /* ./Ast/shrinkify.scm 206 */
int BgL_kz00_2921;
BgL_kz00_2921 = 
(int)(BgL_restz00_2907); 
BgL_method2689z00_2897 = 
VECTOR_REF(BgL_bucketz00_2909,BgL_kz00_2921); } } } } } } } } } } 
{ /* ./Ast/shrinkify.scm 206 */
obj_t BgL_xz00_3162;
BgL_xz00_3162 = 
PROCEDURE_ENTRY(BgL_method2689z00_2897)(BgL_method2689z00_2897, 
(obj_t)(BgL_nodez00_2896), BEOA); 
BgL_res3687z00_2922 = BUNSPEC; } } } BgL_res3687z00_2922; } } 
{ /* ./Ast/shrinkify.scm 207 */
BgL_nodez00_bglt BgL_arg3537z00_1496;
BgL_arg3537z00_1496 = 
(((BgL_setzd2exzd2itz00_bglt)CREF(BgL_nodez00_1491))->BgL_bodyz00); 
{ /* ./Ast/shrinkify.scm 207 */
obj_t BgL_res3690z00_2950;
{ /* ./Ast/shrinkify.scm 207 */
obj_t BgL_method2689z00_2925;
{ /* ./Ast/shrinkify.scm 207 */
BgL_objectz00_bglt BgL_objz00_2926;
BgL_objz00_2926 = 
(BgL_objectz00_bglt)(BgL_arg3537z00_1496); 
{ /* ./Ast/shrinkify.scm 207 */
long BgL_objzd2classzd2numz00_2927;
BgL_objzd2classzd2numz00_2927 = 
BGL_OBJECT_CLASS_NUM(BgL_objz00_2926); 
{ /* ./Ast/shrinkify.scm 207 */
obj_t BgL_arg1989z00_2928;
{ /* ./Ast/shrinkify.scm 207 */
int BgL_auxz00_3409;
BgL_auxz00_3409 = 
(int)(((long)1)); 
BgL_arg1989z00_2928 = 
PROCEDURE_REF(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, BgL_auxz00_3409); } 
{ /* ./Ast/shrinkify.scm 207 */
int BgL_offsetz00_2931;
BgL_offsetz00_2931 = 
(int)(BgL_objzd2classzd2numz00_2927); 
{ /* ./Ast/shrinkify.scm 207 */
long BgL_offsetz00_2932;
{ /* ./Ast/shrinkify.scm 207 */
long BgL_auxz00_3413;
BgL_auxz00_3413 = 
(long)(BgL_offsetz00_2931); 
BgL_offsetz00_2932 = 
(BgL_auxz00_3413-OBJECT_TYPE); } 
{ /* ./Ast/shrinkify.scm 207 */
long BgL_modz00_2933;
{ /* ./Ast/shrinkify.scm 207 */
int BgL_arg2000z00_2934;
BgL_arg2000z00_2934 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 207 */
long BgL_n2z00_2942;
BgL_n2z00_2942 = 
(long)(BgL_arg2000z00_2934); 
BgL_modz00_2933 = 
(BgL_offsetz00_2932/BgL_n2z00_2942); } } 
{ /* ./Ast/shrinkify.scm 207 */
long BgL_restz00_2935;
{ /* ./Ast/shrinkify.scm 207 */
int BgL_arg1996z00_2936;
BgL_arg1996z00_2936 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 207 */
long BgL_n2z00_2945;
BgL_n2z00_2945 = 
(long)(BgL_arg1996z00_2936); 
BgL_restz00_2935 = 
(BgL_offsetz00_2932%BgL_n2z00_2945); } } 
{ /* ./Ast/shrinkify.scm 207 */

{ /* ./Ast/shrinkify.scm 207 */
obj_t BgL_bucketz00_2937;
{ /* ./Ast/shrinkify.scm 207 */
int BgL_kz00_2947;
BgL_kz00_2947 = 
(int)(BgL_modz00_2933); 
BgL_bucketz00_2937 = 
VECTOR_REF(BgL_arg1989z00_2928,BgL_kz00_2947); } 
{ /* ./Ast/shrinkify.scm 207 */
int BgL_kz00_2949;
BgL_kz00_2949 = 
(int)(BgL_restz00_2935); 
BgL_method2689z00_2925 = 
VECTOR_REF(BgL_bucketz00_2937,BgL_kz00_2949); } } } } } } } } } } 
{ /* ./Ast/shrinkify.scm 207 */
obj_t BgL_xz00_3163;
BgL_xz00_3163 = 
PROCEDURE_ENTRY(BgL_method2689z00_2925)(BgL_method2689z00_2925, 
(obj_t)(BgL_arg3537z00_1496), BEOA); 
BgL_res3690z00_2950 = BUNSPEC; } } BgL_res3690z00_2950; } } 
return BUNSPEC;} } 
}



/* shrink-node!-let-var2725 */
obj_t BGl_shrinkzd2nodez12zd2letzd2var2725zc0zzast_shrinkifyz00(obj_t BgL_envz00_3118, obj_t BgL_nodez00_3119)
{ AN_OBJECT;
{ /* ./Ast/shrinkify.scm 192 */
{ 
BgL_letzd2varzd2_bglt BgL_nodez00_1476;
BgL_nodez00_1476 = 
(BgL_letzd2varzd2_bglt)(BgL_nodez00_3119); 
{ /* ./Ast/shrinkify.scm 194 */
BgL_nodez00_bglt BgL_arg3504z00_1480;
BgL_arg3504z00_1480 = 
(((BgL_letzd2varzd2_bglt)CREF(BgL_nodez00_1476))->BgL_bodyz00); 
{ /* ./Ast/shrinkify.scm 194 */
obj_t BgL_res3679z00_2835;
{ /* ./Ast/shrinkify.scm 194 */
obj_t BgL_method2689z00_2810;
{ /* ./Ast/shrinkify.scm 194 */
BgL_objectz00_bglt BgL_objz00_2811;
BgL_objz00_2811 = 
(BgL_objectz00_bglt)(BgL_arg3504z00_1480); 
{ /* ./Ast/shrinkify.scm 194 */
long BgL_objzd2classzd2numz00_2812;
BgL_objzd2classzd2numz00_2812 = 
BGL_OBJECT_CLASS_NUM(BgL_objz00_2811); 
{ /* ./Ast/shrinkify.scm 194 */
obj_t BgL_arg1989z00_2813;
{ /* ./Ast/shrinkify.scm 194 */
int BgL_auxz00_3433;
BgL_auxz00_3433 = 
(int)(((long)1)); 
BgL_arg1989z00_2813 = 
PROCEDURE_REF(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, BgL_auxz00_3433); } 
{ /* ./Ast/shrinkify.scm 194 */
int BgL_offsetz00_2816;
BgL_offsetz00_2816 = 
(int)(BgL_objzd2classzd2numz00_2812); 
{ /* ./Ast/shrinkify.scm 194 */
long BgL_offsetz00_2817;
{ /* ./Ast/shrinkify.scm 194 */
long BgL_auxz00_3437;
BgL_auxz00_3437 = 
(long)(BgL_offsetz00_2816); 
BgL_offsetz00_2817 = 
(BgL_auxz00_3437-OBJECT_TYPE); } 
{ /* ./Ast/shrinkify.scm 194 */
long BgL_modz00_2818;
{ /* ./Ast/shrinkify.scm 194 */
int BgL_arg2000z00_2819;
BgL_arg2000z00_2819 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 194 */
long BgL_n2z00_2827;
BgL_n2z00_2827 = 
(long)(BgL_arg2000z00_2819); 
BgL_modz00_2818 = 
(BgL_offsetz00_2817/BgL_n2z00_2827); } } 
{ /* ./Ast/shrinkify.scm 194 */
long BgL_restz00_2820;
{ /* ./Ast/shrinkify.scm 194 */
int BgL_arg1996z00_2821;
BgL_arg1996z00_2821 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 194 */
long BgL_n2z00_2830;
BgL_n2z00_2830 = 
(long)(BgL_arg1996z00_2821); 
BgL_restz00_2820 = 
(BgL_offsetz00_2817%BgL_n2z00_2830); } } 
{ /* ./Ast/shrinkify.scm 194 */

{ /* ./Ast/shrinkify.scm 194 */
obj_t BgL_bucketz00_2822;
{ /* ./Ast/shrinkify.scm 194 */
int BgL_kz00_2832;
BgL_kz00_2832 = 
(int)(BgL_modz00_2818); 
BgL_bucketz00_2822 = 
VECTOR_REF(BgL_arg1989z00_2813,BgL_kz00_2832); } 
{ /* ./Ast/shrinkify.scm 194 */
int BgL_kz00_2834;
BgL_kz00_2834 = 
(int)(BgL_restz00_2820); 
BgL_method2689z00_2810 = 
VECTOR_REF(BgL_bucketz00_2822,BgL_kz00_2834); } } } } } } } } } } 
{ /* ./Ast/shrinkify.scm 194 */
obj_t BgL_xz00_3164;
BgL_xz00_3164 = 
PROCEDURE_ENTRY(BgL_method2689z00_2810)(BgL_method2689z00_2810, 
(obj_t)(BgL_arg3504z00_1480), BEOA); 
BgL_res3679z00_2835 = BUNSPEC; } } BgL_res3679z00_2835; } } 
{ 
obj_t BgL_l2678z00_1481;
{ /* ./Ast/shrinkify.scm 195 */
obj_t BgL_arg3508z00_1483;
BgL_arg3508z00_1483 = 
(((BgL_letzd2varzd2_bglt)CREF(BgL_nodez00_1476))->BgL_bindingsz00); 
BgL_l2678z00_1481 = BgL_arg3508z00_1483; 
BgL_forzd2each2679zd2_1482:
{ /* ./Ast/shrinkify.scm 195 */
bool_t BgL_test3511z00_1484;
BgL_test3511z00_1484 = 
PAIRP(BgL_l2678z00_1481); 
if(BgL_test3511z00_1484)
{ /* ./Ast/shrinkify.scm 195 */
{ /* ./Ast/shrinkify.scm 196 */
obj_t BgL_bindingz00_1485;
BgL_bindingz00_1485 = 
CAR(BgL_l2678z00_1481); 
{ /* ./Ast/shrinkify.scm 196 */
obj_t BgL_arg3513z00_1486;
BgL_arg3513z00_1486 = 
CAR(BgL_bindingz00_1485); 
{ /* ./Ast/shrinkify.scm 196 */
BgL_variablez00_bglt BgL_variablez00_2840;
BgL_variablez00_2840 = 
(BgL_variablez00_bglt)(BgL_arg3513z00_1486); 
{ /* ./Ast/shrinkify.scm 196 */
obj_t BgL_method2687z00_2841;
{ /* ./Ast/shrinkify.scm 196 */
BgL_objectz00_bglt BgL_objz00_2842;
BgL_objz00_2842 = 
(BgL_objectz00_bglt)(BgL_variablez00_2840); 
{ /* ./Ast/shrinkify.scm 196 */
long BgL_objzd2classzd2numz00_2843;
BgL_objzd2classzd2numz00_2843 = 
BGL_OBJECT_CLASS_NUM(BgL_objz00_2842); 
{ /* ./Ast/shrinkify.scm 196 */
obj_t BgL_arg1989z00_2844;
{ /* ./Ast/shrinkify.scm 196 */
int BgL_auxz00_3461;
BgL_auxz00_3461 = 
(int)(((long)1)); 
BgL_arg1989z00_2844 = 
PROCEDURE_REF(BGl_shrinkzd2variablez12zd2envz12zzast_shrinkifyz00, BgL_auxz00_3461); } 
{ /* ./Ast/shrinkify.scm 196 */
int BgL_offsetz00_2847;
BgL_offsetz00_2847 = 
(int)(BgL_objzd2classzd2numz00_2843); 
{ /* ./Ast/shrinkify.scm 196 */
long BgL_offsetz00_2848;
{ /* ./Ast/shrinkify.scm 196 */
long BgL_auxz00_3465;
BgL_auxz00_3465 = 
(long)(BgL_offsetz00_2847); 
BgL_offsetz00_2848 = 
(BgL_auxz00_3465-OBJECT_TYPE); } 
{ /* ./Ast/shrinkify.scm 196 */
long BgL_modz00_2849;
{ /* ./Ast/shrinkify.scm 196 */
int BgL_arg2000z00_2850;
BgL_arg2000z00_2850 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 196 */
long BgL_n2z00_2858;
BgL_n2z00_2858 = 
(long)(BgL_arg2000z00_2850); 
BgL_modz00_2849 = 
(BgL_offsetz00_2848/BgL_n2z00_2858); } } 
{ /* ./Ast/shrinkify.scm 196 */
long BgL_restz00_2851;
{ /* ./Ast/shrinkify.scm 196 */
int BgL_arg1996z00_2852;
BgL_arg1996z00_2852 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 196 */
long BgL_n2z00_2861;
BgL_n2z00_2861 = 
(long)(BgL_arg1996z00_2852); 
BgL_restz00_2851 = 
(BgL_offsetz00_2848%BgL_n2z00_2861); } } 
{ /* ./Ast/shrinkify.scm 196 */

{ /* ./Ast/shrinkify.scm 196 */
obj_t BgL_bucketz00_2853;
{ /* ./Ast/shrinkify.scm 196 */
int BgL_kz00_2863;
BgL_kz00_2863 = 
(int)(BgL_modz00_2849); 
BgL_bucketz00_2853 = 
VECTOR_REF(BgL_arg1989z00_2844,BgL_kz00_2863); } 
{ /* ./Ast/shrinkify.scm 196 */
int BgL_kz00_2865;
BgL_kz00_2865 = 
(int)(BgL_restz00_2851); 
BgL_method2687z00_2841 = 
VECTOR_REF(BgL_bucketz00_2853,BgL_kz00_2865); } } } } } } } } } } 
PROCEDURE_ENTRY(BgL_method2687z00_2841)(BgL_method2687z00_2841, 
(obj_t)(BgL_variablez00_2840), BEOA); } } } 
{ /* ./Ast/shrinkify.scm 197 */
obj_t BgL_arg3517z00_1487;
BgL_arg3517z00_1487 = 
CDR(BgL_bindingz00_1485); 
{ /* ./Ast/shrinkify.scm 197 */
obj_t BgL_res3684z00_2893;
{ /* ./Ast/shrinkify.scm 197 */
BgL_nodez00_bglt BgL_nodez00_2867;
BgL_nodez00_2867 = 
(BgL_nodez00_bglt)(BgL_arg3517z00_1487); 
{ /* ./Ast/shrinkify.scm 197 */
obj_t BgL_method2689z00_2868;
{ /* ./Ast/shrinkify.scm 197 */
BgL_objectz00_bglt BgL_objz00_2869;
BgL_objz00_2869 = 
(BgL_objectz00_bglt)(BgL_nodez00_2867); 
{ /* ./Ast/shrinkify.scm 197 */
long BgL_objzd2classzd2numz00_2870;
BgL_objzd2classzd2numz00_2870 = 
BGL_OBJECT_CLASS_NUM(BgL_objz00_2869); 
{ /* ./Ast/shrinkify.scm 197 */
obj_t BgL_arg1989z00_2871;
{ /* ./Ast/shrinkify.scm 197 */
int BgL_auxz00_3485;
BgL_auxz00_3485 = 
(int)(((long)1)); 
BgL_arg1989z00_2871 = 
PROCEDURE_REF(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, BgL_auxz00_3485); } 
{ /* ./Ast/shrinkify.scm 197 */
int BgL_offsetz00_2874;
BgL_offsetz00_2874 = 
(int)(BgL_objzd2classzd2numz00_2870); 
{ /* ./Ast/shrinkify.scm 197 */
long BgL_offsetz00_2875;
{ /* ./Ast/shrinkify.scm 197 */
long BgL_auxz00_3489;
BgL_auxz00_3489 = 
(long)(BgL_offsetz00_2874); 
BgL_offsetz00_2875 = 
(BgL_auxz00_3489-OBJECT_TYPE); } 
{ /* ./Ast/shrinkify.scm 197 */
long BgL_modz00_2876;
{ /* ./Ast/shrinkify.scm 197 */
int BgL_arg2000z00_2877;
BgL_arg2000z00_2877 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 197 */
long BgL_n2z00_2885;
BgL_n2z00_2885 = 
(long)(BgL_arg2000z00_2877); 
BgL_modz00_2876 = 
(BgL_offsetz00_2875/BgL_n2z00_2885); } } 
{ /* ./Ast/shrinkify.scm 197 */
long BgL_restz00_2878;
{ /* ./Ast/shrinkify.scm 197 */
int BgL_arg1996z00_2879;
BgL_arg1996z00_2879 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 197 */
long BgL_n2z00_2888;
BgL_n2z00_2888 = 
(long)(BgL_arg1996z00_2879); 
BgL_restz00_2878 = 
(BgL_offsetz00_2875%BgL_n2z00_2888); } } 
{ /* ./Ast/shrinkify.scm 197 */

{ /* ./Ast/shrinkify.scm 197 */
obj_t BgL_bucketz00_2880;
{ /* ./Ast/shrinkify.scm 197 */
int BgL_kz00_2890;
BgL_kz00_2890 = 
(int)(BgL_modz00_2876); 
BgL_bucketz00_2880 = 
VECTOR_REF(BgL_arg1989z00_2871,BgL_kz00_2890); } 
{ /* ./Ast/shrinkify.scm 197 */
int BgL_kz00_2892;
BgL_kz00_2892 = 
(int)(BgL_restz00_2878); 
BgL_method2689z00_2868 = 
VECTOR_REF(BgL_bucketz00_2880,BgL_kz00_2892); } } } } } } } } } } 
{ /* ./Ast/shrinkify.scm 197 */
obj_t BgL_xz00_3165;
BgL_xz00_3165 = 
PROCEDURE_ENTRY(BgL_method2689z00_2868)(BgL_method2689z00_2868, 
(obj_t)(BgL_nodez00_2867), BEOA); 
BgL_res3684z00_2893 = BUNSPEC; } } } BgL_res3684z00_2893; } } } 
{ /* ./Ast/shrinkify.scm 195 */
obj_t BgL_arg3522z00_1488;
BgL_arg3522z00_1488 = 
CDR(BgL_l2678z00_1481); 
{ 
obj_t BgL_l2678z00_3506;
BgL_l2678z00_3506 = BgL_arg3522z00_1488; 
BgL_l2678z00_1481 = BgL_l2678z00_3506; 
goto BgL_forzd2each2679zd2_1482;} } }  else 
{ /* ./Ast/shrinkify.scm 195 */((bool_t)1); } } } } 
return BUNSPEC;} } 
}



/* shrink-node!-let-fun2723 */
obj_t BGl_shrinkzd2nodez12zd2letzd2fun2723zc0zzast_shrinkifyz00(obj_t BgL_envz00_3120, obj_t BgL_nodez00_3121)
{ AN_OBJECT;
{ /* ./Ast/shrinkify.scm 178 */
{ 
BgL_letzd2funzd2_bglt BgL_nodez00_1455;
BgL_nodez00_1455 = 
(BgL_letzd2funzd2_bglt)(BgL_nodez00_3121); 
{ /* ./Ast/shrinkify.scm 180 */
BgL_nodez00_bglt BgL_arg3461z00_1459;
BgL_arg3461z00_1459 = 
(((BgL_letzd2funzd2_bglt)CREF(BgL_nodez00_1455))->BgL_bodyz00); 
{ /* ./Ast/shrinkify.scm 180 */
obj_t BgL_res3669z00_2718;
{ /* ./Ast/shrinkify.scm 180 */
obj_t BgL_method2689z00_2693;
{ /* ./Ast/shrinkify.scm 180 */
BgL_objectz00_bglt BgL_objz00_2694;
BgL_objz00_2694 = 
(BgL_objectz00_bglt)(BgL_arg3461z00_1459); 
{ /* ./Ast/shrinkify.scm 180 */
long BgL_objzd2classzd2numz00_2695;
BgL_objzd2classzd2numz00_2695 = 
BGL_OBJECT_CLASS_NUM(BgL_objz00_2694); 
{ /* ./Ast/shrinkify.scm 180 */
obj_t BgL_arg1989z00_2696;
{ /* ./Ast/shrinkify.scm 180 */
int BgL_auxz00_3511;
BgL_auxz00_3511 = 
(int)(((long)1)); 
BgL_arg1989z00_2696 = 
PROCEDURE_REF(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, BgL_auxz00_3511); } 
{ /* ./Ast/shrinkify.scm 180 */
int BgL_offsetz00_2699;
BgL_offsetz00_2699 = 
(int)(BgL_objzd2classzd2numz00_2695); 
{ /* ./Ast/shrinkify.scm 180 */
long BgL_offsetz00_2700;
{ /* ./Ast/shrinkify.scm 180 */
long BgL_auxz00_3515;
BgL_auxz00_3515 = 
(long)(BgL_offsetz00_2699); 
BgL_offsetz00_2700 = 
(BgL_auxz00_3515-OBJECT_TYPE); } 
{ /* ./Ast/shrinkify.scm 180 */
long BgL_modz00_2701;
{ /* ./Ast/shrinkify.scm 180 */
int BgL_arg2000z00_2702;
BgL_arg2000z00_2702 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 180 */
long BgL_n2z00_2710;
BgL_n2z00_2710 = 
(long)(BgL_arg2000z00_2702); 
BgL_modz00_2701 = 
(BgL_offsetz00_2700/BgL_n2z00_2710); } } 
{ /* ./Ast/shrinkify.scm 180 */
long BgL_restz00_2703;
{ /* ./Ast/shrinkify.scm 180 */
int BgL_arg1996z00_2704;
BgL_arg1996z00_2704 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 180 */
long BgL_n2z00_2713;
BgL_n2z00_2713 = 
(long)(BgL_arg1996z00_2704); 
BgL_restz00_2703 = 
(BgL_offsetz00_2700%BgL_n2z00_2713); } } 
{ /* ./Ast/shrinkify.scm 180 */

{ /* ./Ast/shrinkify.scm 180 */
obj_t BgL_bucketz00_2705;
{ /* ./Ast/shrinkify.scm 180 */
int BgL_kz00_2715;
BgL_kz00_2715 = 
(int)(BgL_modz00_2701); 
BgL_bucketz00_2705 = 
VECTOR_REF(BgL_arg1989z00_2696,BgL_kz00_2715); } 
{ /* ./Ast/shrinkify.scm 180 */
int BgL_kz00_2717;
BgL_kz00_2717 = 
(int)(BgL_restz00_2703); 
BgL_method2689z00_2693 = 
VECTOR_REF(BgL_bucketz00_2705,BgL_kz00_2717); } } } } } } } } } } 
{ /* ./Ast/shrinkify.scm 180 */
obj_t BgL_xz00_3166;
BgL_xz00_3166 = 
PROCEDURE_ENTRY(BgL_method2689z00_2693)(BgL_method2689z00_2693, 
(obj_t)(BgL_arg3461z00_1459), BEOA); 
BgL_res3669z00_2718 = BUNSPEC; } } BgL_res3669z00_2718; } } 
{ 
obj_t BgL_l2672z00_1460;
{ /* ./Ast/shrinkify.scm 181 */
obj_t BgL_arg3466z00_1462;
BgL_arg3466z00_1462 = 
(((BgL_letzd2funzd2_bglt)CREF(BgL_nodez00_1455))->BgL_localsz00); 
BgL_l2672z00_1460 = BgL_arg3466z00_1462; 
BgL_forzd2each2673zd2_1461:
{ /* ./Ast/shrinkify.scm 181 */
bool_t BgL_test3469z00_1463;
BgL_test3469z00_1463 = 
PAIRP(BgL_l2672z00_1460); 
if(BgL_test3469z00_1463)
{ /* ./Ast/shrinkify.scm 181 */
{ /* ./Ast/shrinkify.scm 182 */
obj_t BgL_localz00_1464;
BgL_localz00_1464 = 
CAR(BgL_l2672z00_1460); 
{ /* ./Ast/shrinkify.scm 182 */
BgL_valuez00_bglt BgL_sfunz00_1465;
{ /* ./Ast/shrinkify.scm 182 */
BgL_variablez00_bglt BgL_obj1104z00_2722;
BgL_obj1104z00_2722 = 
(BgL_variablez00_bglt)(BgL_localz00_1464); 
BgL_sfunz00_1465 = 
(((BgL_variablez00_bglt)CREF(BgL_obj1104z00_2722))->BgL_valuez00); } 
{ /* ./Ast/shrinkify.scm 183 */
BgL_variablez00_bglt BgL_variablez00_2723;
BgL_variablez00_2723 = 
(BgL_variablez00_bglt)(BgL_localz00_1464); 
{ /* ./Ast/shrinkify.scm 183 */
obj_t BgL_method2687z00_2724;
{ /* ./Ast/shrinkify.scm 183 */
BgL_objectz00_bglt BgL_objz00_2725;
BgL_objz00_2725 = 
(BgL_objectz00_bglt)(BgL_variablez00_2723); 
{ /* ./Ast/shrinkify.scm 183 */
long BgL_objzd2classzd2numz00_2726;
BgL_objzd2classzd2numz00_2726 = 
BGL_OBJECT_CLASS_NUM(BgL_objz00_2725); 
{ /* ./Ast/shrinkify.scm 183 */
obj_t BgL_arg1989z00_2727;
{ /* ./Ast/shrinkify.scm 183 */
int BgL_auxz00_3540;
BgL_auxz00_3540 = 
(int)(((long)1)); 
BgL_arg1989z00_2727 = 
PROCEDURE_REF(BGl_shrinkzd2variablez12zd2envz12zzast_shrinkifyz00, BgL_auxz00_3540); } 
{ /* ./Ast/shrinkify.scm 183 */
int BgL_offsetz00_2730;
BgL_offsetz00_2730 = 
(int)(BgL_objzd2classzd2numz00_2726); 
{ /* ./Ast/shrinkify.scm 183 */
long BgL_offsetz00_2731;
{ /* ./Ast/shrinkify.scm 183 */
long BgL_auxz00_3544;
BgL_auxz00_3544 = 
(long)(BgL_offsetz00_2730); 
BgL_offsetz00_2731 = 
(BgL_auxz00_3544-OBJECT_TYPE); } 
{ /* ./Ast/shrinkify.scm 183 */
long BgL_modz00_2732;
{ /* ./Ast/shrinkify.scm 183 */
int BgL_arg2000z00_2733;
BgL_arg2000z00_2733 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 183 */
long BgL_n2z00_2741;
BgL_n2z00_2741 = 
(long)(BgL_arg2000z00_2733); 
BgL_modz00_2732 = 
(BgL_offsetz00_2731/BgL_n2z00_2741); } } 
{ /* ./Ast/shrinkify.scm 183 */
long BgL_restz00_2734;
{ /* ./Ast/shrinkify.scm 183 */
int BgL_arg1996z00_2735;
BgL_arg1996z00_2735 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 183 */
long BgL_n2z00_2744;
BgL_n2z00_2744 = 
(long)(BgL_arg1996z00_2735); 
BgL_restz00_2734 = 
(BgL_offsetz00_2731%BgL_n2z00_2744); } } 
{ /* ./Ast/shrinkify.scm 183 */

{ /* ./Ast/shrinkify.scm 183 */
obj_t BgL_bucketz00_2736;
{ /* ./Ast/shrinkify.scm 183 */
int BgL_kz00_2746;
BgL_kz00_2746 = 
(int)(BgL_modz00_2732); 
BgL_bucketz00_2736 = 
VECTOR_REF(BgL_arg1989z00_2727,BgL_kz00_2746); } 
{ /* ./Ast/shrinkify.scm 183 */
int BgL_kz00_2748;
BgL_kz00_2748 = 
(int)(BgL_restz00_2734); 
BgL_method2687z00_2724 = 
VECTOR_REF(BgL_bucketz00_2736,BgL_kz00_2748); } } } } } } } } } } 
PROCEDURE_ENTRY(BgL_method2687z00_2724)(BgL_method2687z00_2724, 
(obj_t)(BgL_variablez00_2723), BEOA); } } 
{ 
obj_t BgL_l2674z00_1466;
{ /* ./Ast/shrinkify.scm 184 */
obj_t BgL_arg3472z00_1468;
{ /* ./Ast/shrinkify.scm 184 */
BgL_sfunz00_bglt BgL_obj1370z00_2749;
BgL_obj1370z00_2749 = 
(BgL_sfunz00_bglt)(BgL_sfunz00_1465); 
BgL_arg3472z00_1468 = 
(((BgL_sfunz00_bglt)CREF(BgL_obj1370z00_2749))->BgL_argsz00); } 
BgL_l2674z00_1466 = BgL_arg3472z00_1468; 
BgL_forzd2each2675zd2_1467:
{ /* ./Ast/shrinkify.scm 184 */
bool_t BgL_test3475z00_1469;
BgL_test3475z00_1469 = 
PAIRP(BgL_l2674z00_1466); 
if(BgL_test3475z00_1469)
{ /* ./Ast/shrinkify.scm 184 */
{ /* ./Ast/shrinkify.scm 184 */
obj_t BgL_arg3477z00_1470;
BgL_arg3477z00_1470 = 
CAR(BgL_l2674z00_1466); 
{ /* ./Ast/shrinkify.scm 184 */
BgL_variablez00_bglt BgL_variablez00_2752;
BgL_variablez00_2752 = 
(BgL_variablez00_bglt)(BgL_arg3477z00_1470); 
{ /* ./Ast/shrinkify.scm 184 */
obj_t BgL_method2687z00_2753;
{ /* ./Ast/shrinkify.scm 184 */
BgL_objectz00_bglt BgL_objz00_2754;
BgL_objz00_2754 = 
(BgL_objectz00_bglt)(BgL_variablez00_2752); 
{ /* ./Ast/shrinkify.scm 184 */
long BgL_objzd2classzd2numz00_2755;
BgL_objzd2classzd2numz00_2755 = 
BGL_OBJECT_CLASS_NUM(BgL_objz00_2754); 
{ /* ./Ast/shrinkify.scm 184 */
obj_t BgL_arg1989z00_2756;
{ /* ./Ast/shrinkify.scm 184 */
int BgL_auxz00_3568;
BgL_auxz00_3568 = 
(int)(((long)1)); 
BgL_arg1989z00_2756 = 
PROCEDURE_REF(BGl_shrinkzd2variablez12zd2envz12zzast_shrinkifyz00, BgL_auxz00_3568); } 
{ /* ./Ast/shrinkify.scm 184 */
int BgL_offsetz00_2759;
BgL_offsetz00_2759 = 
(int)(BgL_objzd2classzd2numz00_2755); 
{ /* ./Ast/shrinkify.scm 184 */
long BgL_offsetz00_2760;
{ /* ./Ast/shrinkify.scm 184 */
long BgL_auxz00_3572;
BgL_auxz00_3572 = 
(long)(BgL_offsetz00_2759); 
BgL_offsetz00_2760 = 
(BgL_auxz00_3572-OBJECT_TYPE); } 
{ /* ./Ast/shrinkify.scm 184 */
long BgL_modz00_2761;
{ /* ./Ast/shrinkify.scm 184 */
int BgL_arg2000z00_2762;
BgL_arg2000z00_2762 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 184 */
long BgL_n2z00_2770;
BgL_n2z00_2770 = 
(long)(BgL_arg2000z00_2762); 
BgL_modz00_2761 = 
(BgL_offsetz00_2760/BgL_n2z00_2770); } } 
{ /* ./Ast/shrinkify.scm 184 */
long BgL_restz00_2763;
{ /* ./Ast/shrinkify.scm 184 */
int BgL_arg1996z00_2764;
BgL_arg1996z00_2764 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 184 */
long BgL_n2z00_2773;
BgL_n2z00_2773 = 
(long)(BgL_arg1996z00_2764); 
BgL_restz00_2763 = 
(BgL_offsetz00_2760%BgL_n2z00_2773); } } 
{ /* ./Ast/shrinkify.scm 184 */

{ /* ./Ast/shrinkify.scm 184 */
obj_t BgL_bucketz00_2765;
{ /* ./Ast/shrinkify.scm 184 */
int BgL_kz00_2775;
BgL_kz00_2775 = 
(int)(BgL_modz00_2761); 
BgL_bucketz00_2765 = 
VECTOR_REF(BgL_arg1989z00_2756,BgL_kz00_2775); } 
{ /* ./Ast/shrinkify.scm 184 */
int BgL_kz00_2777;
BgL_kz00_2777 = 
(int)(BgL_restz00_2763); 
BgL_method2687z00_2753 = 
VECTOR_REF(BgL_bucketz00_2765,BgL_kz00_2777); } } } } } } } } } } 
PROCEDURE_ENTRY(BgL_method2687z00_2753)(BgL_method2687z00_2753, 
(obj_t)(BgL_variablez00_2752), BEOA); } } } 
{ /* ./Ast/shrinkify.scm 184 */
obj_t BgL_arg3481z00_1471;
BgL_arg3481z00_1471 = 
CDR(BgL_l2674z00_1466); 
{ 
obj_t BgL_l2674z00_3589;
BgL_l2674z00_3589 = BgL_arg3481z00_1471; 
BgL_l2674z00_1466 = BgL_l2674z00_3589; 
goto BgL_forzd2each2675zd2_1467;} } }  else 
{ /* ./Ast/shrinkify.scm 184 */((bool_t)1); } } } } 
{ /* ./Ast/shrinkify.scm 185 */
obj_t BgL_arg3486z00_1472;
{ /* ./Ast/shrinkify.scm 185 */
BgL_sfunz00_bglt BgL_obj1373z00_2779;
BgL_obj1373z00_2779 = 
(BgL_sfunz00_bglt)(BgL_sfunz00_1465); 
BgL_arg3486z00_1472 = 
(((BgL_sfunz00_bglt)CREF(BgL_obj1373z00_2779))->BgL_bodyz00); } 
{ /* ./Ast/shrinkify.scm 185 */
obj_t BgL_res3676z00_2806;
{ /* ./Ast/shrinkify.scm 185 */
BgL_nodez00_bglt BgL_nodez00_2780;
BgL_nodez00_2780 = 
(BgL_nodez00_bglt)(BgL_arg3486z00_1472); 
{ /* ./Ast/shrinkify.scm 185 */
obj_t BgL_method2689z00_2781;
{ /* ./Ast/shrinkify.scm 185 */
BgL_objectz00_bglt BgL_objz00_2782;
BgL_objz00_2782 = 
(BgL_objectz00_bglt)(BgL_nodez00_2780); 
{ /* ./Ast/shrinkify.scm 185 */
long BgL_objzd2classzd2numz00_2783;
BgL_objzd2classzd2numz00_2783 = 
BGL_OBJECT_CLASS_NUM(BgL_objz00_2782); 
{ /* ./Ast/shrinkify.scm 185 */
obj_t BgL_arg1989z00_2784;
{ /* ./Ast/shrinkify.scm 185 */
int BgL_auxz00_3595;
BgL_auxz00_3595 = 
(int)(((long)1)); 
BgL_arg1989z00_2784 = 
PROCEDURE_REF(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, BgL_auxz00_3595); } 
{ /* ./Ast/shrinkify.scm 185 */
int BgL_offsetz00_2787;
BgL_offsetz00_2787 = 
(int)(BgL_objzd2classzd2numz00_2783); 
{ /* ./Ast/shrinkify.scm 185 */
long BgL_offsetz00_2788;
{ /* ./Ast/shrinkify.scm 185 */
long BgL_auxz00_3599;
BgL_auxz00_3599 = 
(long)(BgL_offsetz00_2787); 
BgL_offsetz00_2788 = 
(BgL_auxz00_3599-OBJECT_TYPE); } 
{ /* ./Ast/shrinkify.scm 185 */
long BgL_modz00_2789;
{ /* ./Ast/shrinkify.scm 185 */
int BgL_arg2000z00_2790;
BgL_arg2000z00_2790 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 185 */
long BgL_n2z00_2798;
BgL_n2z00_2798 = 
(long)(BgL_arg2000z00_2790); 
BgL_modz00_2789 = 
(BgL_offsetz00_2788/BgL_n2z00_2798); } } 
{ /* ./Ast/shrinkify.scm 185 */
long BgL_restz00_2791;
{ /* ./Ast/shrinkify.scm 185 */
int BgL_arg1996z00_2792;
BgL_arg1996z00_2792 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 185 */
long BgL_n2z00_2801;
BgL_n2z00_2801 = 
(long)(BgL_arg1996z00_2792); 
BgL_restz00_2791 = 
(BgL_offsetz00_2788%BgL_n2z00_2801); } } 
{ /* ./Ast/shrinkify.scm 185 */

{ /* ./Ast/shrinkify.scm 185 */
obj_t BgL_bucketz00_2793;
{ /* ./Ast/shrinkify.scm 185 */
int BgL_kz00_2803;
BgL_kz00_2803 = 
(int)(BgL_modz00_2789); 
BgL_bucketz00_2793 = 
VECTOR_REF(BgL_arg1989z00_2784,BgL_kz00_2803); } 
{ /* ./Ast/shrinkify.scm 185 */
int BgL_kz00_2805;
BgL_kz00_2805 = 
(int)(BgL_restz00_2791); 
BgL_method2689z00_2781 = 
VECTOR_REF(BgL_bucketz00_2793,BgL_kz00_2805); } } } } } } } } } } 
{ /* ./Ast/shrinkify.scm 185 */
obj_t BgL_xz00_3167;
BgL_xz00_3167 = 
PROCEDURE_ENTRY(BgL_method2689z00_2781)(BgL_method2689z00_2781, 
(obj_t)(BgL_nodez00_2780), BEOA); 
BgL_res3676z00_2806 = BUNSPEC; } } } BgL_res3676z00_2806; } } } } 
{ /* ./Ast/shrinkify.scm 181 */
obj_t BgL_arg3492z00_1473;
BgL_arg3492z00_1473 = 
CDR(BgL_l2672z00_1460); 
{ 
obj_t BgL_l2672z00_3616;
BgL_l2672z00_3616 = BgL_arg3492z00_1473; 
BgL_l2672z00_1460 = BgL_l2672z00_3616; 
goto BgL_forzd2each2673zd2_1461;} } }  else 
{ /* ./Ast/shrinkify.scm 181 */((bool_t)1); } } } } 
return BUNSPEC;} } 
}



/* shrink-node!-box-set!2721 */
obj_t BGl_shrinkzd2nodez12zd2boxzd2setz122721zd2zzast_shrinkifyz00(obj_t BgL_envz00_3122, obj_t BgL_nodez00_3123)
{ AN_OBJECT;
{ /* ./Ast/shrinkify.scm 169 */
{ 
BgL_boxzd2setz12zc0_bglt BgL_nodez00_1443;
BgL_nodez00_1443 = 
(BgL_boxzd2setz12zc0_bglt)(BgL_nodez00_3123); 
{ /* ./Ast/shrinkify.scm 170 */
bool_t BgL_test3433z00_1446;
{ /* ./Ast/shrinkify.scm 170 */
bool_t BgL_testz00_3618;
{ /* ./Ast/shrinkify.scm 170 */
obj_t BgL_auxz00_3619;
{ /* ./Ast/shrinkify.scm 170 */
BgL_objectz00_bglt BgL_auxz00_3620;
BgL_auxz00_3620 = 
(BgL_objectz00_bglt)(BgL_nodez00_1443); 
BgL_auxz00_3619 = 
BGL_OBJECT_WIDENING(BgL_auxz00_3620); } 
BgL_testz00_3618 = 
CBOOL(BgL_auxz00_3619); } 
if(BgL_testz00_3618)
{ /* ./Ast/shrinkify.scm 170 */
BgL_test3433z00_1446 = ((bool_t)1); }  else 
{ /* ./Ast/shrinkify.scm 170 */
BgL_test3433z00_1446 = ((bool_t)0); } } 
if(BgL_test3433z00_1446)
{ /* ./Ast/shrinkify.scm 170 */
{ /* ./Ast/shrinkify.scm 170 */
long BgL_arg3435z00_1448;
{ /* ./Ast/shrinkify.scm 170 */
obj_t BgL_arg3438z00_1449;
{ /* ./Ast/shrinkify.scm 170 */
obj_t BgL_arg3441z00_1450;
{ /* ./Ast/shrinkify.scm 170 */
BgL_objectz00_bglt BgL_objectz00_2625;
BgL_objectz00_2625 = 
(BgL_objectz00_bglt)(BgL_nodez00_1443); 
{ /* ./Ast/shrinkify.scm 170 */
long BgL_arg2007z00_2626;
{ /* ./Ast/shrinkify.scm 170 */
long BgL_arg2010z00_2627;
BgL_arg2010z00_2627 = 
BGL_OBJECT_CLASS_NUM(BgL_objectz00_2625); 
BgL_arg2007z00_2626 = 
(BgL_arg2010z00_2627-OBJECT_TYPE); } 
{ /* ./Ast/shrinkify.scm 170 */
obj_t BgL_vectorz00_2631;int BgL_kz00_2632;
BgL_vectorz00_2631 = BGl_za2classesza2z00zz__objectz00; 
BgL_kz00_2632 = 
(int)(BgL_arg2007z00_2626); 
BgL_arg3441z00_1450 = 
VECTOR_REF(BgL_vectorz00_2631,BgL_kz00_2632); } } } 
BgL_arg3438z00_1449 = 
BGl_classzd2superzd2zz__objectz00(BgL_arg3441z00_1450); } 
BgL_arg3435z00_1448 = 
BGl_classzd2numzd2zz__objectz00(BgL_arg3438z00_1449); } 
{ /* ./Ast/shrinkify.scm 170 */
BgL_objectz00_bglt BgL_objz00_2633;
BgL_objz00_2633 = 
(BgL_objectz00_bglt)(BgL_nodez00_1443); 
BGL_OBJECT_CLASS_NUM_SET(BgL_objz00_2633, BgL_arg3435z00_1448); } } 
{ /* ./Ast/shrinkify.scm 170 */
BgL_objectz00_bglt BgL_auxz00_3634;
BgL_auxz00_3634 = 
(BgL_objectz00_bglt)(BgL_nodez00_1443); 
BGL_OBJECT_WIDENING_SET(BgL_auxz00_3634, BFALSE); } 
(obj_t)(BgL_nodez00_1443); }  else 
{ /* ./Ast/shrinkify.scm 170 */BFALSE; } } 
{ /* ./Ast/shrinkify.scm 171 */
BgL_varz00_bglt BgL_arg3447z00_1451;
BgL_arg3447z00_1451 = 
(((BgL_boxzd2setz12zc0_bglt)CREF(BgL_nodez00_1443))->BgL_varz00); 
{ /* ./Ast/shrinkify.scm 171 */
obj_t BgL_res3663z00_2662;
{ /* ./Ast/shrinkify.scm 171 */
BgL_nodez00_bglt BgL_nodez00_2636;
BgL_nodez00_2636 = 
(BgL_nodez00_bglt)(BgL_arg3447z00_1451); 
{ /* ./Ast/shrinkify.scm 171 */
obj_t BgL_method2689z00_2637;
{ /* ./Ast/shrinkify.scm 171 */
BgL_objectz00_bglt BgL_objz00_2638;
BgL_objz00_2638 = 
(BgL_objectz00_bglt)(BgL_nodez00_2636); 
{ /* ./Ast/shrinkify.scm 171 */
long BgL_objzd2classzd2numz00_2639;
BgL_objzd2classzd2numz00_2639 = 
BGL_OBJECT_CLASS_NUM(BgL_objz00_2638); 
{ /* ./Ast/shrinkify.scm 171 */
obj_t BgL_arg1989z00_2640;
{ /* ./Ast/shrinkify.scm 171 */
int BgL_auxz00_3642;
BgL_auxz00_3642 = 
(int)(((long)1)); 
BgL_arg1989z00_2640 = 
PROCEDURE_REF(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, BgL_auxz00_3642); } 
{ /* ./Ast/shrinkify.scm 171 */
int BgL_offsetz00_2643;
BgL_offsetz00_2643 = 
(int)(BgL_objzd2classzd2numz00_2639); 
{ /* ./Ast/shrinkify.scm 171 */
long BgL_offsetz00_2644;
{ /* ./Ast/shrinkify.scm 171 */
long BgL_auxz00_3646;
BgL_auxz00_3646 = 
(long)(BgL_offsetz00_2643); 
BgL_offsetz00_2644 = 
(BgL_auxz00_3646-OBJECT_TYPE); } 
{ /* ./Ast/shrinkify.scm 171 */
long BgL_modz00_2645;
{ /* ./Ast/shrinkify.scm 171 */
int BgL_arg2000z00_2646;
BgL_arg2000z00_2646 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 171 */
long BgL_n2z00_2654;
BgL_n2z00_2654 = 
(long)(BgL_arg2000z00_2646); 
BgL_modz00_2645 = 
(BgL_offsetz00_2644/BgL_n2z00_2654); } } 
{ /* ./Ast/shrinkify.scm 171 */
long BgL_restz00_2647;
{ /* ./Ast/shrinkify.scm 171 */
int BgL_arg1996z00_2648;
BgL_arg1996z00_2648 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 171 */
long BgL_n2z00_2657;
BgL_n2z00_2657 = 
(long)(BgL_arg1996z00_2648); 
BgL_restz00_2647 = 
(BgL_offsetz00_2644%BgL_n2z00_2657); } } 
{ /* ./Ast/shrinkify.scm 171 */

{ /* ./Ast/shrinkify.scm 171 */
obj_t BgL_bucketz00_2649;
{ /* ./Ast/shrinkify.scm 171 */
int BgL_kz00_2659;
BgL_kz00_2659 = 
(int)(BgL_modz00_2645); 
BgL_bucketz00_2649 = 
VECTOR_REF(BgL_arg1989z00_2640,BgL_kz00_2659); } 
{ /* ./Ast/shrinkify.scm 171 */
int BgL_kz00_2661;
BgL_kz00_2661 = 
(int)(BgL_restz00_2647); 
BgL_method2689z00_2637 = 
VECTOR_REF(BgL_bucketz00_2649,BgL_kz00_2661); } } } } } } } } } } 
{ /* ./Ast/shrinkify.scm 171 */
obj_t BgL_xz00_3168;
BgL_xz00_3168 = 
PROCEDURE_ENTRY(BgL_method2689z00_2637)(BgL_method2689z00_2637, 
(obj_t)(BgL_nodez00_2636), BEOA); 
BgL_res3663z00_2662 = BUNSPEC; } } } BgL_res3663z00_2662; } } 
{ /* ./Ast/shrinkify.scm 172 */
BgL_nodez00_bglt BgL_arg3451z00_1452;
BgL_arg3451z00_1452 = 
(((BgL_boxzd2setz12zc0_bglt)CREF(BgL_nodez00_1443))->BgL_valuez00); 
{ /* ./Ast/shrinkify.scm 172 */
obj_t BgL_res3666z00_2690;
{ /* ./Ast/shrinkify.scm 172 */
obj_t BgL_method2689z00_2665;
{ /* ./Ast/shrinkify.scm 172 */
BgL_objectz00_bglt BgL_objz00_2666;
BgL_objz00_2666 = 
(BgL_objectz00_bglt)(BgL_arg3451z00_1452); 
{ /* ./Ast/shrinkify.scm 172 */
long BgL_objzd2classzd2numz00_2667;
BgL_objzd2classzd2numz00_2667 = 
BGL_OBJECT_CLASS_NUM(BgL_objz00_2666); 
{ /* ./Ast/shrinkify.scm 172 */
obj_t BgL_arg1989z00_2668;
{ /* ./Ast/shrinkify.scm 172 */
int BgL_auxz00_3665;
BgL_auxz00_3665 = 
(int)(((long)1)); 
BgL_arg1989z00_2668 = 
PROCEDURE_REF(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, BgL_auxz00_3665); } 
{ /* ./Ast/shrinkify.scm 172 */
int BgL_offsetz00_2671;
BgL_offsetz00_2671 = 
(int)(BgL_objzd2classzd2numz00_2667); 
{ /* ./Ast/shrinkify.scm 172 */
long BgL_offsetz00_2672;
{ /* ./Ast/shrinkify.scm 172 */
long BgL_auxz00_3669;
BgL_auxz00_3669 = 
(long)(BgL_offsetz00_2671); 
BgL_offsetz00_2672 = 
(BgL_auxz00_3669-OBJECT_TYPE); } 
{ /* ./Ast/shrinkify.scm 172 */
long BgL_modz00_2673;
{ /* ./Ast/shrinkify.scm 172 */
int BgL_arg2000z00_2674;
BgL_arg2000z00_2674 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 172 */
long BgL_n2z00_2682;
BgL_n2z00_2682 = 
(long)(BgL_arg2000z00_2674); 
BgL_modz00_2673 = 
(BgL_offsetz00_2672/BgL_n2z00_2682); } } 
{ /* ./Ast/shrinkify.scm 172 */
long BgL_restz00_2675;
{ /* ./Ast/shrinkify.scm 172 */
int BgL_arg1996z00_2676;
BgL_arg1996z00_2676 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 172 */
long BgL_n2z00_2685;
BgL_n2z00_2685 = 
(long)(BgL_arg1996z00_2676); 
BgL_restz00_2675 = 
(BgL_offsetz00_2672%BgL_n2z00_2685); } } 
{ /* ./Ast/shrinkify.scm 172 */

{ /* ./Ast/shrinkify.scm 172 */
obj_t BgL_bucketz00_2677;
{ /* ./Ast/shrinkify.scm 172 */
int BgL_kz00_2687;
BgL_kz00_2687 = 
(int)(BgL_modz00_2673); 
BgL_bucketz00_2677 = 
VECTOR_REF(BgL_arg1989z00_2668,BgL_kz00_2687); } 
{ /* ./Ast/shrinkify.scm 172 */
int BgL_kz00_2689;
BgL_kz00_2689 = 
(int)(BgL_restz00_2675); 
BgL_method2689z00_2665 = 
VECTOR_REF(BgL_bucketz00_2677,BgL_kz00_2689); } } } } } } } } } } 
{ /* ./Ast/shrinkify.scm 172 */
obj_t BgL_xz00_3169;
BgL_xz00_3169 = 
PROCEDURE_ENTRY(BgL_method2689z00_2665)(BgL_method2689z00_2665, 
(obj_t)(BgL_arg3451z00_1452), BEOA); 
BgL_res3666z00_2690 = BUNSPEC; } } BgL_res3666z00_2690; } } 
return BUNSPEC;} } 
}



/* shrink-node!-box-ref2719 */
obj_t BGl_shrinkzd2nodez12zd2boxzd2ref2719zc0zzast_shrinkifyz00(obj_t BgL_envz00_3124, obj_t BgL_nodez00_3125)
{ AN_OBJECT;
{ /* ./Ast/shrinkify.scm 161 */
{ 
BgL_boxzd2refzd2_bglt BgL_nodez00_1432;
BgL_nodez00_1432 = 
(BgL_boxzd2refzd2_bglt)(BgL_nodez00_3125); 
{ /* ./Ast/shrinkify.scm 162 */
bool_t BgL_test3410z00_1435;
{ /* ./Ast/shrinkify.scm 162 */
bool_t BgL_testz00_3686;
{ /* ./Ast/shrinkify.scm 162 */
obj_t BgL_auxz00_3687;
{ /* ./Ast/shrinkify.scm 162 */
BgL_objectz00_bglt BgL_auxz00_3688;
BgL_auxz00_3688 = 
(BgL_objectz00_bglt)(BgL_nodez00_1432); 
BgL_auxz00_3687 = 
BGL_OBJECT_WIDENING(BgL_auxz00_3688); } 
BgL_testz00_3686 = 
CBOOL(BgL_auxz00_3687); } 
if(BgL_testz00_3686)
{ /* ./Ast/shrinkify.scm 162 */
BgL_test3410z00_1435 = ((bool_t)1); }  else 
{ /* ./Ast/shrinkify.scm 162 */
BgL_test3410z00_1435 = ((bool_t)0); } } 
if(BgL_test3410z00_1435)
{ /* ./Ast/shrinkify.scm 162 */
{ /* ./Ast/shrinkify.scm 162 */
long BgL_arg3412z00_1437;
{ /* ./Ast/shrinkify.scm 162 */
obj_t BgL_arg3415z00_1438;
{ /* ./Ast/shrinkify.scm 162 */
obj_t BgL_arg3418z00_1439;
{ /* ./Ast/shrinkify.scm 162 */
BgL_objectz00_bglt BgL_objectz00_2584;
BgL_objectz00_2584 = 
(BgL_objectz00_bglt)(BgL_nodez00_1432); 
{ /* ./Ast/shrinkify.scm 162 */
long BgL_arg2007z00_2585;
{ /* ./Ast/shrinkify.scm 162 */
long BgL_arg2010z00_2586;
BgL_arg2010z00_2586 = 
BGL_OBJECT_CLASS_NUM(BgL_objectz00_2584); 
BgL_arg2007z00_2585 = 
(BgL_arg2010z00_2586-OBJECT_TYPE); } 
{ /* ./Ast/shrinkify.scm 162 */
obj_t BgL_vectorz00_2590;int BgL_kz00_2591;
BgL_vectorz00_2590 = BGl_za2classesza2z00zz__objectz00; 
BgL_kz00_2591 = 
(int)(BgL_arg2007z00_2585); 
BgL_arg3418z00_1439 = 
VECTOR_REF(BgL_vectorz00_2590,BgL_kz00_2591); } } } 
BgL_arg3415z00_1438 = 
BGl_classzd2superzd2zz__objectz00(BgL_arg3418z00_1439); } 
BgL_arg3412z00_1437 = 
BGl_classzd2numzd2zz__objectz00(BgL_arg3415z00_1438); } 
{ /* ./Ast/shrinkify.scm 162 */
BgL_objectz00_bglt BgL_objz00_2592;
BgL_objz00_2592 = 
(BgL_objectz00_bglt)(BgL_nodez00_1432); 
BGL_OBJECT_CLASS_NUM_SET(BgL_objz00_2592, BgL_arg3412z00_1437); } } 
{ /* ./Ast/shrinkify.scm 162 */
BgL_objectz00_bglt BgL_auxz00_3702;
BgL_auxz00_3702 = 
(BgL_objectz00_bglt)(BgL_nodez00_1432); 
BGL_OBJECT_WIDENING_SET(BgL_auxz00_3702, BFALSE); } 
(obj_t)(BgL_nodez00_1432); }  else 
{ /* ./Ast/shrinkify.scm 162 */BFALSE; } } 
{ /* ./Ast/shrinkify.scm 163 */
BgL_varz00_bglt BgL_arg3424z00_1440;
BgL_arg3424z00_1440 = 
(((BgL_boxzd2refzd2_bglt)CREF(BgL_nodez00_1432))->BgL_varz00); 
{ /* ./Ast/shrinkify.scm 163 */
obj_t BgL_res3659z00_2621;
{ /* ./Ast/shrinkify.scm 163 */
BgL_nodez00_bglt BgL_nodez00_2595;
BgL_nodez00_2595 = 
(BgL_nodez00_bglt)(BgL_arg3424z00_1440); 
{ /* ./Ast/shrinkify.scm 163 */
obj_t BgL_method2689z00_2596;
{ /* ./Ast/shrinkify.scm 163 */
BgL_objectz00_bglt BgL_objz00_2597;
BgL_objz00_2597 = 
(BgL_objectz00_bglt)(BgL_nodez00_2595); 
{ /* ./Ast/shrinkify.scm 163 */
long BgL_objzd2classzd2numz00_2598;
BgL_objzd2classzd2numz00_2598 = 
BGL_OBJECT_CLASS_NUM(BgL_objz00_2597); 
{ /* ./Ast/shrinkify.scm 163 */
obj_t BgL_arg1989z00_2599;
{ /* ./Ast/shrinkify.scm 163 */
int BgL_auxz00_3710;
BgL_auxz00_3710 = 
(int)(((long)1)); 
BgL_arg1989z00_2599 = 
PROCEDURE_REF(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, BgL_auxz00_3710); } 
{ /* ./Ast/shrinkify.scm 163 */
int BgL_offsetz00_2602;
BgL_offsetz00_2602 = 
(int)(BgL_objzd2classzd2numz00_2598); 
{ /* ./Ast/shrinkify.scm 163 */
long BgL_offsetz00_2603;
{ /* ./Ast/shrinkify.scm 163 */
long BgL_auxz00_3714;
BgL_auxz00_3714 = 
(long)(BgL_offsetz00_2602); 
BgL_offsetz00_2603 = 
(BgL_auxz00_3714-OBJECT_TYPE); } 
{ /* ./Ast/shrinkify.scm 163 */
long BgL_modz00_2604;
{ /* ./Ast/shrinkify.scm 163 */
int BgL_arg2000z00_2605;
BgL_arg2000z00_2605 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 163 */
long BgL_n2z00_2613;
BgL_n2z00_2613 = 
(long)(BgL_arg2000z00_2605); 
BgL_modz00_2604 = 
(BgL_offsetz00_2603/BgL_n2z00_2613); } } 
{ /* ./Ast/shrinkify.scm 163 */
long BgL_restz00_2606;
{ /* ./Ast/shrinkify.scm 163 */
int BgL_arg1996z00_2607;
BgL_arg1996z00_2607 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 163 */
long BgL_n2z00_2616;
BgL_n2z00_2616 = 
(long)(BgL_arg1996z00_2607); 
BgL_restz00_2606 = 
(BgL_offsetz00_2603%BgL_n2z00_2616); } } 
{ /* ./Ast/shrinkify.scm 163 */

{ /* ./Ast/shrinkify.scm 163 */
obj_t BgL_bucketz00_2608;
{ /* ./Ast/shrinkify.scm 163 */
int BgL_kz00_2618;
BgL_kz00_2618 = 
(int)(BgL_modz00_2604); 
BgL_bucketz00_2608 = 
VECTOR_REF(BgL_arg1989z00_2599,BgL_kz00_2618); } 
{ /* ./Ast/shrinkify.scm 163 */
int BgL_kz00_2620;
BgL_kz00_2620 = 
(int)(BgL_restz00_2606); 
BgL_method2689z00_2596 = 
VECTOR_REF(BgL_bucketz00_2608,BgL_kz00_2620); } } } } } } } } } } 
{ /* ./Ast/shrinkify.scm 163 */
obj_t BgL_xz00_3170;
BgL_xz00_3170 = 
PROCEDURE_ENTRY(BgL_method2689z00_2596)(BgL_method2689z00_2596, 
(obj_t)(BgL_nodez00_2595), BEOA); 
BgL_res3659z00_2621 = BUNSPEC; } } } BgL_res3659z00_2621; } } 
return BUNSPEC;} } 
}



/* shrink-node!-make-box2717 */
obj_t BGl_shrinkzd2nodez12zd2makezd2box2717zc0zzast_shrinkifyz00(obj_t BgL_envz00_3126, obj_t BgL_nodez00_3127)
{ AN_OBJECT;
{ /* ./Ast/shrinkify.scm 153 */
{ 
BgL_makezd2boxzd2_bglt BgL_nodez00_1421;
BgL_nodez00_1421 = 
(BgL_makezd2boxzd2_bglt)(BgL_nodez00_3127); 
{ /* ./Ast/shrinkify.scm 154 */
bool_t BgL_test3386z00_1424;
{ /* ./Ast/shrinkify.scm 154 */
bool_t BgL_testz00_3731;
{ /* ./Ast/shrinkify.scm 154 */
obj_t BgL_auxz00_3732;
{ /* ./Ast/shrinkify.scm 154 */
BgL_objectz00_bglt BgL_auxz00_3733;
BgL_auxz00_3733 = 
(BgL_objectz00_bglt)(BgL_nodez00_1421); 
BgL_auxz00_3732 = 
BGL_OBJECT_WIDENING(BgL_auxz00_3733); } 
BgL_testz00_3731 = 
CBOOL(BgL_auxz00_3732); } 
if(BgL_testz00_3731)
{ /* ./Ast/shrinkify.scm 154 */
BgL_test3386z00_1424 = ((bool_t)1); }  else 
{ /* ./Ast/shrinkify.scm 154 */
BgL_test3386z00_1424 = ((bool_t)0); } } 
if(BgL_test3386z00_1424)
{ /* ./Ast/shrinkify.scm 154 */
{ /* ./Ast/shrinkify.scm 154 */
long BgL_arg3388z00_1426;
{ /* ./Ast/shrinkify.scm 154 */
obj_t BgL_arg3391z00_1427;
{ /* ./Ast/shrinkify.scm 154 */
obj_t BgL_arg3395z00_1428;
{ /* ./Ast/shrinkify.scm 154 */
BgL_objectz00_bglt BgL_objectz00_2543;
BgL_objectz00_2543 = 
(BgL_objectz00_bglt)(BgL_nodez00_1421); 
{ /* ./Ast/shrinkify.scm 154 */
long BgL_arg2007z00_2544;
{ /* ./Ast/shrinkify.scm 154 */
long BgL_arg2010z00_2545;
BgL_arg2010z00_2545 = 
BGL_OBJECT_CLASS_NUM(BgL_objectz00_2543); 
BgL_arg2007z00_2544 = 
(BgL_arg2010z00_2545-OBJECT_TYPE); } 
{ /* ./Ast/shrinkify.scm 154 */
obj_t BgL_vectorz00_2549;int BgL_kz00_2550;
BgL_vectorz00_2549 = BGl_za2classesza2z00zz__objectz00; 
BgL_kz00_2550 = 
(int)(BgL_arg2007z00_2544); 
BgL_arg3395z00_1428 = 
VECTOR_REF(BgL_vectorz00_2549,BgL_kz00_2550); } } } 
BgL_arg3391z00_1427 = 
BGl_classzd2superzd2zz__objectz00(BgL_arg3395z00_1428); } 
BgL_arg3388z00_1426 = 
BGl_classzd2numzd2zz__objectz00(BgL_arg3391z00_1427); } 
{ /* ./Ast/shrinkify.scm 154 */
BgL_objectz00_bglt BgL_objz00_2551;
BgL_objz00_2551 = 
(BgL_objectz00_bglt)(BgL_nodez00_1421); 
BGL_OBJECT_CLASS_NUM_SET(BgL_objz00_2551, BgL_arg3388z00_1426); } } 
{ /* ./Ast/shrinkify.scm 154 */
BgL_objectz00_bglt BgL_auxz00_3747;
BgL_auxz00_3747 = 
(BgL_objectz00_bglt)(BgL_nodez00_1421); 
BGL_OBJECT_WIDENING_SET(BgL_auxz00_3747, BFALSE); } 
(obj_t)(BgL_nodez00_1421); }  else 
{ /* ./Ast/shrinkify.scm 154 */BFALSE; } } 
{ /* ./Ast/shrinkify.scm 155 */
BgL_nodez00_bglt BgL_arg3401z00_1429;
BgL_arg3401z00_1429 = 
(((BgL_makezd2boxzd2_bglt)CREF(BgL_nodez00_1421))->BgL_valuez00); 
{ /* ./Ast/shrinkify.scm 155 */
obj_t BgL_res3655z00_2580;
{ /* ./Ast/shrinkify.scm 155 */
obj_t BgL_method2689z00_2555;
{ /* ./Ast/shrinkify.scm 155 */
BgL_objectz00_bglt BgL_objz00_2556;
BgL_objz00_2556 = 
(BgL_objectz00_bglt)(BgL_arg3401z00_1429); 
{ /* ./Ast/shrinkify.scm 155 */
long BgL_objzd2classzd2numz00_2557;
BgL_objzd2classzd2numz00_2557 = 
BGL_OBJECT_CLASS_NUM(BgL_objz00_2556); 
{ /* ./Ast/shrinkify.scm 155 */
obj_t BgL_arg1989z00_2558;
{ /* ./Ast/shrinkify.scm 155 */
int BgL_auxz00_3754;
BgL_auxz00_3754 = 
(int)(((long)1)); 
BgL_arg1989z00_2558 = 
PROCEDURE_REF(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, BgL_auxz00_3754); } 
{ /* ./Ast/shrinkify.scm 155 */
int BgL_offsetz00_2561;
BgL_offsetz00_2561 = 
(int)(BgL_objzd2classzd2numz00_2557); 
{ /* ./Ast/shrinkify.scm 155 */
long BgL_offsetz00_2562;
{ /* ./Ast/shrinkify.scm 155 */
long BgL_auxz00_3758;
BgL_auxz00_3758 = 
(long)(BgL_offsetz00_2561); 
BgL_offsetz00_2562 = 
(BgL_auxz00_3758-OBJECT_TYPE); } 
{ /* ./Ast/shrinkify.scm 155 */
long BgL_modz00_2563;
{ /* ./Ast/shrinkify.scm 155 */
int BgL_arg2000z00_2564;
BgL_arg2000z00_2564 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 155 */
long BgL_n2z00_2572;
BgL_n2z00_2572 = 
(long)(BgL_arg2000z00_2564); 
BgL_modz00_2563 = 
(BgL_offsetz00_2562/BgL_n2z00_2572); } } 
{ /* ./Ast/shrinkify.scm 155 */
long BgL_restz00_2565;
{ /* ./Ast/shrinkify.scm 155 */
int BgL_arg1996z00_2566;
BgL_arg1996z00_2566 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 155 */
long BgL_n2z00_2575;
BgL_n2z00_2575 = 
(long)(BgL_arg1996z00_2566); 
BgL_restz00_2565 = 
(BgL_offsetz00_2562%BgL_n2z00_2575); } } 
{ /* ./Ast/shrinkify.scm 155 */

{ /* ./Ast/shrinkify.scm 155 */
obj_t BgL_bucketz00_2567;
{ /* ./Ast/shrinkify.scm 155 */
int BgL_kz00_2577;
BgL_kz00_2577 = 
(int)(BgL_modz00_2563); 
BgL_bucketz00_2567 = 
VECTOR_REF(BgL_arg1989z00_2558,BgL_kz00_2577); } 
{ /* ./Ast/shrinkify.scm 155 */
int BgL_kz00_2579;
BgL_kz00_2579 = 
(int)(BgL_restz00_2565); 
BgL_method2689z00_2555 = 
VECTOR_REF(BgL_bucketz00_2567,BgL_kz00_2579); } } } } } } } } } } 
{ /* ./Ast/shrinkify.scm 155 */
obj_t BgL_xz00_3171;
BgL_xz00_3171 = 
PROCEDURE_ENTRY(BgL_method2689z00_2555)(BgL_method2689z00_2555, 
(obj_t)(BgL_arg3401z00_1429), BEOA); 
BgL_res3655z00_2580 = BUNSPEC; } } BgL_res3655z00_2580; } } 
return BUNSPEC;} } 
}



/* shrink-node!-select2715 */
obj_t BGl_shrinkzd2nodez12zd2select2715z12zzast_shrinkifyz00(obj_t BgL_envz00_3128, obj_t BgL_nodez00_3129)
{ AN_OBJECT;
{ /* ./Ast/shrinkify.scm 143 */
{ 
BgL_selectz00_bglt BgL_nodez00_1408;
BgL_nodez00_1408 = 
(BgL_selectz00_bglt)(BgL_nodez00_3129); 
{ /* ./Ast/shrinkify.scm 144 */
BgL_nodez00_bglt BgL_arg3362z00_1411;
BgL_arg3362z00_1411 = 
(((BgL_selectz00_bglt)CREF(BgL_nodez00_1408))->BgL_testz00); 
{ /* ./Ast/shrinkify.scm 144 */
obj_t BgL_res3648z00_2507;
{ /* ./Ast/shrinkify.scm 144 */
obj_t BgL_method2689z00_2482;
{ /* ./Ast/shrinkify.scm 144 */
BgL_objectz00_bglt BgL_objz00_2483;
BgL_objz00_2483 = 
(BgL_objectz00_bglt)(BgL_arg3362z00_1411); 
{ /* ./Ast/shrinkify.scm 144 */
long BgL_objzd2classzd2numz00_2484;
BgL_objzd2classzd2numz00_2484 = 
BGL_OBJECT_CLASS_NUM(BgL_objz00_2483); 
{ /* ./Ast/shrinkify.scm 144 */
obj_t BgL_arg1989z00_2485;
{ /* ./Ast/shrinkify.scm 144 */
int BgL_auxz00_3778;
BgL_auxz00_3778 = 
(int)(((long)1)); 
BgL_arg1989z00_2485 = 
PROCEDURE_REF(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, BgL_auxz00_3778); } 
{ /* ./Ast/shrinkify.scm 144 */
int BgL_offsetz00_2488;
BgL_offsetz00_2488 = 
(int)(BgL_objzd2classzd2numz00_2484); 
{ /* ./Ast/shrinkify.scm 144 */
long BgL_offsetz00_2489;
{ /* ./Ast/shrinkify.scm 144 */
long BgL_auxz00_3782;
BgL_auxz00_3782 = 
(long)(BgL_offsetz00_2488); 
BgL_offsetz00_2489 = 
(BgL_auxz00_3782-OBJECT_TYPE); } 
{ /* ./Ast/shrinkify.scm 144 */
long BgL_modz00_2490;
{ /* ./Ast/shrinkify.scm 144 */
int BgL_arg2000z00_2491;
BgL_arg2000z00_2491 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 144 */
long BgL_n2z00_2499;
BgL_n2z00_2499 = 
(long)(BgL_arg2000z00_2491); 
BgL_modz00_2490 = 
(BgL_offsetz00_2489/BgL_n2z00_2499); } } 
{ /* ./Ast/shrinkify.scm 144 */
long BgL_restz00_2492;
{ /* ./Ast/shrinkify.scm 144 */
int BgL_arg1996z00_2493;
BgL_arg1996z00_2493 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 144 */
long BgL_n2z00_2502;
BgL_n2z00_2502 = 
(long)(BgL_arg1996z00_2493); 
BgL_restz00_2492 = 
(BgL_offsetz00_2489%BgL_n2z00_2502); } } 
{ /* ./Ast/shrinkify.scm 144 */

{ /* ./Ast/shrinkify.scm 144 */
obj_t BgL_bucketz00_2494;
{ /* ./Ast/shrinkify.scm 144 */
int BgL_kz00_2504;
BgL_kz00_2504 = 
(int)(BgL_modz00_2490); 
BgL_bucketz00_2494 = 
VECTOR_REF(BgL_arg1989z00_2485,BgL_kz00_2504); } 
{ /* ./Ast/shrinkify.scm 144 */
int BgL_kz00_2506;
BgL_kz00_2506 = 
(int)(BgL_restz00_2492); 
BgL_method2689z00_2482 = 
VECTOR_REF(BgL_bucketz00_2494,BgL_kz00_2506); } } } } } } } } } } 
{ /* ./Ast/shrinkify.scm 144 */
obj_t BgL_xz00_3172;
BgL_xz00_3172 = 
PROCEDURE_ENTRY(BgL_method2689z00_2482)(BgL_method2689z00_2482, 
(obj_t)(BgL_arg3362z00_1411), BEOA); 
BgL_res3648z00_2507 = BUNSPEC; } } BgL_res3648z00_2507; } } 
{ 
obj_t BgL_l2665z00_1412;
{ /* ./Ast/shrinkify.scm 147 */
obj_t BgL_arg3366z00_1414;
BgL_arg3366z00_1414 = 
(((BgL_selectz00_bglt)CREF(BgL_nodez00_1408))->BgL_clausesz00); 
BgL_l2665z00_1412 = BgL_arg3366z00_1414; 
BgL_forzd2each2666zd2_1413:
{ /* ./Ast/shrinkify.scm 145 */
bool_t BgL_test3369z00_1415;
BgL_test3369z00_1415 = 
PAIRP(BgL_l2665z00_1412); 
if(BgL_test3369z00_1415)
{ /* ./Ast/shrinkify.scm 145 */
{ /* ./Ast/shrinkify.scm 146 */
obj_t BgL_clausez00_1416;
BgL_clausez00_1416 = 
CAR(BgL_l2665z00_1412); 
{ /* ./Ast/shrinkify.scm 146 */
obj_t BgL_arg3371z00_1417;
BgL_arg3371z00_1417 = 
CDR(BgL_clausez00_1416); 
{ /* ./Ast/shrinkify.scm 146 */
obj_t BgL_res3651z00_2538;
{ /* ./Ast/shrinkify.scm 146 */
BgL_nodez00_bglt BgL_nodez00_2512;
BgL_nodez00_2512 = 
(BgL_nodez00_bglt)(BgL_arg3371z00_1417); 
{ /* ./Ast/shrinkify.scm 146 */
obj_t BgL_method2689z00_2513;
{ /* ./Ast/shrinkify.scm 146 */
BgL_objectz00_bglt BgL_objz00_2514;
BgL_objz00_2514 = 
(BgL_objectz00_bglt)(BgL_nodez00_2512); 
{ /* ./Ast/shrinkify.scm 146 */
long BgL_objzd2classzd2numz00_2515;
BgL_objzd2classzd2numz00_2515 = 
BGL_OBJECT_CLASS_NUM(BgL_objz00_2514); 
{ /* ./Ast/shrinkify.scm 146 */
obj_t BgL_arg1989z00_2516;
{ /* ./Ast/shrinkify.scm 146 */
int BgL_auxz00_3806;
BgL_auxz00_3806 = 
(int)(((long)1)); 
BgL_arg1989z00_2516 = 
PROCEDURE_REF(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, BgL_auxz00_3806); } 
{ /* ./Ast/shrinkify.scm 146 */
int BgL_offsetz00_2519;
BgL_offsetz00_2519 = 
(int)(BgL_objzd2classzd2numz00_2515); 
{ /* ./Ast/shrinkify.scm 146 */
long BgL_offsetz00_2520;
{ /* ./Ast/shrinkify.scm 146 */
long BgL_auxz00_3810;
BgL_auxz00_3810 = 
(long)(BgL_offsetz00_2519); 
BgL_offsetz00_2520 = 
(BgL_auxz00_3810-OBJECT_TYPE); } 
{ /* ./Ast/shrinkify.scm 146 */
long BgL_modz00_2521;
{ /* ./Ast/shrinkify.scm 146 */
int BgL_arg2000z00_2522;
BgL_arg2000z00_2522 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 146 */
long BgL_n2z00_2530;
BgL_n2z00_2530 = 
(long)(BgL_arg2000z00_2522); 
BgL_modz00_2521 = 
(BgL_offsetz00_2520/BgL_n2z00_2530); } } 
{ /* ./Ast/shrinkify.scm 146 */
long BgL_restz00_2523;
{ /* ./Ast/shrinkify.scm 146 */
int BgL_arg1996z00_2524;
BgL_arg1996z00_2524 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 146 */
long BgL_n2z00_2533;
BgL_n2z00_2533 = 
(long)(BgL_arg1996z00_2524); 
BgL_restz00_2523 = 
(BgL_offsetz00_2520%BgL_n2z00_2533); } } 
{ /* ./Ast/shrinkify.scm 146 */

{ /* ./Ast/shrinkify.scm 146 */
obj_t BgL_bucketz00_2525;
{ /* ./Ast/shrinkify.scm 146 */
int BgL_kz00_2535;
BgL_kz00_2535 = 
(int)(BgL_modz00_2521); 
BgL_bucketz00_2525 = 
VECTOR_REF(BgL_arg1989z00_2516,BgL_kz00_2535); } 
{ /* ./Ast/shrinkify.scm 146 */
int BgL_kz00_2537;
BgL_kz00_2537 = 
(int)(BgL_restz00_2523); 
BgL_method2689z00_2513 = 
VECTOR_REF(BgL_bucketz00_2525,BgL_kz00_2537); } } } } } } } } } } 
{ /* ./Ast/shrinkify.scm 146 */
obj_t BgL_xz00_3173;
BgL_xz00_3173 = 
PROCEDURE_ENTRY(BgL_method2689z00_2513)(BgL_method2689z00_2513, 
(obj_t)(BgL_nodez00_2512), BEOA); 
BgL_res3651z00_2538 = BUNSPEC; } } } BgL_res3651z00_2538; } } } 
{ /* ./Ast/shrinkify.scm 145 */
obj_t BgL_arg3376z00_1418;
BgL_arg3376z00_1418 = 
CDR(BgL_l2665z00_1412); 
{ 
obj_t BgL_l2665z00_3827;
BgL_l2665z00_3827 = BgL_arg3376z00_1418; 
BgL_l2665z00_1412 = BgL_l2665z00_3827; 
goto BgL_forzd2each2666zd2_1413;} } }  else 
{ /* ./Ast/shrinkify.scm 145 */((bool_t)1); } } } } 
return BUNSPEC;} } 
}



/* shrink-node!-fail2713 */
obj_t BGl_shrinkzd2nodez12zd2fail2713z12zzast_shrinkifyz00(obj_t BgL_envz00_3130, obj_t BgL_nodez00_3131)
{ AN_OBJECT;
{ /* ./Ast/shrinkify.scm 134 */
{ 
BgL_failz00_bglt BgL_nodez00_1400;
BgL_nodez00_1400 = 
(BgL_failz00_bglt)(BgL_nodez00_3131); 
{ /* ./Ast/shrinkify.scm 135 */
BgL_nodez00_bglt BgL_arg3344z00_1403;
BgL_arg3344z00_1403 = 
(((BgL_failz00_bglt)CREF(BgL_nodez00_1400))->BgL_procz00); 
{ /* ./Ast/shrinkify.scm 135 */
obj_t BgL_res3639z00_2423;
{ /* ./Ast/shrinkify.scm 135 */
obj_t BgL_method2689z00_2398;
{ /* ./Ast/shrinkify.scm 135 */
BgL_objectz00_bglt BgL_objz00_2399;
BgL_objz00_2399 = 
(BgL_objectz00_bglt)(BgL_arg3344z00_1403); 
{ /* ./Ast/shrinkify.scm 135 */
long BgL_objzd2classzd2numz00_2400;
BgL_objzd2classzd2numz00_2400 = 
BGL_OBJECT_CLASS_NUM(BgL_objz00_2399); 
{ /* ./Ast/shrinkify.scm 135 */
obj_t BgL_arg1989z00_2401;
{ /* ./Ast/shrinkify.scm 135 */
int BgL_auxz00_3832;
BgL_auxz00_3832 = 
(int)(((long)1)); 
BgL_arg1989z00_2401 = 
PROCEDURE_REF(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, BgL_auxz00_3832); } 
{ /* ./Ast/shrinkify.scm 135 */
int BgL_offsetz00_2404;
BgL_offsetz00_2404 = 
(int)(BgL_objzd2classzd2numz00_2400); 
{ /* ./Ast/shrinkify.scm 135 */
long BgL_offsetz00_2405;
{ /* ./Ast/shrinkify.scm 135 */
long BgL_auxz00_3836;
BgL_auxz00_3836 = 
(long)(BgL_offsetz00_2404); 
BgL_offsetz00_2405 = 
(BgL_auxz00_3836-OBJECT_TYPE); } 
{ /* ./Ast/shrinkify.scm 135 */
long BgL_modz00_2406;
{ /* ./Ast/shrinkify.scm 135 */
int BgL_arg2000z00_2407;
BgL_arg2000z00_2407 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 135 */
long BgL_n2z00_2415;
BgL_n2z00_2415 = 
(long)(BgL_arg2000z00_2407); 
BgL_modz00_2406 = 
(BgL_offsetz00_2405/BgL_n2z00_2415); } } 
{ /* ./Ast/shrinkify.scm 135 */
long BgL_restz00_2408;
{ /* ./Ast/shrinkify.scm 135 */
int BgL_arg1996z00_2409;
BgL_arg1996z00_2409 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 135 */
long BgL_n2z00_2418;
BgL_n2z00_2418 = 
(long)(BgL_arg1996z00_2409); 
BgL_restz00_2408 = 
(BgL_offsetz00_2405%BgL_n2z00_2418); } } 
{ /* ./Ast/shrinkify.scm 135 */

{ /* ./Ast/shrinkify.scm 135 */
obj_t BgL_bucketz00_2410;
{ /* ./Ast/shrinkify.scm 135 */
int BgL_kz00_2420;
BgL_kz00_2420 = 
(int)(BgL_modz00_2406); 
BgL_bucketz00_2410 = 
VECTOR_REF(BgL_arg1989z00_2401,BgL_kz00_2420); } 
{ /* ./Ast/shrinkify.scm 135 */
int BgL_kz00_2422;
BgL_kz00_2422 = 
(int)(BgL_restz00_2408); 
BgL_method2689z00_2398 = 
VECTOR_REF(BgL_bucketz00_2410,BgL_kz00_2422); } } } } } } } } } } 
{ /* ./Ast/shrinkify.scm 135 */
obj_t BgL_xz00_3174;
BgL_xz00_3174 = 
PROCEDURE_ENTRY(BgL_method2689z00_2398)(BgL_method2689z00_2398, 
(obj_t)(BgL_arg3344z00_1403), BEOA); 
BgL_res3639z00_2423 = BUNSPEC; } } BgL_res3639z00_2423; } } 
{ /* ./Ast/shrinkify.scm 136 */
BgL_nodez00_bglt BgL_arg3348z00_1404;
BgL_arg3348z00_1404 = 
(((BgL_failz00_bglt)CREF(BgL_nodez00_1400))->BgL_msgz00); 
{ /* ./Ast/shrinkify.scm 136 */
obj_t BgL_res3642z00_2451;
{ /* ./Ast/shrinkify.scm 136 */
obj_t BgL_method2689z00_2426;
{ /* ./Ast/shrinkify.scm 136 */
BgL_objectz00_bglt BgL_objz00_2427;
BgL_objz00_2427 = 
(BgL_objectz00_bglt)(BgL_arg3348z00_1404); 
{ /* ./Ast/shrinkify.scm 136 */
long BgL_objzd2classzd2numz00_2428;
BgL_objzd2classzd2numz00_2428 = 
BGL_OBJECT_CLASS_NUM(BgL_objz00_2427); 
{ /* ./Ast/shrinkify.scm 136 */
obj_t BgL_arg1989z00_2429;
{ /* ./Ast/shrinkify.scm 136 */
int BgL_auxz00_3855;
BgL_auxz00_3855 = 
(int)(((long)1)); 
BgL_arg1989z00_2429 = 
PROCEDURE_REF(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, BgL_auxz00_3855); } 
{ /* ./Ast/shrinkify.scm 136 */
int BgL_offsetz00_2432;
BgL_offsetz00_2432 = 
(int)(BgL_objzd2classzd2numz00_2428); 
{ /* ./Ast/shrinkify.scm 136 */
long BgL_offsetz00_2433;
{ /* ./Ast/shrinkify.scm 136 */
long BgL_auxz00_3859;
BgL_auxz00_3859 = 
(long)(BgL_offsetz00_2432); 
BgL_offsetz00_2433 = 
(BgL_auxz00_3859-OBJECT_TYPE); } 
{ /* ./Ast/shrinkify.scm 136 */
long BgL_modz00_2434;
{ /* ./Ast/shrinkify.scm 136 */
int BgL_arg2000z00_2435;
BgL_arg2000z00_2435 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 136 */
long BgL_n2z00_2443;
BgL_n2z00_2443 = 
(long)(BgL_arg2000z00_2435); 
BgL_modz00_2434 = 
(BgL_offsetz00_2433/BgL_n2z00_2443); } } 
{ /* ./Ast/shrinkify.scm 136 */
long BgL_restz00_2436;
{ /* ./Ast/shrinkify.scm 136 */
int BgL_arg1996z00_2437;
BgL_arg1996z00_2437 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 136 */
long BgL_n2z00_2446;
BgL_n2z00_2446 = 
(long)(BgL_arg1996z00_2437); 
BgL_restz00_2436 = 
(BgL_offsetz00_2433%BgL_n2z00_2446); } } 
{ /* ./Ast/shrinkify.scm 136 */

{ /* ./Ast/shrinkify.scm 136 */
obj_t BgL_bucketz00_2438;
{ /* ./Ast/shrinkify.scm 136 */
int BgL_kz00_2448;
BgL_kz00_2448 = 
(int)(BgL_modz00_2434); 
BgL_bucketz00_2438 = 
VECTOR_REF(BgL_arg1989z00_2429,BgL_kz00_2448); } 
{ /* ./Ast/shrinkify.scm 136 */
int BgL_kz00_2450;
BgL_kz00_2450 = 
(int)(BgL_restz00_2436); 
BgL_method2689z00_2426 = 
VECTOR_REF(BgL_bucketz00_2438,BgL_kz00_2450); } } } } } } } } } } 
{ /* ./Ast/shrinkify.scm 136 */
obj_t BgL_xz00_3175;
BgL_xz00_3175 = 
PROCEDURE_ENTRY(BgL_method2689z00_2426)(BgL_method2689z00_2426, 
(obj_t)(BgL_arg3348z00_1404), BEOA); 
BgL_res3642z00_2451 = BUNSPEC; } } BgL_res3642z00_2451; } } 
{ /* ./Ast/shrinkify.scm 137 */
BgL_nodez00_bglt BgL_arg3352z00_1405;
BgL_arg3352z00_1405 = 
(((BgL_failz00_bglt)CREF(BgL_nodez00_1400))->BgL_objz00); 
{ /* ./Ast/shrinkify.scm 137 */
obj_t BgL_res3645z00_2479;
{ /* ./Ast/shrinkify.scm 137 */
obj_t BgL_method2689z00_2454;
{ /* ./Ast/shrinkify.scm 137 */
BgL_objectz00_bglt BgL_objz00_2455;
BgL_objz00_2455 = 
(BgL_objectz00_bglt)(BgL_arg3352z00_1405); 
{ /* ./Ast/shrinkify.scm 137 */
long BgL_objzd2classzd2numz00_2456;
BgL_objzd2classzd2numz00_2456 = 
BGL_OBJECT_CLASS_NUM(BgL_objz00_2455); 
{ /* ./Ast/shrinkify.scm 137 */
obj_t BgL_arg1989z00_2457;
{ /* ./Ast/shrinkify.scm 137 */
int BgL_auxz00_3878;
BgL_auxz00_3878 = 
(int)(((long)1)); 
BgL_arg1989z00_2457 = 
PROCEDURE_REF(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, BgL_auxz00_3878); } 
{ /* ./Ast/shrinkify.scm 137 */
int BgL_offsetz00_2460;
BgL_offsetz00_2460 = 
(int)(BgL_objzd2classzd2numz00_2456); 
{ /* ./Ast/shrinkify.scm 137 */
long BgL_offsetz00_2461;
{ /* ./Ast/shrinkify.scm 137 */
long BgL_auxz00_3882;
BgL_auxz00_3882 = 
(long)(BgL_offsetz00_2460); 
BgL_offsetz00_2461 = 
(BgL_auxz00_3882-OBJECT_TYPE); } 
{ /* ./Ast/shrinkify.scm 137 */
long BgL_modz00_2462;
{ /* ./Ast/shrinkify.scm 137 */
int BgL_arg2000z00_2463;
BgL_arg2000z00_2463 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 137 */
long BgL_n2z00_2471;
BgL_n2z00_2471 = 
(long)(BgL_arg2000z00_2463); 
BgL_modz00_2462 = 
(BgL_offsetz00_2461/BgL_n2z00_2471); } } 
{ /* ./Ast/shrinkify.scm 137 */
long BgL_restz00_2464;
{ /* ./Ast/shrinkify.scm 137 */
int BgL_arg1996z00_2465;
BgL_arg1996z00_2465 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 137 */
long BgL_n2z00_2474;
BgL_n2z00_2474 = 
(long)(BgL_arg1996z00_2465); 
BgL_restz00_2464 = 
(BgL_offsetz00_2461%BgL_n2z00_2474); } } 
{ /* ./Ast/shrinkify.scm 137 */

{ /* ./Ast/shrinkify.scm 137 */
obj_t BgL_bucketz00_2466;
{ /* ./Ast/shrinkify.scm 137 */
int BgL_kz00_2476;
BgL_kz00_2476 = 
(int)(BgL_modz00_2462); 
BgL_bucketz00_2466 = 
VECTOR_REF(BgL_arg1989z00_2457,BgL_kz00_2476); } 
{ /* ./Ast/shrinkify.scm 137 */
int BgL_kz00_2478;
BgL_kz00_2478 = 
(int)(BgL_restz00_2464); 
BgL_method2689z00_2454 = 
VECTOR_REF(BgL_bucketz00_2466,BgL_kz00_2478); } } } } } } } } } } 
{ /* ./Ast/shrinkify.scm 137 */
obj_t BgL_xz00_3176;
BgL_xz00_3176 = 
PROCEDURE_ENTRY(BgL_method2689z00_2454)(BgL_method2689z00_2454, 
(obj_t)(BgL_arg3352z00_1405), BEOA); 
BgL_res3645z00_2479 = BUNSPEC; } } BgL_res3645z00_2479; } } 
return BUNSPEC;} } 
}



/* shrink-node!-conditional2711 */
obj_t BGl_shrinkzd2nodez12zd2conditional2711z12zzast_shrinkifyz00(obj_t BgL_envz00_3132, obj_t BgL_nodez00_3133)
{ AN_OBJECT;
{ /* ./Ast/shrinkify.scm 125 */
{ 
BgL_conditionalz00_bglt BgL_nodez00_1392;
BgL_nodez00_1392 = 
(BgL_conditionalz00_bglt)(BgL_nodez00_3133); 
{ /* ./Ast/shrinkify.scm 126 */
BgL_nodez00_bglt BgL_arg3326z00_1395;
BgL_arg3326z00_1395 = 
(((BgL_conditionalz00_bglt)CREF(BgL_nodez00_1392))->BgL_testz00); 
{ /* ./Ast/shrinkify.scm 126 */
obj_t BgL_res3630z00_2339;
{ /* ./Ast/shrinkify.scm 126 */
obj_t BgL_method2689z00_2314;
{ /* ./Ast/shrinkify.scm 126 */
BgL_objectz00_bglt BgL_objz00_2315;
BgL_objz00_2315 = 
(BgL_objectz00_bglt)(BgL_arg3326z00_1395); 
{ /* ./Ast/shrinkify.scm 126 */
long BgL_objzd2classzd2numz00_2316;
BgL_objzd2classzd2numz00_2316 = 
BGL_OBJECT_CLASS_NUM(BgL_objz00_2315); 
{ /* ./Ast/shrinkify.scm 126 */
obj_t BgL_arg1989z00_2317;
{ /* ./Ast/shrinkify.scm 126 */
int BgL_auxz00_3902;
BgL_auxz00_3902 = 
(int)(((long)1)); 
BgL_arg1989z00_2317 = 
PROCEDURE_REF(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, BgL_auxz00_3902); } 
{ /* ./Ast/shrinkify.scm 126 */
int BgL_offsetz00_2320;
BgL_offsetz00_2320 = 
(int)(BgL_objzd2classzd2numz00_2316); 
{ /* ./Ast/shrinkify.scm 126 */
long BgL_offsetz00_2321;
{ /* ./Ast/shrinkify.scm 126 */
long BgL_auxz00_3906;
BgL_auxz00_3906 = 
(long)(BgL_offsetz00_2320); 
BgL_offsetz00_2321 = 
(BgL_auxz00_3906-OBJECT_TYPE); } 
{ /* ./Ast/shrinkify.scm 126 */
long BgL_modz00_2322;
{ /* ./Ast/shrinkify.scm 126 */
int BgL_arg2000z00_2323;
BgL_arg2000z00_2323 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 126 */
long BgL_n2z00_2331;
BgL_n2z00_2331 = 
(long)(BgL_arg2000z00_2323); 
BgL_modz00_2322 = 
(BgL_offsetz00_2321/BgL_n2z00_2331); } } 
{ /* ./Ast/shrinkify.scm 126 */
long BgL_restz00_2324;
{ /* ./Ast/shrinkify.scm 126 */
int BgL_arg1996z00_2325;
BgL_arg1996z00_2325 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 126 */
long BgL_n2z00_2334;
BgL_n2z00_2334 = 
(long)(BgL_arg1996z00_2325); 
BgL_restz00_2324 = 
(BgL_offsetz00_2321%BgL_n2z00_2334); } } 
{ /* ./Ast/shrinkify.scm 126 */

{ /* ./Ast/shrinkify.scm 126 */
obj_t BgL_bucketz00_2326;
{ /* ./Ast/shrinkify.scm 126 */
int BgL_kz00_2336;
BgL_kz00_2336 = 
(int)(BgL_modz00_2322); 
BgL_bucketz00_2326 = 
VECTOR_REF(BgL_arg1989z00_2317,BgL_kz00_2336); } 
{ /* ./Ast/shrinkify.scm 126 */
int BgL_kz00_2338;
BgL_kz00_2338 = 
(int)(BgL_restz00_2324); 
BgL_method2689z00_2314 = 
VECTOR_REF(BgL_bucketz00_2326,BgL_kz00_2338); } } } } } } } } } } 
{ /* ./Ast/shrinkify.scm 126 */
obj_t BgL_xz00_3177;
BgL_xz00_3177 = 
PROCEDURE_ENTRY(BgL_method2689z00_2314)(BgL_method2689z00_2314, 
(obj_t)(BgL_arg3326z00_1395), BEOA); 
BgL_res3630z00_2339 = BUNSPEC; } } BgL_res3630z00_2339; } } 
{ /* ./Ast/shrinkify.scm 127 */
BgL_nodez00_bglt BgL_arg3330z00_1396;
BgL_arg3330z00_1396 = 
(((BgL_conditionalz00_bglt)CREF(BgL_nodez00_1392))->BgL_truez00); 
{ /* ./Ast/shrinkify.scm 127 */
obj_t BgL_res3633z00_2367;
{ /* ./Ast/shrinkify.scm 127 */
obj_t BgL_method2689z00_2342;
{ /* ./Ast/shrinkify.scm 127 */
BgL_objectz00_bglt BgL_objz00_2343;
BgL_objz00_2343 = 
(BgL_objectz00_bglt)(BgL_arg3330z00_1396); 
{ /* ./Ast/shrinkify.scm 127 */
long BgL_objzd2classzd2numz00_2344;
BgL_objzd2classzd2numz00_2344 = 
BGL_OBJECT_CLASS_NUM(BgL_objz00_2343); 
{ /* ./Ast/shrinkify.scm 127 */
obj_t BgL_arg1989z00_2345;
{ /* ./Ast/shrinkify.scm 127 */
int BgL_auxz00_3925;
BgL_auxz00_3925 = 
(int)(((long)1)); 
BgL_arg1989z00_2345 = 
PROCEDURE_REF(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, BgL_auxz00_3925); } 
{ /* ./Ast/shrinkify.scm 127 */
int BgL_offsetz00_2348;
BgL_offsetz00_2348 = 
(int)(BgL_objzd2classzd2numz00_2344); 
{ /* ./Ast/shrinkify.scm 127 */
long BgL_offsetz00_2349;
{ /* ./Ast/shrinkify.scm 127 */
long BgL_auxz00_3929;
BgL_auxz00_3929 = 
(long)(BgL_offsetz00_2348); 
BgL_offsetz00_2349 = 
(BgL_auxz00_3929-OBJECT_TYPE); } 
{ /* ./Ast/shrinkify.scm 127 */
long BgL_modz00_2350;
{ /* ./Ast/shrinkify.scm 127 */
int BgL_arg2000z00_2351;
BgL_arg2000z00_2351 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 127 */
long BgL_n2z00_2359;
BgL_n2z00_2359 = 
(long)(BgL_arg2000z00_2351); 
BgL_modz00_2350 = 
(BgL_offsetz00_2349/BgL_n2z00_2359); } } 
{ /* ./Ast/shrinkify.scm 127 */
long BgL_restz00_2352;
{ /* ./Ast/shrinkify.scm 127 */
int BgL_arg1996z00_2353;
BgL_arg1996z00_2353 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 127 */
long BgL_n2z00_2362;
BgL_n2z00_2362 = 
(long)(BgL_arg1996z00_2353); 
BgL_restz00_2352 = 
(BgL_offsetz00_2349%BgL_n2z00_2362); } } 
{ /* ./Ast/shrinkify.scm 127 */

{ /* ./Ast/shrinkify.scm 127 */
obj_t BgL_bucketz00_2354;
{ /* ./Ast/shrinkify.scm 127 */
int BgL_kz00_2364;
BgL_kz00_2364 = 
(int)(BgL_modz00_2350); 
BgL_bucketz00_2354 = 
VECTOR_REF(BgL_arg1989z00_2345,BgL_kz00_2364); } 
{ /* ./Ast/shrinkify.scm 127 */
int BgL_kz00_2366;
BgL_kz00_2366 = 
(int)(BgL_restz00_2352); 
BgL_method2689z00_2342 = 
VECTOR_REF(BgL_bucketz00_2354,BgL_kz00_2366); } } } } } } } } } } 
{ /* ./Ast/shrinkify.scm 127 */
obj_t BgL_xz00_3178;
BgL_xz00_3178 = 
PROCEDURE_ENTRY(BgL_method2689z00_2342)(BgL_method2689z00_2342, 
(obj_t)(BgL_arg3330z00_1396), BEOA); 
BgL_res3633z00_2367 = BUNSPEC; } } BgL_res3633z00_2367; } } 
{ /* ./Ast/shrinkify.scm 128 */
BgL_nodez00_bglt BgL_arg3334z00_1397;
BgL_arg3334z00_1397 = 
(((BgL_conditionalz00_bglt)CREF(BgL_nodez00_1392))->BgL_falsez00); 
{ /* ./Ast/shrinkify.scm 128 */
obj_t BgL_res3636z00_2395;
{ /* ./Ast/shrinkify.scm 128 */
obj_t BgL_method2689z00_2370;
{ /* ./Ast/shrinkify.scm 128 */
BgL_objectz00_bglt BgL_objz00_2371;
BgL_objz00_2371 = 
(BgL_objectz00_bglt)(BgL_arg3334z00_1397); 
{ /* ./Ast/shrinkify.scm 128 */
long BgL_objzd2classzd2numz00_2372;
BgL_objzd2classzd2numz00_2372 = 
BGL_OBJECT_CLASS_NUM(BgL_objz00_2371); 
{ /* ./Ast/shrinkify.scm 128 */
obj_t BgL_arg1989z00_2373;
{ /* ./Ast/shrinkify.scm 128 */
int BgL_auxz00_3948;
BgL_auxz00_3948 = 
(int)(((long)1)); 
BgL_arg1989z00_2373 = 
PROCEDURE_REF(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, BgL_auxz00_3948); } 
{ /* ./Ast/shrinkify.scm 128 */
int BgL_offsetz00_2376;
BgL_offsetz00_2376 = 
(int)(BgL_objzd2classzd2numz00_2372); 
{ /* ./Ast/shrinkify.scm 128 */
long BgL_offsetz00_2377;
{ /* ./Ast/shrinkify.scm 128 */
long BgL_auxz00_3952;
BgL_auxz00_3952 = 
(long)(BgL_offsetz00_2376); 
BgL_offsetz00_2377 = 
(BgL_auxz00_3952-OBJECT_TYPE); } 
{ /* ./Ast/shrinkify.scm 128 */
long BgL_modz00_2378;
{ /* ./Ast/shrinkify.scm 128 */
int BgL_arg2000z00_2379;
BgL_arg2000z00_2379 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 128 */
long BgL_n2z00_2387;
BgL_n2z00_2387 = 
(long)(BgL_arg2000z00_2379); 
BgL_modz00_2378 = 
(BgL_offsetz00_2377/BgL_n2z00_2387); } } 
{ /* ./Ast/shrinkify.scm 128 */
long BgL_restz00_2380;
{ /* ./Ast/shrinkify.scm 128 */
int BgL_arg1996z00_2381;
BgL_arg1996z00_2381 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 128 */
long BgL_n2z00_2390;
BgL_n2z00_2390 = 
(long)(BgL_arg1996z00_2381); 
BgL_restz00_2380 = 
(BgL_offsetz00_2377%BgL_n2z00_2390); } } 
{ /* ./Ast/shrinkify.scm 128 */

{ /* ./Ast/shrinkify.scm 128 */
obj_t BgL_bucketz00_2382;
{ /* ./Ast/shrinkify.scm 128 */
int BgL_kz00_2392;
BgL_kz00_2392 = 
(int)(BgL_modz00_2378); 
BgL_bucketz00_2382 = 
VECTOR_REF(BgL_arg1989z00_2373,BgL_kz00_2392); } 
{ /* ./Ast/shrinkify.scm 128 */
int BgL_kz00_2394;
BgL_kz00_2394 = 
(int)(BgL_restz00_2380); 
BgL_method2689z00_2370 = 
VECTOR_REF(BgL_bucketz00_2382,BgL_kz00_2394); } } } } } } } } } } 
{ /* ./Ast/shrinkify.scm 128 */
obj_t BgL_xz00_3179;
BgL_xz00_3179 = 
PROCEDURE_ENTRY(BgL_method2689z00_2370)(BgL_method2689z00_2370, 
(obj_t)(BgL_arg3334z00_1397), BEOA); 
BgL_res3636z00_2395 = BUNSPEC; } } BgL_res3636z00_2395; } } 
return BUNSPEC;} } 
}



/* shrink-node!-setq2709 */
obj_t BGl_shrinkzd2nodez12zd2setq2709z12zzast_shrinkifyz00(obj_t BgL_envz00_3134, obj_t BgL_nodez00_3135)
{ AN_OBJECT;
{ /* ./Ast/shrinkify.scm 118 */
{ 
BgL_setqz00_bglt BgL_nodez00_1386;
BgL_nodez00_1386 = 
(BgL_setqz00_bglt)(BgL_nodez00_3135); 
{ /* ./Ast/shrinkify.scm 119 */
BgL_nodez00_bglt BgL_arg3316z00_2283;
BgL_arg3316z00_2283 = 
(((BgL_setqz00_bglt)CREF(BgL_nodez00_1386))->BgL_valuez00); 
{ /* ./Ast/shrinkify.scm 119 */
obj_t BgL_res3627z00_2311;
{ /* ./Ast/shrinkify.scm 119 */
obj_t BgL_method2689z00_2286;
{ /* ./Ast/shrinkify.scm 119 */
BgL_objectz00_bglt BgL_objz00_2287;
BgL_objz00_2287 = 
(BgL_objectz00_bglt)(BgL_arg3316z00_2283); 
{ /* ./Ast/shrinkify.scm 119 */
long BgL_objzd2classzd2numz00_2288;
BgL_objzd2classzd2numz00_2288 = 
BGL_OBJECT_CLASS_NUM(BgL_objz00_2287); 
{ /* ./Ast/shrinkify.scm 119 */
obj_t BgL_arg1989z00_2289;
{ /* ./Ast/shrinkify.scm 119 */
int BgL_auxz00_3972;
BgL_auxz00_3972 = 
(int)(((long)1)); 
BgL_arg1989z00_2289 = 
PROCEDURE_REF(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, BgL_auxz00_3972); } 
{ /* ./Ast/shrinkify.scm 119 */
int BgL_offsetz00_2292;
BgL_offsetz00_2292 = 
(int)(BgL_objzd2classzd2numz00_2288); 
{ /* ./Ast/shrinkify.scm 119 */
long BgL_offsetz00_2293;
{ /* ./Ast/shrinkify.scm 119 */
long BgL_auxz00_3976;
BgL_auxz00_3976 = 
(long)(BgL_offsetz00_2292); 
BgL_offsetz00_2293 = 
(BgL_auxz00_3976-OBJECT_TYPE); } 
{ /* ./Ast/shrinkify.scm 119 */
long BgL_modz00_2294;
{ /* ./Ast/shrinkify.scm 119 */
int BgL_arg2000z00_2295;
BgL_arg2000z00_2295 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 119 */
long BgL_n2z00_2303;
BgL_n2z00_2303 = 
(long)(BgL_arg2000z00_2295); 
BgL_modz00_2294 = 
(BgL_offsetz00_2293/BgL_n2z00_2303); } } 
{ /* ./Ast/shrinkify.scm 119 */
long BgL_restz00_2296;
{ /* ./Ast/shrinkify.scm 119 */
int BgL_arg1996z00_2297;
BgL_arg1996z00_2297 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 119 */
long BgL_n2z00_2306;
BgL_n2z00_2306 = 
(long)(BgL_arg1996z00_2297); 
BgL_restz00_2296 = 
(BgL_offsetz00_2293%BgL_n2z00_2306); } } 
{ /* ./Ast/shrinkify.scm 119 */

{ /* ./Ast/shrinkify.scm 119 */
obj_t BgL_bucketz00_2298;
{ /* ./Ast/shrinkify.scm 119 */
int BgL_kz00_2308;
BgL_kz00_2308 = 
(int)(BgL_modz00_2294); 
BgL_bucketz00_2298 = 
VECTOR_REF(BgL_arg1989z00_2289,BgL_kz00_2308); } 
{ /* ./Ast/shrinkify.scm 119 */
int BgL_kz00_2310;
BgL_kz00_2310 = 
(int)(BgL_restz00_2296); 
BgL_method2689z00_2286 = 
VECTOR_REF(BgL_bucketz00_2298,BgL_kz00_2310); } } } } } } } } } } 
{ /* ./Ast/shrinkify.scm 119 */
obj_t BgL_xz00_3180;
BgL_xz00_3180 = 
PROCEDURE_ENTRY(BgL_method2689z00_2286)(BgL_method2689z00_2286, 
(obj_t)(BgL_arg3316z00_2283), BEOA); 
BgL_res3627z00_2311 = BUNSPEC; } } BgL_res3627z00_2311; } } 
return BUNSPEC;} } 
}



/* shrink-node!-cast2707 */
obj_t BGl_shrinkzd2nodez12zd2cast2707z12zzast_shrinkifyz00(obj_t BgL_envz00_3136, obj_t BgL_nodez00_3137)
{ AN_OBJECT;
{ /* ./Ast/shrinkify.scm 111 */
{ 
BgL_castz00_bglt BgL_nodez00_1380;
{ /* ./Ast/shrinkify.scm 112 */
BgL_castz00_bglt BgL_auxz00_3993;
BgL_nodez00_1380 = 
(BgL_castz00_bglt)(BgL_nodez00_3137); 
{ /* ./Ast/shrinkify.scm 112 */
BgL_nodez00_bglt BgL_arg3306z00_2254;
BgL_arg3306z00_2254 = 
(((BgL_castz00_bglt)CREF(BgL_nodez00_1380))->BgL_argz00); 
{ /* ./Ast/shrinkify.scm 112 */
obj_t BgL_res3624z00_2282;
{ /* ./Ast/shrinkify.scm 112 */
obj_t BgL_method2689z00_2257;
{ /* ./Ast/shrinkify.scm 112 */
BgL_objectz00_bglt BgL_objz00_2258;
BgL_objz00_2258 = 
(BgL_objectz00_bglt)(BgL_arg3306z00_2254); 
{ /* ./Ast/shrinkify.scm 112 */
long BgL_objzd2classzd2numz00_2259;
BgL_objzd2classzd2numz00_2259 = 
BGL_OBJECT_CLASS_NUM(BgL_objz00_2258); 
{ /* ./Ast/shrinkify.scm 112 */
obj_t BgL_arg1989z00_2260;
{ /* ./Ast/shrinkify.scm 112 */
int BgL_auxz00_3997;
BgL_auxz00_3997 = 
(int)(((long)1)); 
BgL_arg1989z00_2260 = 
PROCEDURE_REF(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, BgL_auxz00_3997); } 
{ /* ./Ast/shrinkify.scm 112 */
int BgL_offsetz00_2263;
BgL_offsetz00_2263 = 
(int)(BgL_objzd2classzd2numz00_2259); 
{ /* ./Ast/shrinkify.scm 112 */
long BgL_offsetz00_2264;
{ /* ./Ast/shrinkify.scm 112 */
long BgL_auxz00_4001;
BgL_auxz00_4001 = 
(long)(BgL_offsetz00_2263); 
BgL_offsetz00_2264 = 
(BgL_auxz00_4001-OBJECT_TYPE); } 
{ /* ./Ast/shrinkify.scm 112 */
long BgL_modz00_2265;
{ /* ./Ast/shrinkify.scm 112 */
int BgL_arg2000z00_2266;
BgL_arg2000z00_2266 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 112 */
long BgL_n2z00_2274;
BgL_n2z00_2274 = 
(long)(BgL_arg2000z00_2266); 
BgL_modz00_2265 = 
(BgL_offsetz00_2264/BgL_n2z00_2274); } } 
{ /* ./Ast/shrinkify.scm 112 */
long BgL_restz00_2267;
{ /* ./Ast/shrinkify.scm 112 */
int BgL_arg1996z00_2268;
BgL_arg1996z00_2268 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 112 */
long BgL_n2z00_2277;
BgL_n2z00_2277 = 
(long)(BgL_arg1996z00_2268); 
BgL_restz00_2267 = 
(BgL_offsetz00_2264%BgL_n2z00_2277); } } 
{ /* ./Ast/shrinkify.scm 112 */

{ /* ./Ast/shrinkify.scm 112 */
obj_t BgL_bucketz00_2269;
{ /* ./Ast/shrinkify.scm 112 */
int BgL_kz00_2279;
BgL_kz00_2279 = 
(int)(BgL_modz00_2265); 
BgL_bucketz00_2269 = 
VECTOR_REF(BgL_arg1989z00_2260,BgL_kz00_2279); } 
{ /* ./Ast/shrinkify.scm 112 */
int BgL_kz00_2281;
BgL_kz00_2281 = 
(int)(BgL_restz00_2267); 
BgL_method2689z00_2257 = 
VECTOR_REF(BgL_bucketz00_2269,BgL_kz00_2281); } } } } } } } } } } 
{ /* ./Ast/shrinkify.scm 112 */
obj_t BgL_xz00_3181;
BgL_xz00_3181 = 
PROCEDURE_ENTRY(BgL_method2689z00_2257)(BgL_method2689z00_2257, 
(obj_t)(BgL_arg3306z00_2254), BEOA); 
BgL_res3624z00_2282 = BUNSPEC; } } BgL_res3624z00_2282; } } 
BgL_auxz00_3993 = BgL_nodez00_1380; 
return 
(obj_t)(BgL_auxz00_3993);} } } 
}



/* shrink-node!-extern2705 */
obj_t BGl_shrinkzd2nodez12zd2extern2705z12zzast_shrinkifyz00(obj_t BgL_envz00_3138, obj_t BgL_nodez00_3139)
{ AN_OBJECT;
{ /* ./Ast/shrinkify.scm 103 */
{ 
BgL_externz00_bglt BgL_nodez00_1369;
{ /* ./Ast/shrinkify.scm 104 */
BgL_externz00_bglt BgL_auxz00_4019;
BgL_nodez00_1369 = 
(BgL_externz00_bglt)(BgL_nodez00_3139); 
{ /* ./Ast/shrinkify.scm 104 */
bool_t BgL_test3282z00_1372;
{ /* ./Ast/shrinkify.scm 104 */
bool_t BgL_testz00_4020;
{ /* ./Ast/shrinkify.scm 104 */
obj_t BgL_auxz00_4021;
{ /* ./Ast/shrinkify.scm 104 */
BgL_objectz00_bglt BgL_auxz00_4022;
BgL_auxz00_4022 = 
(BgL_objectz00_bglt)(BgL_nodez00_1369); 
BgL_auxz00_4021 = 
BGL_OBJECT_WIDENING(BgL_auxz00_4022); } 
BgL_testz00_4020 = 
CBOOL(BgL_auxz00_4021); } 
if(BgL_testz00_4020)
{ /* ./Ast/shrinkify.scm 104 */
BgL_test3282z00_1372 = ((bool_t)1); }  else 
{ /* ./Ast/shrinkify.scm 104 */
BgL_test3282z00_1372 = ((bool_t)0); } } 
if(BgL_test3282z00_1372)
{ /* ./Ast/shrinkify.scm 104 */
{ /* ./Ast/shrinkify.scm 104 */
long BgL_arg3284z00_1374;
{ /* ./Ast/shrinkify.scm 104 */
obj_t BgL_arg3287z00_1375;
{ /* ./Ast/shrinkify.scm 104 */
obj_t BgL_arg3290z00_1376;
{ /* ./Ast/shrinkify.scm 104 */
BgL_objectz00_bglt BgL_objectz00_2243;
BgL_objectz00_2243 = 
(BgL_objectz00_bglt)(BgL_nodez00_1369); 
{ /* ./Ast/shrinkify.scm 104 */
long BgL_arg2007z00_2244;
{ /* ./Ast/shrinkify.scm 104 */
long BgL_arg2010z00_2245;
BgL_arg2010z00_2245 = 
BGL_OBJECT_CLASS_NUM(BgL_objectz00_2243); 
BgL_arg2007z00_2244 = 
(BgL_arg2010z00_2245-OBJECT_TYPE); } 
{ /* ./Ast/shrinkify.scm 104 */
obj_t BgL_vectorz00_2249;int BgL_kz00_2250;
BgL_vectorz00_2249 = BGl_za2classesza2z00zz__objectz00; 
BgL_kz00_2250 = 
(int)(BgL_arg2007z00_2244); 
BgL_arg3290z00_1376 = 
VECTOR_REF(BgL_vectorz00_2249,BgL_kz00_2250); } } } 
BgL_arg3287z00_1375 = 
BGl_classzd2superzd2zz__objectz00(BgL_arg3290z00_1376); } 
BgL_arg3284z00_1374 = 
BGl_classzd2numzd2zz__objectz00(BgL_arg3287z00_1375); } 
{ /* ./Ast/shrinkify.scm 104 */
BgL_objectz00_bglt BgL_objz00_2251;
BgL_objz00_2251 = 
(BgL_objectz00_bglt)(BgL_nodez00_1369); 
BGL_OBJECT_CLASS_NUM_SET(BgL_objz00_2251, BgL_arg3284z00_1374); } } 
{ /* ./Ast/shrinkify.scm 104 */
BgL_objectz00_bglt BgL_auxz00_4036;
BgL_auxz00_4036 = 
(BgL_objectz00_bglt)(BgL_nodez00_1369); 
BGL_OBJECT_WIDENING_SET(BgL_auxz00_4036, BFALSE); } 
(obj_t)(BgL_nodez00_1369); }  else 
{ /* ./Ast/shrinkify.scm 104 */BFALSE; } } 
{ /* ./Ast/shrinkify.scm 105 */
obj_t BgL_arg3296z00_1377;
BgL_arg3296z00_1377 = 
(((BgL_externz00_bglt)CREF(BgL_nodez00_1369))->BgL_exprza2za2); 
BGl_shrinkzd2nodeza2z12z62zzast_shrinkifyz00(BgL_arg3296z00_1377); } 
BgL_auxz00_4019 = BgL_nodez00_1369; 
return 
(obj_t)(BgL_auxz00_4019);} } } 
}



/* shrink-node!-funcall2703 */
obj_t BGl_shrinkzd2nodez12zd2funcall2703z12zzast_shrinkifyz00(obj_t BgL_envz00_3140, obj_t BgL_nodez00_3141)
{ AN_OBJECT;
{ /* ./Ast/shrinkify.scm 94 */
{ 
BgL_funcallz00_bglt BgL_nodez00_1357;
BgL_nodez00_1357 = 
(BgL_funcallz00_bglt)(BgL_nodez00_3141); 
{ /* ./Ast/shrinkify.scm 95 */
bool_t BgL_test3254z00_1360;
{ /* ./Ast/shrinkify.scm 95 */
bool_t BgL_testz00_4044;
{ /* ./Ast/shrinkify.scm 95 */
obj_t BgL_auxz00_4045;
{ /* ./Ast/shrinkify.scm 95 */
BgL_objectz00_bglt BgL_auxz00_4046;
BgL_auxz00_4046 = 
(BgL_objectz00_bglt)(BgL_nodez00_1357); 
BgL_auxz00_4045 = 
BGL_OBJECT_WIDENING(BgL_auxz00_4046); } 
BgL_testz00_4044 = 
CBOOL(BgL_auxz00_4045); } 
if(BgL_testz00_4044)
{ /* ./Ast/shrinkify.scm 95 */
BgL_test3254z00_1360 = ((bool_t)1); }  else 
{ /* ./Ast/shrinkify.scm 95 */
BgL_test3254z00_1360 = ((bool_t)0); } } 
if(BgL_test3254z00_1360)
{ /* ./Ast/shrinkify.scm 95 */
{ /* ./Ast/shrinkify.scm 95 */
long BgL_arg3256z00_1362;
{ /* ./Ast/shrinkify.scm 95 */
obj_t BgL_arg3259z00_1363;
{ /* ./Ast/shrinkify.scm 95 */
obj_t BgL_arg3263z00_1364;
{ /* ./Ast/shrinkify.scm 95 */
BgL_objectz00_bglt BgL_objectz00_2201;
BgL_objectz00_2201 = 
(BgL_objectz00_bglt)(BgL_nodez00_1357); 
{ /* ./Ast/shrinkify.scm 95 */
long BgL_arg2007z00_2202;
{ /* ./Ast/shrinkify.scm 95 */
long BgL_arg2010z00_2203;
BgL_arg2010z00_2203 = 
BGL_OBJECT_CLASS_NUM(BgL_objectz00_2201); 
BgL_arg2007z00_2202 = 
(BgL_arg2010z00_2203-OBJECT_TYPE); } 
{ /* ./Ast/shrinkify.scm 95 */
obj_t BgL_vectorz00_2207;int BgL_kz00_2208;
BgL_vectorz00_2207 = BGl_za2classesza2z00zz__objectz00; 
BgL_kz00_2208 = 
(int)(BgL_arg2007z00_2202); 
BgL_arg3263z00_1364 = 
VECTOR_REF(BgL_vectorz00_2207,BgL_kz00_2208); } } } 
BgL_arg3259z00_1363 = 
BGl_classzd2superzd2zz__objectz00(BgL_arg3263z00_1364); } 
BgL_arg3256z00_1362 = 
BGl_classzd2numzd2zz__objectz00(BgL_arg3259z00_1363); } 
{ /* ./Ast/shrinkify.scm 95 */
BgL_objectz00_bglt BgL_objz00_2209;
BgL_objz00_2209 = 
(BgL_objectz00_bglt)(BgL_nodez00_1357); 
BGL_OBJECT_CLASS_NUM_SET(BgL_objz00_2209, BgL_arg3256z00_1362); } } 
{ /* ./Ast/shrinkify.scm 95 */
BgL_objectz00_bglt BgL_auxz00_4060;
BgL_auxz00_4060 = 
(BgL_objectz00_bglt)(BgL_nodez00_1357); 
BGL_OBJECT_WIDENING_SET(BgL_auxz00_4060, BFALSE); } 
(obj_t)(BgL_nodez00_1357); }  else 
{ /* ./Ast/shrinkify.scm 95 */BFALSE; } } 
{ /* ./Ast/shrinkify.scm 96 */
BgL_nodez00_bglt BgL_arg3269z00_1365;
BgL_arg3269z00_1365 = 
(((BgL_funcallz00_bglt)CREF(BgL_nodez00_1357))->BgL_funz00); 
{ /* ./Ast/shrinkify.scm 96 */
obj_t BgL_res3620z00_2238;
{ /* ./Ast/shrinkify.scm 96 */
obj_t BgL_method2689z00_2213;
{ /* ./Ast/shrinkify.scm 96 */
BgL_objectz00_bglt BgL_objz00_2214;
BgL_objz00_2214 = 
(BgL_objectz00_bglt)(BgL_arg3269z00_1365); 
{ /* ./Ast/shrinkify.scm 96 */
long BgL_objzd2classzd2numz00_2215;
BgL_objzd2classzd2numz00_2215 = 
BGL_OBJECT_CLASS_NUM(BgL_objz00_2214); 
{ /* ./Ast/shrinkify.scm 96 */
obj_t BgL_arg1989z00_2216;
{ /* ./Ast/shrinkify.scm 96 */
int BgL_auxz00_4067;
BgL_auxz00_4067 = 
(int)(((long)1)); 
BgL_arg1989z00_2216 = 
PROCEDURE_REF(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, BgL_auxz00_4067); } 
{ /* ./Ast/shrinkify.scm 96 */
int BgL_offsetz00_2219;
BgL_offsetz00_2219 = 
(int)(BgL_objzd2classzd2numz00_2215); 
{ /* ./Ast/shrinkify.scm 96 */
long BgL_offsetz00_2220;
{ /* ./Ast/shrinkify.scm 96 */
long BgL_auxz00_4071;
BgL_auxz00_4071 = 
(long)(BgL_offsetz00_2219); 
BgL_offsetz00_2220 = 
(BgL_auxz00_4071-OBJECT_TYPE); } 
{ /* ./Ast/shrinkify.scm 96 */
long BgL_modz00_2221;
{ /* ./Ast/shrinkify.scm 96 */
int BgL_arg2000z00_2222;
BgL_arg2000z00_2222 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 96 */
long BgL_n2z00_2230;
BgL_n2z00_2230 = 
(long)(BgL_arg2000z00_2222); 
BgL_modz00_2221 = 
(BgL_offsetz00_2220/BgL_n2z00_2230); } } 
{ /* ./Ast/shrinkify.scm 96 */
long BgL_restz00_2223;
{ /* ./Ast/shrinkify.scm 96 */
int BgL_arg1996z00_2224;
BgL_arg1996z00_2224 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 96 */
long BgL_n2z00_2233;
BgL_n2z00_2233 = 
(long)(BgL_arg1996z00_2224); 
BgL_restz00_2223 = 
(BgL_offsetz00_2220%BgL_n2z00_2233); } } 
{ /* ./Ast/shrinkify.scm 96 */

{ /* ./Ast/shrinkify.scm 96 */
obj_t BgL_bucketz00_2225;
{ /* ./Ast/shrinkify.scm 96 */
int BgL_kz00_2235;
BgL_kz00_2235 = 
(int)(BgL_modz00_2221); 
BgL_bucketz00_2225 = 
VECTOR_REF(BgL_arg1989z00_2216,BgL_kz00_2235); } 
{ /* ./Ast/shrinkify.scm 96 */
int BgL_kz00_2237;
BgL_kz00_2237 = 
(int)(BgL_restz00_2223); 
BgL_method2689z00_2213 = 
VECTOR_REF(BgL_bucketz00_2225,BgL_kz00_2237); } } } } } } } } } } 
{ /* ./Ast/shrinkify.scm 96 */
obj_t BgL_xz00_3182;
BgL_xz00_3182 = 
PROCEDURE_ENTRY(BgL_method2689z00_2213)(BgL_method2689z00_2213, 
(obj_t)(BgL_arg3269z00_1365), BEOA); 
BgL_res3620z00_2238 = BUNSPEC; } } BgL_res3620z00_2238; } } 
{ /* ./Ast/shrinkify.scm 97 */
obj_t BgL_arg3273z00_1366;
BgL_arg3273z00_1366 = 
(((BgL_funcallz00_bglt)CREF(BgL_nodez00_1357))->BgL_argsz00); 
BGl_shrinkzd2nodeza2z12z62zzast_shrinkifyz00(BgL_arg3273z00_1366); } 
return BUNSPEC;} } 
}



/* shrink-node!-app-ly2701 */
obj_t BGl_shrinkzd2nodez12zd2appzd2ly2701zc0zzast_shrinkifyz00(obj_t BgL_envz00_3142, obj_t BgL_nodez00_3143)
{ AN_OBJECT;
{ /* ./Ast/shrinkify.scm 85 */
{ 
BgL_appzd2lyzd2_bglt BgL_nodez00_1345;
BgL_nodez00_1345 = 
(BgL_appzd2lyzd2_bglt)(BgL_nodez00_3143); 
{ /* ./Ast/shrinkify.scm 86 */
bool_t BgL_test3227z00_1348;
{ /* ./Ast/shrinkify.scm 86 */
bool_t BgL_testz00_4090;
{ /* ./Ast/shrinkify.scm 86 */
obj_t BgL_auxz00_4091;
{ /* ./Ast/shrinkify.scm 86 */
BgL_objectz00_bglt BgL_auxz00_4092;
BgL_auxz00_4092 = 
(BgL_objectz00_bglt)(BgL_nodez00_1345); 
BgL_auxz00_4091 = 
BGL_OBJECT_WIDENING(BgL_auxz00_4092); } 
BgL_testz00_4090 = 
CBOOL(BgL_auxz00_4091); } 
if(BgL_testz00_4090)
{ /* ./Ast/shrinkify.scm 86 */
BgL_test3227z00_1348 = ((bool_t)1); }  else 
{ /* ./Ast/shrinkify.scm 86 */
BgL_test3227z00_1348 = ((bool_t)0); } } 
if(BgL_test3227z00_1348)
{ /* ./Ast/shrinkify.scm 86 */
{ /* ./Ast/shrinkify.scm 86 */
long BgL_arg3229z00_1350;
{ /* ./Ast/shrinkify.scm 86 */
obj_t BgL_arg3232z00_1351;
{ /* ./Ast/shrinkify.scm 86 */
obj_t BgL_arg3235z00_1352;
{ /* ./Ast/shrinkify.scm 86 */
BgL_objectz00_bglt BgL_objectz00_2132;
BgL_objectz00_2132 = 
(BgL_objectz00_bglt)(BgL_nodez00_1345); 
{ /* ./Ast/shrinkify.scm 86 */
long BgL_arg2007z00_2133;
{ /* ./Ast/shrinkify.scm 86 */
long BgL_arg2010z00_2134;
BgL_arg2010z00_2134 = 
BGL_OBJECT_CLASS_NUM(BgL_objectz00_2132); 
BgL_arg2007z00_2133 = 
(BgL_arg2010z00_2134-OBJECT_TYPE); } 
{ /* ./Ast/shrinkify.scm 86 */
obj_t BgL_vectorz00_2138;int BgL_kz00_2139;
BgL_vectorz00_2138 = BGl_za2classesza2z00zz__objectz00; 
BgL_kz00_2139 = 
(int)(BgL_arg2007z00_2133); 
BgL_arg3235z00_1352 = 
VECTOR_REF(BgL_vectorz00_2138,BgL_kz00_2139); } } } 
BgL_arg3232z00_1351 = 
BGl_classzd2superzd2zz__objectz00(BgL_arg3235z00_1352); } 
BgL_arg3229z00_1350 = 
BGl_classzd2numzd2zz__objectz00(BgL_arg3232z00_1351); } 
{ /* ./Ast/shrinkify.scm 86 */
BgL_objectz00_bglt BgL_objz00_2140;
BgL_objz00_2140 = 
(BgL_objectz00_bglt)(BgL_nodez00_1345); 
BGL_OBJECT_CLASS_NUM_SET(BgL_objz00_2140, BgL_arg3229z00_1350); } } 
{ /* ./Ast/shrinkify.scm 86 */
BgL_objectz00_bglt BgL_auxz00_4106;
BgL_auxz00_4106 = 
(BgL_objectz00_bglt)(BgL_nodez00_1345); 
BGL_OBJECT_WIDENING_SET(BgL_auxz00_4106, BFALSE); } 
(obj_t)(BgL_nodez00_1345); }  else 
{ /* ./Ast/shrinkify.scm 86 */BFALSE; } } 
{ /* ./Ast/shrinkify.scm 87 */
BgL_nodez00_bglt BgL_arg3241z00_1353;
BgL_arg3241z00_1353 = 
(((BgL_appzd2lyzd2_bglt)CREF(BgL_nodez00_1345))->BgL_funz00); 
{ /* ./Ast/shrinkify.scm 87 */
obj_t BgL_res3613z00_2169;
{ /* ./Ast/shrinkify.scm 87 */
obj_t BgL_method2689z00_2144;
{ /* ./Ast/shrinkify.scm 87 */
BgL_objectz00_bglt BgL_objz00_2145;
BgL_objz00_2145 = 
(BgL_objectz00_bglt)(BgL_arg3241z00_1353); 
{ /* ./Ast/shrinkify.scm 87 */
long BgL_objzd2classzd2numz00_2146;
BgL_objzd2classzd2numz00_2146 = 
BGL_OBJECT_CLASS_NUM(BgL_objz00_2145); 
{ /* ./Ast/shrinkify.scm 87 */
obj_t BgL_arg1989z00_2147;
{ /* ./Ast/shrinkify.scm 87 */
int BgL_auxz00_4113;
BgL_auxz00_4113 = 
(int)(((long)1)); 
BgL_arg1989z00_2147 = 
PROCEDURE_REF(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, BgL_auxz00_4113); } 
{ /* ./Ast/shrinkify.scm 87 */
int BgL_offsetz00_2150;
BgL_offsetz00_2150 = 
(int)(BgL_objzd2classzd2numz00_2146); 
{ /* ./Ast/shrinkify.scm 87 */
long BgL_offsetz00_2151;
{ /* ./Ast/shrinkify.scm 87 */
long BgL_auxz00_4117;
BgL_auxz00_4117 = 
(long)(BgL_offsetz00_2150); 
BgL_offsetz00_2151 = 
(BgL_auxz00_4117-OBJECT_TYPE); } 
{ /* ./Ast/shrinkify.scm 87 */
long BgL_modz00_2152;
{ /* ./Ast/shrinkify.scm 87 */
int BgL_arg2000z00_2153;
BgL_arg2000z00_2153 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 87 */
long BgL_n2z00_2161;
BgL_n2z00_2161 = 
(long)(BgL_arg2000z00_2153); 
BgL_modz00_2152 = 
(BgL_offsetz00_2151/BgL_n2z00_2161); } } 
{ /* ./Ast/shrinkify.scm 87 */
long BgL_restz00_2154;
{ /* ./Ast/shrinkify.scm 87 */
int BgL_arg1996z00_2155;
BgL_arg1996z00_2155 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 87 */
long BgL_n2z00_2164;
BgL_n2z00_2164 = 
(long)(BgL_arg1996z00_2155); 
BgL_restz00_2154 = 
(BgL_offsetz00_2151%BgL_n2z00_2164); } } 
{ /* ./Ast/shrinkify.scm 87 */

{ /* ./Ast/shrinkify.scm 87 */
obj_t BgL_bucketz00_2156;
{ /* ./Ast/shrinkify.scm 87 */
int BgL_kz00_2166;
BgL_kz00_2166 = 
(int)(BgL_modz00_2152); 
BgL_bucketz00_2156 = 
VECTOR_REF(BgL_arg1989z00_2147,BgL_kz00_2166); } 
{ /* ./Ast/shrinkify.scm 87 */
int BgL_kz00_2168;
BgL_kz00_2168 = 
(int)(BgL_restz00_2154); 
BgL_method2689z00_2144 = 
VECTOR_REF(BgL_bucketz00_2156,BgL_kz00_2168); } } } } } } } } } } 
{ /* ./Ast/shrinkify.scm 87 */
obj_t BgL_xz00_3183;
BgL_xz00_3183 = 
PROCEDURE_ENTRY(BgL_method2689z00_2144)(BgL_method2689z00_2144, 
(obj_t)(BgL_arg3241z00_1353), BEOA); 
BgL_res3613z00_2169 = BUNSPEC; } } BgL_res3613z00_2169; } } 
{ /* ./Ast/shrinkify.scm 88 */
BgL_nodez00_bglt BgL_arg3245z00_1354;
BgL_arg3245z00_1354 = 
(((BgL_appzd2lyzd2_bglt)CREF(BgL_nodez00_1345))->BgL_argz00); 
{ /* ./Ast/shrinkify.scm 88 */
obj_t BgL_res3616z00_2197;
{ /* ./Ast/shrinkify.scm 88 */
obj_t BgL_method2689z00_2172;
{ /* ./Ast/shrinkify.scm 88 */
BgL_objectz00_bglt BgL_objz00_2173;
BgL_objz00_2173 = 
(BgL_objectz00_bglt)(BgL_arg3245z00_1354); 
{ /* ./Ast/shrinkify.scm 88 */
long BgL_objzd2classzd2numz00_2174;
BgL_objzd2classzd2numz00_2174 = 
BGL_OBJECT_CLASS_NUM(BgL_objz00_2173); 
{ /* ./Ast/shrinkify.scm 88 */
obj_t BgL_arg1989z00_2175;
{ /* ./Ast/shrinkify.scm 88 */
int BgL_auxz00_4136;
BgL_auxz00_4136 = 
(int)(((long)1)); 
BgL_arg1989z00_2175 = 
PROCEDURE_REF(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, BgL_auxz00_4136); } 
{ /* ./Ast/shrinkify.scm 88 */
int BgL_offsetz00_2178;
BgL_offsetz00_2178 = 
(int)(BgL_objzd2classzd2numz00_2174); 
{ /* ./Ast/shrinkify.scm 88 */
long BgL_offsetz00_2179;
{ /* ./Ast/shrinkify.scm 88 */
long BgL_auxz00_4140;
BgL_auxz00_4140 = 
(long)(BgL_offsetz00_2178); 
BgL_offsetz00_2179 = 
(BgL_auxz00_4140-OBJECT_TYPE); } 
{ /* ./Ast/shrinkify.scm 88 */
long BgL_modz00_2180;
{ /* ./Ast/shrinkify.scm 88 */
int BgL_arg2000z00_2181;
BgL_arg2000z00_2181 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 88 */
long BgL_n2z00_2189;
BgL_n2z00_2189 = 
(long)(BgL_arg2000z00_2181); 
BgL_modz00_2180 = 
(BgL_offsetz00_2179/BgL_n2z00_2189); } } 
{ /* ./Ast/shrinkify.scm 88 */
long BgL_restz00_2182;
{ /* ./Ast/shrinkify.scm 88 */
int BgL_arg1996z00_2183;
BgL_arg1996z00_2183 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 88 */
long BgL_n2z00_2192;
BgL_n2z00_2192 = 
(long)(BgL_arg1996z00_2183); 
BgL_restz00_2182 = 
(BgL_offsetz00_2179%BgL_n2z00_2192); } } 
{ /* ./Ast/shrinkify.scm 88 */

{ /* ./Ast/shrinkify.scm 88 */
obj_t BgL_bucketz00_2184;
{ /* ./Ast/shrinkify.scm 88 */
int BgL_kz00_2194;
BgL_kz00_2194 = 
(int)(BgL_modz00_2180); 
BgL_bucketz00_2184 = 
VECTOR_REF(BgL_arg1989z00_2175,BgL_kz00_2194); } 
{ /* ./Ast/shrinkify.scm 88 */
int BgL_kz00_2196;
BgL_kz00_2196 = 
(int)(BgL_restz00_2182); 
BgL_method2689z00_2172 = 
VECTOR_REF(BgL_bucketz00_2184,BgL_kz00_2196); } } } } } } } } } } 
{ /* ./Ast/shrinkify.scm 88 */
obj_t BgL_xz00_3184;
BgL_xz00_3184 = 
PROCEDURE_ENTRY(BgL_method2689z00_2172)(BgL_method2689z00_2172, 
(obj_t)(BgL_arg3245z00_1354), BEOA); 
BgL_res3616z00_2197 = BUNSPEC; } } BgL_res3616z00_2197; } } 
return BUNSPEC;} } 
}



/* shrink-node!-app2699 */
obj_t BGl_shrinkzd2nodez12zd2app2699z12zzast_shrinkifyz00(obj_t BgL_envz00_3144, obj_t BgL_nodez00_3145)
{ AN_OBJECT;
{ /* ./Ast/shrinkify.scm 76 */
{ 
BgL_appz00_bglt BgL_nodez00_1333;
BgL_nodez00_1333 = 
(BgL_appz00_bglt)(BgL_nodez00_3145); 
{ /* ./Ast/shrinkify.scm 77 */
bool_t BgL_test3200z00_1336;
{ /* ./Ast/shrinkify.scm 77 */
bool_t BgL_testz00_4157;
{ /* ./Ast/shrinkify.scm 77 */
obj_t BgL_auxz00_4158;
{ /* ./Ast/shrinkify.scm 77 */
BgL_objectz00_bglt BgL_auxz00_4159;
BgL_auxz00_4159 = 
(BgL_objectz00_bglt)(BgL_nodez00_1333); 
BgL_auxz00_4158 = 
BGL_OBJECT_WIDENING(BgL_auxz00_4159); } 
BgL_testz00_4157 = 
CBOOL(BgL_auxz00_4158); } 
if(BgL_testz00_4157)
{ /* ./Ast/shrinkify.scm 77 */
BgL_test3200z00_1336 = ((bool_t)1); }  else 
{ /* ./Ast/shrinkify.scm 77 */
BgL_test3200z00_1336 = ((bool_t)0); } } 
if(BgL_test3200z00_1336)
{ /* ./Ast/shrinkify.scm 77 */
{ /* ./Ast/shrinkify.scm 77 */
long BgL_arg3202z00_1338;
{ /* ./Ast/shrinkify.scm 77 */
obj_t BgL_arg3205z00_1339;
{ /* ./Ast/shrinkify.scm 77 */
obj_t BgL_arg3208z00_1340;
{ /* ./Ast/shrinkify.scm 77 */
BgL_objectz00_bglt BgL_objectz00_2090;
BgL_objectz00_2090 = 
(BgL_objectz00_bglt)(BgL_nodez00_1333); 
{ /* ./Ast/shrinkify.scm 77 */
long BgL_arg2007z00_2091;
{ /* ./Ast/shrinkify.scm 77 */
long BgL_arg2010z00_2092;
BgL_arg2010z00_2092 = 
BGL_OBJECT_CLASS_NUM(BgL_objectz00_2090); 
BgL_arg2007z00_2091 = 
(BgL_arg2010z00_2092-OBJECT_TYPE); } 
{ /* ./Ast/shrinkify.scm 77 */
obj_t BgL_vectorz00_2096;int BgL_kz00_2097;
BgL_vectorz00_2096 = BGl_za2classesza2z00zz__objectz00; 
BgL_kz00_2097 = 
(int)(BgL_arg2007z00_2091); 
BgL_arg3208z00_1340 = 
VECTOR_REF(BgL_vectorz00_2096,BgL_kz00_2097); } } } 
BgL_arg3205z00_1339 = 
BGl_classzd2superzd2zz__objectz00(BgL_arg3208z00_1340); } 
BgL_arg3202z00_1338 = 
BGl_classzd2numzd2zz__objectz00(BgL_arg3205z00_1339); } 
{ /* ./Ast/shrinkify.scm 77 */
BgL_objectz00_bglt BgL_objz00_2098;
BgL_objz00_2098 = 
(BgL_objectz00_bglt)(BgL_nodez00_1333); 
BGL_OBJECT_CLASS_NUM_SET(BgL_objz00_2098, BgL_arg3202z00_1338); } } 
{ /* ./Ast/shrinkify.scm 77 */
BgL_objectz00_bglt BgL_auxz00_4173;
BgL_auxz00_4173 = 
(BgL_objectz00_bglt)(BgL_nodez00_1333); 
BGL_OBJECT_WIDENING_SET(BgL_auxz00_4173, BFALSE); } 
(obj_t)(BgL_nodez00_1333); }  else 
{ /* ./Ast/shrinkify.scm 77 */BFALSE; } } 
{ /* ./Ast/shrinkify.scm 78 */
BgL_varz00_bglt BgL_arg3214z00_1341;
BgL_arg3214z00_1341 = 
(((BgL_appz00_bglt)CREF(BgL_nodez00_1333))->BgL_funz00); 
{ /* ./Ast/shrinkify.scm 78 */
obj_t BgL_res3609z00_2127;
{ /* ./Ast/shrinkify.scm 78 */
BgL_nodez00_bglt BgL_nodez00_2101;
BgL_nodez00_2101 = 
(BgL_nodez00_bglt)(BgL_arg3214z00_1341); 
{ /* ./Ast/shrinkify.scm 78 */
obj_t BgL_method2689z00_2102;
{ /* ./Ast/shrinkify.scm 78 */
BgL_objectz00_bglt BgL_objz00_2103;
BgL_objz00_2103 = 
(BgL_objectz00_bglt)(BgL_nodez00_2101); 
{ /* ./Ast/shrinkify.scm 78 */
long BgL_objzd2classzd2numz00_2104;
BgL_objzd2classzd2numz00_2104 = 
BGL_OBJECT_CLASS_NUM(BgL_objz00_2103); 
{ /* ./Ast/shrinkify.scm 78 */
obj_t BgL_arg1989z00_2105;
{ /* ./Ast/shrinkify.scm 78 */
int BgL_auxz00_4181;
BgL_auxz00_4181 = 
(int)(((long)1)); 
BgL_arg1989z00_2105 = 
PROCEDURE_REF(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, BgL_auxz00_4181); } 
{ /* ./Ast/shrinkify.scm 78 */
int BgL_offsetz00_2108;
BgL_offsetz00_2108 = 
(int)(BgL_objzd2classzd2numz00_2104); 
{ /* ./Ast/shrinkify.scm 78 */
long BgL_offsetz00_2109;
{ /* ./Ast/shrinkify.scm 78 */
long BgL_auxz00_4185;
BgL_auxz00_4185 = 
(long)(BgL_offsetz00_2108); 
BgL_offsetz00_2109 = 
(BgL_auxz00_4185-OBJECT_TYPE); } 
{ /* ./Ast/shrinkify.scm 78 */
long BgL_modz00_2110;
{ /* ./Ast/shrinkify.scm 78 */
int BgL_arg2000z00_2111;
BgL_arg2000z00_2111 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 78 */
long BgL_n2z00_2119;
BgL_n2z00_2119 = 
(long)(BgL_arg2000z00_2111); 
BgL_modz00_2110 = 
(BgL_offsetz00_2109/BgL_n2z00_2119); } } 
{ /* ./Ast/shrinkify.scm 78 */
long BgL_restz00_2112;
{ /* ./Ast/shrinkify.scm 78 */
int BgL_arg1996z00_2113;
BgL_arg1996z00_2113 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 78 */
long BgL_n2z00_2122;
BgL_n2z00_2122 = 
(long)(BgL_arg1996z00_2113); 
BgL_restz00_2112 = 
(BgL_offsetz00_2109%BgL_n2z00_2122); } } 
{ /* ./Ast/shrinkify.scm 78 */

{ /* ./Ast/shrinkify.scm 78 */
obj_t BgL_bucketz00_2114;
{ /* ./Ast/shrinkify.scm 78 */
int BgL_kz00_2124;
BgL_kz00_2124 = 
(int)(BgL_modz00_2110); 
BgL_bucketz00_2114 = 
VECTOR_REF(BgL_arg1989z00_2105,BgL_kz00_2124); } 
{ /* ./Ast/shrinkify.scm 78 */
int BgL_kz00_2126;
BgL_kz00_2126 = 
(int)(BgL_restz00_2112); 
BgL_method2689z00_2102 = 
VECTOR_REF(BgL_bucketz00_2114,BgL_kz00_2126); } } } } } } } } } } 
{ /* ./Ast/shrinkify.scm 78 */
obj_t BgL_xz00_3185;
BgL_xz00_3185 = 
PROCEDURE_ENTRY(BgL_method2689z00_2102)(BgL_method2689z00_2102, 
(obj_t)(BgL_nodez00_2101), BEOA); 
BgL_res3609z00_2127 = BUNSPEC; } } } BgL_res3609z00_2127; } } 
{ /* ./Ast/shrinkify.scm 79 */
obj_t BgL_arg3218z00_1342;
BgL_arg3218z00_1342 = 
(((BgL_appz00_bglt)CREF(BgL_nodez00_1333))->BgL_argsz00); 
BGl_shrinkzd2nodeza2z12z62zzast_shrinkifyz00(BgL_arg3218z00_1342); } 
return BUNSPEC;} } 
}



/* shrink-node!-sequence2697 */
obj_t BGl_shrinkzd2nodez12zd2sequence2697z12zzast_shrinkifyz00(obj_t BgL_envz00_3146, obj_t BgL_nodez00_3147)
{ AN_OBJECT;
{ /* ./Ast/shrinkify.scm 69 */
{ 
BgL_sequencez00_bglt BgL_nodez00_1327;
BgL_nodez00_1327 = 
(BgL_sequencez00_bglt)(BgL_nodez00_3147); 
{ /* ./Ast/shrinkify.scm 70 */
obj_t BgL_arg3191z00_2085;
BgL_arg3191z00_2085 = 
(((BgL_sequencez00_bglt)CREF(BgL_nodez00_1327))->BgL_nodesz00); 
BGl_shrinkzd2nodeza2z12z62zzast_shrinkifyz00(BgL_arg3191z00_2085); } 
return BUNSPEC;} } 
}



/* shrink-node!-kwote2695 */
obj_t BGl_shrinkzd2nodez12zd2kwote2695z12zzast_shrinkifyz00(obj_t BgL_envz00_3148, obj_t BgL_nodez00_3149)
{ AN_OBJECT;
{ /* ./Ast/shrinkify.scm 63 */
{ 
BgL_kwotez00_bglt BgL_nodez00_1322;
BgL_nodez00_1322 = 
(BgL_kwotez00_bglt)(BgL_nodez00_3149); 
return BUNSPEC;} } 
}



/* shrink-node!-var2693 */
obj_t BGl_shrinkzd2nodez12zd2var2693z12zzast_shrinkifyz00(obj_t BgL_envz00_3150, obj_t BgL_nodez00_3151)
{ AN_OBJECT;
{ /* ./Ast/shrinkify.scm 57 */
{ 
BgL_varz00_bglt BgL_nodez00_1317;
BgL_nodez00_1317 = 
(BgL_varz00_bglt)(BgL_nodez00_3151); 
return BUNSPEC;} } 
}



/* shrink-node!-atom2691 */
obj_t BGl_shrinkzd2nodez12zd2atom2691z12zzast_shrinkifyz00(obj_t BgL_envz00_3152, obj_t BgL_nodez00_3153)
{ AN_OBJECT;
{ /* ./Ast/shrinkify.scm 51 */
{ 
BgL_atomz00_bglt BgL_nodez00_1312;
BgL_nodez00_1312 = 
(BgL_atomz00_bglt)(BgL_nodez00_3153); 
return BUNSPEC;} } 
}



/* shrink-variable! */
obj_t BGl_shrinkzd2variablez12zc0zzast_shrinkifyz00(BgL_variablez00_bglt BgL_variablez00_2)
{ AN_OBJECT;
{ /* ./Ast/shrinkify.scm 37 */
{ /* ./Ast/shrinkify.scm 37 */
obj_t BgL_method2687z00_3007;
{ /* ./Ast/shrinkify.scm 37 */
BgL_objectz00_bglt BgL_objz00_3008;
BgL_objz00_3008 = 
(BgL_objectz00_bglt)(BgL_variablez00_2); 
{ /* ./Ast/shrinkify.scm 37 */
long BgL_objzd2classzd2numz00_3009;
BgL_objzd2classzd2numz00_3009 = 
BGL_OBJECT_CLASS_NUM(BgL_objz00_3008); 
{ /* ./Ast/shrinkify.scm 37 */
obj_t BgL_arg1989z00_3010;
{ /* ./Ast/shrinkify.scm 37 */
int BgL_auxz00_4212;
BgL_auxz00_4212 = 
(int)(((long)1)); 
BgL_arg1989z00_3010 = 
PROCEDURE_REF(BGl_shrinkzd2variablez12zd2envz12zzast_shrinkifyz00, BgL_auxz00_4212); } 
{ /* ./Ast/shrinkify.scm 37 */
int BgL_offsetz00_3013;
BgL_offsetz00_3013 = 
(int)(BgL_objzd2classzd2numz00_3009); 
{ /* ./Ast/shrinkify.scm 37 */
long BgL_offsetz00_3014;
{ /* ./Ast/shrinkify.scm 37 */
long BgL_auxz00_4216;
BgL_auxz00_4216 = 
(long)(BgL_offsetz00_3013); 
BgL_offsetz00_3014 = 
(BgL_auxz00_4216-OBJECT_TYPE); } 
{ /* ./Ast/shrinkify.scm 37 */
long BgL_modz00_3015;
{ /* ./Ast/shrinkify.scm 37 */
int BgL_arg2000z00_3016;
BgL_arg2000z00_3016 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 37 */
long BgL_n2z00_3024;
BgL_n2z00_3024 = 
(long)(BgL_arg2000z00_3016); 
BgL_modz00_3015 = 
(BgL_offsetz00_3014/BgL_n2z00_3024); } } 
{ /* ./Ast/shrinkify.scm 37 */
long BgL_restz00_3017;
{ /* ./Ast/shrinkify.scm 37 */
int BgL_arg1996z00_3018;
BgL_arg1996z00_3018 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 37 */
long BgL_n2z00_3027;
BgL_n2z00_3027 = 
(long)(BgL_arg1996z00_3018); 
BgL_restz00_3017 = 
(BgL_offsetz00_3014%BgL_n2z00_3027); } } 
{ /* ./Ast/shrinkify.scm 37 */

{ /* ./Ast/shrinkify.scm 37 */
obj_t BgL_bucketz00_3019;
{ /* ./Ast/shrinkify.scm 37 */
int BgL_kz00_3029;
BgL_kz00_3029 = 
(int)(BgL_modz00_3015); 
BgL_bucketz00_3019 = 
VECTOR_REF(BgL_arg1989z00_3010,BgL_kz00_3029); } 
{ /* ./Ast/shrinkify.scm 37 */
int BgL_kz00_3031;
BgL_kz00_3031 = 
(int)(BgL_restz00_3017); 
BgL_method2687z00_3007 = 
VECTOR_REF(BgL_bucketz00_3019,BgL_kz00_3031); } } } } } } } } } } 
return 
PROCEDURE_ENTRY(BgL_method2687z00_3007)(BgL_method2687z00_3007, 
(obj_t)(BgL_variablez00_2), BEOA);} } 
}



/* _shrink-variable!3704 */
obj_t BGl__shrinkzd2variablez123704zc0zzast_shrinkifyz00(obj_t BgL_envz00_3090, obj_t BgL_variablez00_3091)
{ AN_OBJECT;
{ /* ./Ast/shrinkify.scm 37 */
return 
BGl_shrinkzd2variablez12zc0zzast_shrinkifyz00(
(BgL_variablez00_bglt)(BgL_variablez00_3091));} 
}



/* shrink-variable!-default2684 */
obj_t BGl_shrinkzd2variablez12zd2default2684z12zzast_shrinkifyz00(BgL_variablez00_bglt BgL_variablez00_3)
{ AN_OBJECT;
{ /* ./Ast/shrinkify.scm 15 */
{ /* ./Ast/shrinkify.scm 38 */
bool_t BgL_test3561z00_1507;
{ /* ./Ast/shrinkify.scm 38 */
bool_t BgL_testz00_4234;
{ /* ./Ast/shrinkify.scm 38 */
obj_t BgL_auxz00_4235;
{ /* ./Ast/shrinkify.scm 38 */
BgL_objectz00_bglt BgL_auxz00_4236;
BgL_auxz00_4236 = 
(BgL_objectz00_bglt)(BgL_variablez00_3); 
BgL_auxz00_4235 = 
BGL_OBJECT_WIDENING(BgL_auxz00_4236); } 
BgL_testz00_4234 = 
CBOOL(BgL_auxz00_4235); } 
if(BgL_testz00_4234)
{ /* ./Ast/shrinkify.scm 38 */
BgL_test3561z00_1507 = ((bool_t)1); }  else 
{ /* ./Ast/shrinkify.scm 38 */
BgL_test3561z00_1507 = ((bool_t)0); } } 
if(BgL_test3561z00_1507)
{ /* ./Ast/shrinkify.scm 38 */
{ /* ./Ast/shrinkify.scm 39 */
long BgL_arg3563z00_1509;
{ /* ./Ast/shrinkify.scm 39 */
obj_t BgL_arg3566z00_1510;
{ /* ./Ast/shrinkify.scm 39 */
obj_t BgL_arg3569z00_1511;
{ /* ./Ast/shrinkify.scm 39 */
BgL_objectz00_bglt BgL_objectz00_3035;
BgL_objectz00_3035 = 
(BgL_objectz00_bglt)(BgL_variablez00_3); 
{ /* ./Ast/shrinkify.scm 39 */
long BgL_arg2007z00_3036;
{ /* ./Ast/shrinkify.scm 39 */
long BgL_arg2010z00_3037;
BgL_arg2010z00_3037 = 
BGL_OBJECT_CLASS_NUM(BgL_objectz00_3035); 
BgL_arg2007z00_3036 = 
(BgL_arg2010z00_3037-OBJECT_TYPE); } 
{ /* ./Ast/shrinkify.scm 39 */
obj_t BgL_vectorz00_3041;int BgL_kz00_3042;
BgL_vectorz00_3041 = BGl_za2classesza2z00zz__objectz00; 
BgL_kz00_3042 = 
(int)(BgL_arg2007z00_3036); 
BgL_arg3569z00_1511 = 
VECTOR_REF(BgL_vectorz00_3041,BgL_kz00_3042); } } } 
BgL_arg3566z00_1510 = 
BGl_classzd2superzd2zz__objectz00(BgL_arg3569z00_1511); } 
BgL_arg3563z00_1509 = 
BGl_classzd2numzd2zz__objectz00(BgL_arg3566z00_1510); } 
{ /* ./Ast/shrinkify.scm 39 */
BgL_objectz00_bglt BgL_objz00_3043;
BgL_objz00_3043 = 
(BgL_objectz00_bglt)(BgL_variablez00_3); 
BGL_OBJECT_CLASS_NUM_SET(BgL_objz00_3043, BgL_arg3563z00_1509); } } 
{ /* ./Ast/shrinkify.scm 39 */
BgL_objectz00_bglt BgL_auxz00_4250;
BgL_auxz00_4250 = 
(BgL_objectz00_bglt)(BgL_variablez00_3); 
BGL_OBJECT_WIDENING_SET(BgL_auxz00_4250, BFALSE); } 
(obj_t)(BgL_variablez00_3); }  else 
{ /* ./Ast/shrinkify.scm 38 */BFALSE; } } 
{ /* ./Ast/shrinkify.scm 40 */
bool_t BgL_test3574z00_1512;
{ /* ./Ast/shrinkify.scm 40 */
bool_t BgL_testz00_4254;
{ /* ./Ast/shrinkify.scm 40 */
obj_t BgL_auxz00_4255;
{ /* ./Ast/shrinkify.scm 40 */
BgL_objectz00_bglt BgL_auxz00_4256;
{ /* ./Ast/shrinkify.scm 40 */
BgL_valuez00_bglt BgL_auxz00_4257;
BgL_auxz00_4257 = 
(((BgL_variablez00_bglt)CREF(BgL_variablez00_3))->BgL_valuez00); 
BgL_auxz00_4256 = 
(BgL_objectz00_bglt)(BgL_auxz00_4257); } 
BgL_auxz00_4255 = 
BGL_OBJECT_WIDENING(BgL_auxz00_4256); } 
BgL_testz00_4254 = 
CBOOL(BgL_auxz00_4255); } 
if(BgL_testz00_4254)
{ /* ./Ast/shrinkify.scm 40 */
BgL_test3574z00_1512 = ((bool_t)1); }  else 
{ /* ./Ast/shrinkify.scm 40 */
BgL_test3574z00_1512 = ((bool_t)0); } } 
if(BgL_test3574z00_1512)
{ /* ./Ast/shrinkify.scm 41 */
BgL_valuez00_bglt BgL_o2660z00_1513;
BgL_o2660z00_1513 = 
(((BgL_variablez00_bglt)CREF(BgL_variablez00_3))->BgL_valuez00); 
{ /* ./Ast/shrinkify.scm 41 */
long BgL_arg3576z00_1514;
{ /* ./Ast/shrinkify.scm 41 */
obj_t BgL_arg3579z00_1515;
{ /* ./Ast/shrinkify.scm 41 */
obj_t BgL_arg3582z00_1516;
{ /* ./Ast/shrinkify.scm 41 */
BgL_objectz00_bglt BgL_objectz00_3050;
BgL_objectz00_3050 = 
(BgL_objectz00_bglt)(BgL_o2660z00_1513); 
{ /* ./Ast/shrinkify.scm 41 */
long BgL_arg2007z00_3051;
{ /* ./Ast/shrinkify.scm 41 */
long BgL_arg2010z00_3052;
BgL_arg2010z00_3052 = 
BGL_OBJECT_CLASS_NUM(BgL_objectz00_3050); 
BgL_arg2007z00_3051 = 
(BgL_arg2010z00_3052-OBJECT_TYPE); } 
{ /* ./Ast/shrinkify.scm 41 */
obj_t BgL_vectorz00_3056;int BgL_kz00_3057;
BgL_vectorz00_3056 = BGl_za2classesza2z00zz__objectz00; 
BgL_kz00_3057 = 
(int)(BgL_arg2007z00_3051); 
BgL_arg3582z00_1516 = 
VECTOR_REF(BgL_vectorz00_3056,BgL_kz00_3057); } } } 
BgL_arg3579z00_1515 = 
BGl_classzd2superzd2zz__objectz00(BgL_arg3582z00_1516); } 
BgL_arg3576z00_1514 = 
BGl_classzd2numzd2zz__objectz00(BgL_arg3579z00_1515); } 
{ /* ./Ast/shrinkify.scm 41 */
BgL_objectz00_bglt BgL_objz00_3058;
BgL_objz00_3058 = 
(BgL_objectz00_bglt)(BgL_o2660z00_1513); 
BGL_OBJECT_CLASS_NUM_SET(BgL_objz00_3058, BgL_arg3576z00_1514); } } 
{ /* ./Ast/shrinkify.scm 41 */
BgL_objectz00_bglt BgL_auxz00_4273;
BgL_auxz00_4273 = 
(BgL_objectz00_bglt)(BgL_o2660z00_1513); 
BGL_OBJECT_WIDENING_SET(BgL_auxz00_4273, BFALSE); } 
return 
(obj_t)(BgL_o2660z00_1513);}  else 
{ /* ./Ast/shrinkify.scm 40 */
return BFALSE;} } } 
}



/* _shrink-variable!-default2684 */
obj_t BGl__shrinkzd2variablez12zd2default2684z12zzast_shrinkifyz00(obj_t BgL_envz00_3154, obj_t BgL_variablez00_3155)
{ AN_OBJECT;
{ /* ./Ast/shrinkify.scm 15 */
return 
BGl_shrinkzd2variablez12zd2default2684z12zzast_shrinkifyz00(
(BgL_variablez00_bglt)(BgL_variablez00_3155));} 
}



/* shrink-node! */
obj_t BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(BgL_nodez00_bglt BgL_nodez00_4)
{ AN_OBJECT;
{ /* ./Ast/shrinkify.scm 46 */
{ /* ./Ast/shrinkify.scm 46 */
obj_t BgL_method2689z00_3060;
{ /* ./Ast/shrinkify.scm 46 */
BgL_objectz00_bglt BgL_objz00_3061;
BgL_objz00_3061 = 
(BgL_objectz00_bglt)(BgL_nodez00_4); 
{ /* ./Ast/shrinkify.scm 46 */
long BgL_objzd2classzd2numz00_3062;
BgL_objzd2classzd2numz00_3062 = 
BGL_OBJECT_CLASS_NUM(BgL_objz00_3061); 
{ /* ./Ast/shrinkify.scm 46 */
obj_t BgL_arg1989z00_3063;
{ /* ./Ast/shrinkify.scm 46 */
int BgL_auxz00_4281;
BgL_auxz00_4281 = 
(int)(((long)1)); 
BgL_arg1989z00_3063 = 
PROCEDURE_REF(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00, BgL_auxz00_4281); } 
{ /* ./Ast/shrinkify.scm 46 */
int BgL_offsetz00_3066;
BgL_offsetz00_3066 = 
(int)(BgL_objzd2classzd2numz00_3062); 
{ /* ./Ast/shrinkify.scm 46 */
long BgL_offsetz00_3067;
{ /* ./Ast/shrinkify.scm 46 */
long BgL_auxz00_4285;
BgL_auxz00_4285 = 
(long)(BgL_offsetz00_3066); 
BgL_offsetz00_3067 = 
(BgL_auxz00_4285-OBJECT_TYPE); } 
{ /* ./Ast/shrinkify.scm 46 */
long BgL_modz00_3068;
{ /* ./Ast/shrinkify.scm 46 */
int BgL_arg2000z00_3069;
BgL_arg2000z00_3069 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 46 */
long BgL_n2z00_3077;
BgL_n2z00_3077 = 
(long)(BgL_arg2000z00_3069); 
BgL_modz00_3068 = 
(BgL_offsetz00_3067/BgL_n2z00_3077); } } 
{ /* ./Ast/shrinkify.scm 46 */
long BgL_restz00_3070;
{ /* ./Ast/shrinkify.scm 46 */
int BgL_arg1996z00_3071;
BgL_arg1996z00_3071 = 
(int)(((long)8)); 
{ /* ./Ast/shrinkify.scm 46 */
long BgL_n2z00_3080;
BgL_n2z00_3080 = 
(long)(BgL_arg1996z00_3071); 
BgL_restz00_3070 = 
(BgL_offsetz00_3067%BgL_n2z00_3080); } } 
{ /* ./Ast/shrinkify.scm 46 */

{ /* ./Ast/shrinkify.scm 46 */
obj_t BgL_bucketz00_3072;
{ /* ./Ast/shrinkify.scm 46 */
int BgL_kz00_3082;
BgL_kz00_3082 = 
(int)(BgL_modz00_3068); 
BgL_bucketz00_3072 = 
VECTOR_REF(BgL_arg1989z00_3063,BgL_kz00_3082); } 
{ /* ./Ast/shrinkify.scm 46 */
int BgL_kz00_3084;
BgL_kz00_3084 = 
(int)(BgL_restz00_3070); 
BgL_method2689z00_3060 = 
VECTOR_REF(BgL_bucketz00_3072,BgL_kz00_3084); } } } } } } } } } } 
{ /* ./Ast/shrinkify.scm 46 */
obj_t BgL_xz00_3186;
BgL_xz00_3186 = 
PROCEDURE_ENTRY(BgL_method2689z00_3060)(BgL_method2689z00_3060, 
(obj_t)(BgL_nodez00_4), BEOA); 
return BUNSPEC;} } } 
}



/* _shrink-node!3706 */
obj_t BGl__shrinkzd2nodez123706zc0zzast_shrinkifyz00(obj_t BgL_envz00_3092, obj_t BgL_nodez00_3093)
{ AN_OBJECT;
{ /* ./Ast/shrinkify.scm 46 */
return 
BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
(BgL_nodez00_bglt)(BgL_nodez00_3093));} 
}



/* shrink-node!-default2688 */
obj_t BGl_shrinkzd2nodez12zd2default2688z12zzast_shrinkifyz00(BgL_nodez00_bglt BgL_nodez00_5)
{ AN_OBJECT;
{ /* ./Ast/shrinkify.scm 15 */
{ /* ./Ast/shrinkify.scm 15 */
obj_t BgL_procz00_3085;obj_t BgL_objectz00_3087;
BgL_procz00_3085 = 
CNST_TABLE_REF(((long)0)); 
BgL_objectz00_3087 = 
(obj_t)(BgL_nodez00_5); 
FAILURE(BgL_procz00_3085,BGl_string4273z00zzast_shrinkifyz00,BgL_objectz00_3087);} } 
}



/* _shrink-node!-default2688 */
obj_t BGl__shrinkzd2nodez12zd2default2688z12zzast_shrinkifyz00(obj_t BgL_envz00_3156, obj_t BgL_nodez00_3157)
{ AN_OBJECT;
{ /* ./Ast/shrinkify.scm 15 */
return 
BGl_shrinkzd2nodez12zd2default2688z12zzast_shrinkifyz00(
(BgL_nodez00_bglt)(BgL_nodez00_3157));} 
}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zzast_shrinkifyz00()
{ AN_OBJECT;
{ /* ./Ast/shrinkify.scm 15 */
BGl_modulezd2initializa7ationz75zztype_typez00(((long)19090), "ast_shrinkify"); 
BGl_modulezd2initializa7ationz75zzast_varz00(((long)28323), "ast_shrinkify"); 
BGl_modulezd2initializa7ationz75zzast_nodez00(((long)50868), "ast_shrinkify"); 
return 
BGl_modulezd2initializa7ationz75zzast_envz00(((long)62031), "ast_shrinkify");} 
}

